cpp = {}

require("eu_sci")

function cpp.get_styles()
  local style_t = {
    -- [SCE_C_COMMENT] = 0x008000,
    -- [SCE_C_COMMENTLINE] = 0x008000,
    -- [SCE_C_WORD] = 0x0000FF,
    -- [SCE_C_WORD2] = 0x0000FF,
    -- [SCE_C_GLOBALCLASS] = 0x800000,
    -- [SCE_C_STRING] = 0x008000,
    -- [SCE_C_NUMBER] = 0xFF0000,
    -- [SCE_C_OPERATOR] = 0xB000B0,
    -- [SCE_C_PREPROCESSOR] = 0xFF8000,
    -- [SCE_C_PREPROCESSORCOMMENT] = 0xFF8000,
    -- [SCE_C_PREPROCESSORCOMMENTDOC] = 0xFF8000,
    -- [SCE_C_TRIPLEVERBATIM] = 0xB000B0,
    -- [SCE_C_VERBATIM] = 0xB000B0,
    -- [SCE_C_COMMENTDOC] = 0x808080,
    -- [SCE_C_COMMENTLINEDOC] = 0x808080,
    -- [SCE_C_COMMENTDOCKEYWORD] = 0x808080,
    -- [SCE_C_COMMENTDOCKEYWORDERROR] = 0x800000,
    -- [SCE_C_TASKMARKER] = 0x208080,
  }
  return style_t
end

function cpp.get_keywords()
  local keywords0_set = "__asm __based __cdecl __declspec __except __far __fastcall __finally __fortran __huge __inline __int16 __int32 __int64 __int8 __interrupt __leave __loadds __near __pascal __saveregs __segment __segname __self __stdcall __try __uuidof auto bool break case char const continue default defined do double else enum extern for goto return if int long float register short signed sizeof static struct switch typedef union unsigned void volatile while __multiple_inheritance __single_inheritance __virtual_inheritance catch class const_cast delete dynamic_cast explicit export false friend inline __inline__ __inline __auto_type auto char8_t char16_t char32_t wchar_t nullptr_t nothrow_t _Bool complex _Complex _Imaginary imaginary __w64 __wchar_t __int8 __int16 __int32 __int64 __m64 __m128 __m128d __m128i __m256 __m256d __m256i __m512 __m512d __m512i __mmask8 __mmask16 __mmask32 __mmask64 __int3264 __ptr32 __ptr64 __sptr __uptr __int128 __float80 __float128 __fp16 __complex__ __real__ __imag__ __complex128 _Decimal32 _Decimal64 _Decimal128 decimal32 decimal64 decimal128 int128 qfloat errno_t fenv_t femode_t fexcept_t imaxdiv_t float_t double_t jmp_buf sigjmp_buf sig_atomic_t sigset_t pid_t va_list atomic_flag atomic_bool atomic_char atomic_schar atomic_uchar atomic_short atomic_ushort atomic_int atomic_uint atomic_long atomic_ulong atomic_llong atomic_ullong atomic_char16_t atomic_char32_t atomic_wchar_t atomic_intptr_t atomic_uintptr_t atomic_size_t atomic_ptrdiff_t atomic_intmax_t atomic_uintmax_t size_t rsize_t ptrdiff_t max_align_t int8_t int16_t int32_t int64_t uint8_t uint16_t uint32_t uint64_t intptr_t uintptr_t intmax_t uintmax_t ssize_t locale_t FILE fpos_t off_t div_t ldiv_t lldiv_t cnd_t thrd_t tss_t mtx_t tss_dtor_t thrd_start_t once_flag clock_t time_t wint_t mbstate_t wctrans_t wctype_t stdin stdout stderr sptr_t mutable namespace new operator private protected public reinterpret_cast static_cast template this throw true try typeid typename using virtual wchar_t dllexport dllimport naked thread uuid pascal"
  local keywords1_set = "a64l abort abs asprintf __asprintf atexit atof atoi atol atoll at_quick_exit available basename bcmp bcopy bsearch __builtin_alloca __builtin_index __builtin_memchr __builtin_rindex __builtin_strchr __builtin_strpbrk __builtin_strrchr __builtin_strstr bzero __bzero calloc canonicalize_file_name cfree clearenv clearerr clearerr_unlocked Copyright ctermid __ctype_get_mb_cur_max cuserid div dprintf drand48 drand48_r ecvt ecvt_r erand48 erand48_r exit __extension__ fclose fcloseall fcvt fcvt_r fdopen feof feof_unlocked ferror ferror_unlocked fflush fflush_unlocked ffs ffsl ffsll fgetc fgetc_unlocked fgetpos fgetpos64 fgets fgets_unlocked fileno fileno_unlocked flockfile fmemopen fopen fopen64 fopencookie __format__ fprintf fputc fputc_unlocked fputs fputs_unlocked fread fread_unlocked free freopen freopen64 fscanf fseek _fseeki64 fseeko fseeko64 fsetpos fsetpos64 ftell ftello ftello64 ftrylockfile funlockfile fwrite fwrite_unlocked gcvt getc getchar getchar_unlocked getc_unlocked getdelim __getdelim getenv getline getloadavg getpt gets getsubopt getw grantpt if index initstate initstate_r _IO_getc _IO_putc __isoc99_fscanf __isoc99_scanf __isoc99_sscanf __isoc99_vfscanf __isoc99_vscanf __isoc99_vsscanf jrand48 jrand48_r l64a labs lcong48 lcong48_r ldiv llabs lldiv lrand48 lrand48_r malloc mblen mbstowcs mbtowc memccpy memchr memcmp memcpy memfrob memmem memmove mempcpy __mempcpy memrchr memset mkdtemp mkostemp mkostemp64 mkostemps mkostemps64 mkstemp mkstemp64 mkstemps mkstemps64 mktemp mrand48 mrand48_r nrand48 nrand48_r obstack_printf obstack_vprintf on_exit open_memstream optimizations or pclose perror popen posix_memalign posix_openpt printf ptsname ptsname_r putc putchar putchar_unlocked putc_unlocked putenv puts putw qecvt qecvt_r qfcvt qfcvt_r qgcvt qsort qsort_r quick_exit rand random random_r rand_r rawmemchr read realloc realpath remove rename renameat return rewind rindex rpmatch S S2 scanf __secure_getenv seed48 seed48_r setbuf setbuffer setenv setkey setlinebuf setstate setstate_r setvbuf snprintf sprintf srand srand48 srand48_r srandom srandom_r sscanf standard stpcpy __stpcpy stpncpy __stpncpy strcasecmp strcasecmp_l strcasestr strcat strchr strchrnul strcmp strcoll strcoll_l strcpy strcspn strdup strdupa strerror strerror_l strerror_r strfry strlen strncasecmp strncasecmp_l strncat strncmp strncpy strndup strndupa strnlen strpbrk strrchr strsep strsignal strspn strstr strtod strtod_l strtof strtof_l strtok __strtok_r strtok_r strtol strtold strtold_l strtoll strtol_l strtoll_l strtoq strtoul strtoull strtoul_l strtoull_l strtouq strverscmp strxfrm strxfrm_l system tempnam tmpfile tmpfile64 tmpnam tmpnam_r to __typeof ungetc unlockpt unsetenv valloc vasprintf vdprintf vfprintf vfscanf void vprintf vscanf vsnprintf vsprintf vsscanf wcstombs wctomb word written  __xpg_strerror_r"
  local keywords2_set = "if elif else endif ifdef elifdef ifndef elifndef define undef include include_next import using pragma line error warning warn message region endregion sccs ident assert unassert"
  local keywords3_set = "_T TEXT VOID PVOID LPVOID LPCVOID BOOL PBOOL LPBOOL BOOLEAN PBOOLEAN BYTE PBYTE LPBYTE WORD PWORD LPWORD ATOM DWORD PDWORD LPDWORD UCHAR PUCHAR SHORT PSHORT USHORT PUSHORT INT PINT LPINT UINT PUINT LONG PLONG LPLONG ULONG PULONG FLOAT PFLOAT LONGLONG PLONGLONG ULONGLONG PULONGLONG DWORDLONG PDWORDLONG LARGE_INTEGER PLARGE_INTEGER ULARGE_INTEGER PULARGE_INTEGER FLOAT128 PFLOAT128 M128A PM128A LONG64 PLONG64 ULONG64 PULONG64 DWORD64 PDWORD64 LONG32 PLONG32 ULONG32 PULONG32 DWORD32 PDWORD32 DWORD_PTR PDWORD_PTR SHANDLE_PTR HANDLE_PTR UHALF_PTR PUHALF_PTR HALF_PTR PHALF_PTR INT_PTR PINT_PTR UINT_PTR PUINT_PTR LONG_PTR PLONG_PTR ULONG_PTR PULONG_PTR INT8 INT16 INT32 INT64 UINT8 UINT16 UINT32 UINT64 PINT8 PINT16 PINT32 PINT64 PUINT8 PUINT16 PUINT32 PUINT64 CHAR LPSTR LPCSTR WCHAR LPWSTR LPCWSTR TCHAR LPTSTR LPCTSTR WPARAM LPARAM LRESULT HRESULT HANDLE PHANDLE HGLOBAL HLOCAL HINSTANCE HMODULE HWND HHOOK HEVENT HGDIOBJ HKEY HACCEL HBITMAP HBRUSH HCOLORSPACE HDC HGLRC HDESK HENHMETAFILE HFONT HICON HMENU HMETAFILE HPALETTE HPEN HRGN HRSRC HSPRITE HLSURF HSTR HTASK HWINSTA HKL HWINEVENTHOOK HMONITOR HUMPD HFILE HCURSOR HDWP HINTERNET PHKEY MSG LPMSG NMHDR LPNMHDR LCID PLCID LANGID PSID SID PISID LUID PLUID ACL PACL LGRPID LCTYPE CALTYPE CALID CPINFO LPCPINFO GEOID GEOTYPE GEOCLASS XFORM LPXFORM CONTEXT PCONTEXT ACCESS_MASK KSPIN_LOCK SIZE_T PSIZE_T SSIZE_T PSSIZE_T RECT LPRECT RECTL LPRECTL POINT LPPOINT POINTL SIZE LPSIZE SIZEL LPSIZEL POINTS COLORREF LPCOLORREF RGBQUAD LPRGBQUAD BITMAP LPBITMAP FILETIME LPFILETIME SYSTEMTIME LPSYSTEMTIME GUID LPGUID LPCGUID IID LPIID CLSID LPCLSID FMTID LPFMTID REFGUID REFIID REFCLSID REFFMTID WNDCLASS WNDCLASSEX LOGFONT LOGBRUSH VARIANT"
  return keywords0_set,keywords1_set,keywords2_set,keywords3_set
end

function cpp.get_autocomplete()
  local autocomplete_set = "define elif else endif error ifdef ifndef include include_next line pragma undef __asm __based __cdecl __declspec __except __far __fastcall __finally __fortran __huge __inline __int16 __int32 __int64 __int8 __interrupt __leave __loadds __near __pascal __saveregs __segment __segname __self __stdcall __try __uuidof auto bool break case char const continue default defined do double else enum extern for goto return if int long float register short signed sizeof static struct switch typedef union unsigned void volatile while __multiple_inheritance __single_inheritance __virtual_inheritance catch class const_cast delete dynamic_cast explicit export false friend inline __inline__ __inline __auto_type auto char8_t char16_t char32_t wchar_t nullptr_t nothrow_t _Bool complex _Complex _Imaginary imaginary __w64 __wchar_t __int8 __int16 __int32 __int64 __m64 __m128 __m128d __m128i __m256 __m256d __m256i __m512 __m512d __m512i __mmask8 __mmask16 __mmask32 __mmask64 __int3264 __ptr32 __ptr64 __sptr __uptr __int128 __float80 __float128 __fp16 __complex__ __real__ __imag__ __complex128 _Decimal32 _Decimal64 _Decimal128 decimal32 decimal64 decimal128 int128 qfloat errno_t fenv_t femode_t fexcept_t imaxdiv_t float_t double_t jmp_buf sigjmp_buf sig_atomic_t sigset_t pid_t va_list atomic_flag atomic_bool atomic_char atomic_schar atomic_uchar atomic_short atomic_ushort atomic_int atomic_uint atomic_long atomic_ulong atomic_llong atomic_ullong atomic_char16_t atomic_char32_t atomic_wchar_t atomic_intptr_t atomic_uintptr_t atomic_size_t atomic_ptrdiff_t atomic_intmax_t atomic_uintmax_t size_t rsize_t ptrdiff_t max_align_t int8_t int16_t int32_t int64_t uint8_t uint16_t uint32_t uint64_t intptr_t uintptr_t intmax_t uintmax_t ssize_t locale_t FILE fpos_t off_t div_t ldiv_t lldiv_t cnd_t thrd_t tss_t mtx_t tss_dtor_t thrd_start_t once_flag clock_t time_t wint_t mbstate_t wctrans_t wctype_t byte sptr_t _T TEXT TCHAR mutable namespace new operator private protected public reinterpret_cast static_cast template this throw true try typeid typename using virtual wchar_t dllexport dllimport naked thread uuid a64l abort abs asprintf __asprintf atexit atof atoi atol atoll at_quick_exit available basename bcmp bcopy bsearch __builtin_alloca __builtin_index __builtin_memchr __builtin_rindex __builtin_strchr __builtin_strpbrk __builtin_strrchr __builtin_strstr bzero __bzero calloc canonicalize_file_name cfree clearenv clearerr clearerr_unlocked Copyright ctermid __ctype_get_mb_cur_max cuserid DEST div dprintf drand48 drand48_r ecvt ecvt_r EOF erand48 erand48_r exit _Exit __extension__ fclose fcloseall fcvt fcvt_r fdopen feof feof_unlocked ferror ferror_unlocked fflush fflush_unlocked ffs ffsl ffsll fgetc fgetc_unlocked fgetpos fgetpos64 fgets fgets_unlocked fileno fileno_unlocked flockfile fmemopen fopen fopen64 fopencookie __format__ fprintf fputc fputc_unlocked fputs fputs_unlocked fread fread_unlocked free freopen freopen64 fscanf fseek _fseeki64 fseeko fseeko64 fsetpos fsetpos64 ftell ftello ftello64 ftrylockfile funlockfile fwrite fwrite_unlocked gcvt getc getchar getchar_unlocked getc_unlocked getdelim __getdelim getenv getline getloadavg getpt gets getsubopt getw __GNUC_PREREQ grantpt if index initstate initstate_r _IO_getc _IO_putc __isoc99_fscanf __isoc99_scanf __isoc99_sscanf __isoc99_vfscanf __isoc99_vscanf __isoc99_vsscanf jrand48 jrand48_r l64a labs lcong48 lcong48_r ldiv llabs lldiv lrand48 lrand48_r malloc mblen mbstowcs mbtowc memccpy memchr memcmp memcpy memfrob memmem memmove mempcpy __mempcpy memrchr memset mkdtemp mkostemp mkostemp64 mkostemps mkostemps64 mkstemp mkstemp64 mkstemps mkstemps64 mktemp mrand48 mrand48_r nrand48 nrand48_r __NTH obstack_printf obstack_vprintf on_exit open_memstream optimizations or pclose perror popen posix_memalign posix_openpt printf ptsname ptsname_r putc putchar putchar_unlocked putc_unlocked putenv puts putw qecvt qecvt_r qfcvt qfcvt_r qgcvt qsort qsort_r quick_exit rand random random_r rand_r rawmemchr read realloc realpath remove rename renameat return rewind rindex rpmatch S S2 scanf __secure_getenv seed48 seed48_r setbuf setbuffer setenv setkey setlinebuf setstate setstate_r setvbuf snprintf sprintf srand srand48 srand48_r srandom srandom_r sscanf standard stpcpy __stpcpy stpncpy __stpncpy strcasecmp strcasecmp_l strcasestr strcat strchr strchrnul strcmp strcoll strcoll_l strcpy strcspn strdup strdupa strerror strerror_l strerror_r strfry strlen strncasecmp strncasecmp_l strncat strncmp strncpy strndup strndupa strnlen strpbrk strrchr strsep strsignal strspn strstr strtod strtod_l strtof strtof_l strtok __strtok_r strtok_r strtol strtold strtold_l strtoll strtol_l strtoll_l strtoq strtoul strtoull strtoul_l strtoull_l strtouq strverscmp strxfrm strxfrm_l system tempnam tmpfile tmpfile64 tmpnam tmpnam_r to __typeof ungetc unlockpt unsetenv __USING_NAMESPACE_STD valloc vasprintf vdprintf vfprintf vfscanf void vprintf vscanf vsnprintf vsprintf vsscanf __WAIT_INT wcstombs wctomb WEXITSTATUS __WEXITSTATUS WIFCONTINUED __WIFCONTINUED WIFEXITED __WIFEXITED WIFSIGNALED __WIFSIGNALED WIFSTOPPED __WIFSTOPPED word written WSTOPSIG __WSTOPSIG WTERMSIG __WTERMSIG __xpg_strerror_r _hread _hwrite _lclose _lcreat _llseek _lopen _lread _lwrite AbnormalTermination AbortDoc AbortPath AbortPrinter AbortProc AbortSystemShutdown AccessCheck AccessCheckAndAuditAlarm AcsLan ActivateKeyboardLayout AddAccessAllowedAce AddAccessDeniedAce AddAce AddAtom AddAuditAccessAce AddFontResource AddForm AddJob AddMonitor AddPort AddPrinter AddPrinterConnection AddPrinterDriver AddPrintProcessor AddPrintProvidor AddPropSheetPageProc AdjustTokenGroups AdjustTokenPrivileges AdjustWindowRect AdjustWindowRectEx AdvancedDocumentProperties AllocateAndInitializeSid AllocateLocallyUniqueId AllocConsole AngleArc AnimatePalette AnsiLower AnsiLowerBuff AnsiNext AnsiPrev AnsiToOem AnsiToOemBuff AnsiUpper AnsiUpperBuff AnyPopup AppendMenu Arc ArcTo AreAllAccessesGranted AreAnyAccessesGranted AreFileApisANSI ArrangeIconicWindows AttachThreadInput BackupEventLog BackupRead BackupSeek BackupWrite Beep BeginDeferWindowPos BeginPaint BeginPath BeginUpdateResource BitBlt BringWindowToTop BroadcastSystemMessage BrowseCallbackProc BuildCommDCB BuildCommDCBAndTimeouts BuildExplicitAccessWithName BuildImpersonateExplicitAccessWithName BuildImpersonateTrustee BuildSecurityDescriptor BuildTrusteeWithName BuildTrusteeWithSid CallMsgFilter CallNamedPipe CallNextHookEx CallWindowProc CallWndProc CallWndRetProc CancelDC CancelIO CancelWaitableTimer CascadeWindows CBTProc CCHookProc CFHookProc ChangeClipboardChain ChangeDisplaySettings ChangeMenu ChangeServiceConfig CharLower CharLowerBuff CharNext CharNextExA CharPrev CharPrevExA CharToOem CharToOemBuff CharUpper CharUpperBuff CheckColorsInGamut CheckDlgButton CheckMenuItem CheckMenuRadioItem CheckRadioButton ChildWindowFromPoint ChildWindowFromPointEx ChooseColor ChooseFont ClearCommBreak ClearCommError ClearEventLog ClientToScreen ClipCursor CloseClipboard CloseDesktop CloseEnhMetaFile CloseEventLog CloseFigure CloseHandle CloseMetaFile ClosePrinter CloseServiceHandle CloseWindow CloseWindowStation ColorMatchToTarget CombineRgn CombineTransform CommandLineToArgvW CommConfigDialog CommDlgExtendedError CompareFileTime CompareString ConfigurePort ConnectNamedPipe ConnectToPrinterDlg ContinueDebugEvent ControlService ConvertDefaultLocale ConvertThreadToFiber CopyAcceleratorTable CopyCursor CopyEnhMetaFile CopyFile CopyFileEx CopyIcon CopyImage CopyLZFile CopyMemory CopyMetaFile CopyProgressRoutine CopyRect CopySid CountClipboardFormats CPlApplet CreateAcceleratorTable CreateBitmap CreateBitmapIndirect CreateBrushIndirect CreateCaret CreateColorSpace CreateCompatibleBitmap CreateCompatibleDC CreateConsoleScreenBuffer CreateCursor CreateDC CreateDesktop CreateDialog CreateDialogIndirect CreateDialogIndirectParam CreateDialogParam CreateDIBitmap CreateDIBPatternBrush CreateDIBPatternBrushPt CreateDIBSection CreateDirectory CreateDirectoryEx CreateDiscardableBitmap CreateEllipticRgn CreateEllipticRgnIndirect CreateEnhMetaFile CreateEvent CreateFiber CreateFile CreateFileMapping CreateFont CreateFontIndirect CreateHalftonePalette CreateHatchBrush CreateIC CreateIcon CreateIconFromResource CreateIconFromResourceEx CreateIconIndirect CreateIoCompletionPort CreateMailslot CreateMappedBitmap CreateMenu CreateMetaFile CreateMutex CreateNamedPipe CreatePalette CreatePatternBrush CreatePen CreatePenIndirect CreatePipe CreatePolygonRgn CreatePolyPolygonRgn CreatePopupMenu CreatePrivateObjectSecurity CreateProcess CreateProcessAsUser CreatePropertySheetPage CreateRectRgn CreateRectRgnIndirect CreateRemoteThread CreateRoundRectRgn CreateScalableFontResource CreateSemaphore CreateService CreateSolidBrush CreateTapePartition CreateToolbarEx CreateThread CreateUpDownControl CreateWaitableTimer CreateWindow CreateWindowEx CreateWindowStation CryptAcquireContext CryptCreateHash CryptDecryp CryptDeriveKey CryptDestroyHash CryptDestroyKey CryptEncrypt CryptExportKey CryptGenKey CryptGenRandom CryptGetHashParam CryptGetKeyParam CryptGetProvParam CryptGetUserKey CryptHashData CryptHashSessionKey CryptImportKey CryptReleaseContext CryptSetHashParam CryptSetKeyParam CryptSetProvider CryptSetProvParam CryptSignHash CryptVerifySignature DdeAbandonTransaction DdeAccessData DdeAddData DdeCallback DdeClientTransaction DdeCmpStringHandles DdeConnect DdeConnectList DdeCreateDataHandle DdeCreateStringHandle DdeDisconnect DdeDisconnectList DdeEnableCallback DdeFreeDataHandle DdeFreeStringHandle DdeGetData DdeGetLastError DdeImpersonateClient DdeInitialize DdeKeepStringHandle DdeNameService DdePostAdvise DdeQueryConvInfo DdeQueryNextServer DdeQueryString DdeReconnect DdeSetQualityOfService DdeSetUserHandle DdeUnaccessData DdeUninitialize DebugActiveProcess DebugBreak DebugProc DefDlgProc DeferWindowPos DefFrameProc DefHookProc DefineDosDevice DefineHandleTable DefMDIChildProc DefScreenSaverProc DefWindowProc DeleteAce DeleteAtom DeleteColorSpace DeleteCriticalSection DeleteDC DeleteEnhMetaFile DeleteFiber DeleteFile DeleteForm DeleteMenu DeleteMetaFile DeleteMonitor DeleteObject DeletePort DeletePrinter DeletePrinterConnection DeletePrinterData DeletePrinterDriver DeletePrintProcessor DeletePrintProvidor DeleteService DeregisterEventSource DestroyAcceleratorTable DestroyCaret DestroyCursor DestroyIcon DestroyMenu DestroyPrivateObjectSecurity DestroyPropertySheetPage DestroyWindow DeviceCapabilities DeviceIoControl DialogBox DialogBoxIndirect DialogBoxIndirectParam DialogBoxParam DialogProc DisableThreadLibraryCalls DisconnectNamedPipe DispatchMessage DlgDirList DlgDirListComboBox DlgDirSelectComboBoxEx DllEntryPoint DocumentProperties DosDateTimeToFileTime DPtoLP DragAcceptFiles DragDetect DragFinish DragQueryFile DragQueryPoint DrawAnimatedRects DrawCaption DrawEdge DrawEscape DrawFocusRect DrawFrameControl DrawIcon DrawIconEx DrawInsert DrawMenuBar DrawState DrawStateProc DrawStatusText DrawText DrawTextEx DuplicateHandle DuplicateToken DuplicateTokenEx EditWordBreakProc EditWordBreakProcEx Ellipse EmptyClipboard EnableEUDC EnableMenuItem EnableScrollBar EnableWindow EndDeferWindowPos EndDialog EndDoc EndDocPrinter EndPage EndPagePrinter EndPaint EndPath EndUpdateResource EnhMetaFileProc EnumCalendarInfo EnumChildProc EnumChildWindows EnumClipboardFormats EnumCodePagesProc EnumDateFormats EnumDateFormatsProc EnumDependentServices EnumDesktopProc EnumDesktops EnumDesktopWindows EnumDisplaySettings EnumEnhMetaFile EnumFontFamExProc EnumFontFamilies EnumFontFamiliesEx EnumFontFamProc EnumFonts EnumFontsProc EnumForms EnumICMProfiles EnumICMProfilesProc EnumJobs EnumLocalesProc EnumMetaFile EnumMetaFileProc EnumMonitors EnumObjects EnumObjectsProc EnumPorts EnumPrinterData EnumPrinterDrivers EnumPrinters EnumPrintProcessorDatatypes EnumPrintProcessors EnumProps EnumPropsEx EnumRegisterWordProc EnumResLangProc EnumResNameProc EnumResourceLanguages EnumResourceNames EnumResourceTypes EnumResTypeProc EnumServicesStatus EnumSystemCodePages EnumSystemLocales EnumTaskWindows EnumThreadWindows EnumThreadWndProc EnumTimeFormats EnumTimeFormatsProc EnumWindows EnumWindowsProc EnumWindowStationProc EnumWindowStations EqualPrefixSid EqualRect EqualRgn EqualSid EraseTape Escape EscapeCommFunction ExcludeClipRect ExcludeUpdateRgn ExitProcess ExitThread ExitWindows ExitWindowsEx ExpandEnvironmentStrings ExtCreatePen ExtensionPropSheetPageProc ExtEscape ExtFloodFill ExtractAssociatedIcon ExtractIcon ExtractIconEx ExtSelectClipRgn ExtTextOut FatalAppExit FatalExit FileIOCompletionRoutine FileTimeToDosDateTime FileTimeToLocalFileTime FileTimeToSystemTime FillConsoleOutputAttribute FillConsoleOutputCharacter FillMemory FillPath FillRect FillRgn FindAtom FindClose FindCloseChangeNotification FindClosePrinterChangeNotification FindExecutable FindFirstChangeNotification FindFirstFile FindFirstFileEx FindFirstFreeAce FindFirstPrinterChangeNotification FindNextChangeNotification FindNextFile FindNextPrinterChangeNotification FindResource FindResourceEx FindText FindWindow FindWindowEx FixBrushOrgEx FlashWindow FlattenPath FloodFill FlushConsoleInputBuffer FlushFileBuffers FlushInstructionCache FlushViewOfFile FMExtensionProc FoldString ForegroundIdleProc FormatMessage FrameRect FrameRgn FreeConsole FreeDDElParam FreeEnvironmentStrings FreeLibrary FreeLibraryAndExitThread FreeModule FreePrinterNotifyInfo FreeProcInstance FreeResource FreeSid FRHookProc FSCTL_DISMOUNT_VOLUME FSCTL_GET_COMPRESSION FSCTL_LOCK_VOLUME FSCTL_SET_COMPRESSION FSCTL_UNLOCK_VOLUME GdiComment GdiFlush GdiGetBatchLimit GdiSetBatchLimit GenerateConsoleCtrlEvent GetAce GetAclInformation GetACP GetActiveWindow GetArcDirection GetAspectRatioFilterEx GetAsyncKeyState GetAtomName GetAuditedPermissionsFromAcl GetBinaryType GetBitmapBits GetBitmapDimensionEx GetBkColor GetBkMode GetBoundsRect GetBrushOrgEx GetCapture GetCaretBlinkTime GetCaretPos GetCharABCWidths GetCharABCWidthsFloat GetCharacterPlacement GetCharWidth GetCharWidth32 GetCharWidthFloat GetClassInfo GetClassInfoEx GetClassLong GetClassName GetClassWord GetClientRect GetClipboardData GetClipboardFormatName GetClipboardOwner GetClipboardViewer GetClipBox GetClipCursor GetClipRgn GetColorAdjustment GetColorSpace GetCommandLine GetCommConfig GetCommMask GetCommModemStatus GetCommProperties GetCommState GetCommTimeouts GetCompressedFileSize GetComputerName GetConsoleCP GetConsoleCursorInfo GetConsoleMode GetConsoleOutputCP GetConsoleScreenBufferInfo GetConsoleTitle GetCPInfo GetCurrencyFormat GetCurrentDirectory GetCurrentFiber GetCurrentHwProfile GetCurrentObject GetCurrentPositionEx GetCurrentProcess GetCurrentProcessId GetCurrentThread GetCurrentThreadId GetCurrentTime GetCursor GetCursorPos GetDateFormat GetDC GetDCEx GetDCOrgEx GetDefaultCommConfig GetDesktopWindow GetDeviceCaps GetDeviceGammaRamp GetDialogBaseUnits GetDIBits GetDiskFreeSpace GetDiskFreeSpaceEx GetDlgCtrlID GetDlgItem GetDlgItemInt GetDlgItemText GetDoubleClickTime GetDriveType GetEffectiveClientRect GetEffectiveRightsFromAcl GetEnhMetaFile GetEnhMetaFileBits GetEnhMetaFileDescription GetEnhMetaFileHeader GetEnhMetaFilePaletteEntries GetEnvironmentStrings GetEnvironmentVariable GetExceptionCode GetExceptionInformation GetExitCodeProcess GetExitCodeThread GetExpandedName GetExplicitEntriesFromAcl GetFiberData GetFileAttributes GetFileAttributesEx GetFileInformationByHandle GetFileSecurity GetFileSize GetFileTime GetFileTitle GetFileType GetFileVersionInfo GetFileVersionInfoSize GetFocus GetFontData GetFontLanguageInfo GetForegroundWindow GetForm GetFreeSpace GetFullPathName GetGlyphOutline GetGraphicsMode GetHandleInformation GetICMProfile GetIconInfo GetInputState GetJob GetKBCodePage GetKernelObjectSecurity GetKerningPairs GetKeyboardLayout GetKeyboardLayoutList GetKeyboardLayoutName GetKeyboardState GetKeyboardType GetKeyNameText GetKeyState GetLargestConsoleWindowSize GetLastActivePopup GetLastError GetLengthSid GetLocaleInfo GetLocalTime GetLogColorSpace GetLogicalDrives GetLogicalDriveStrings GetMailslotInfo GetMapMode GetMenu GetMenuCheckMarkDimensions GetMenuContextHelpId GetMenuDefaultItem GetMenuItemCount GetMenuItemID GetMenuItemInfo GetMenuItemRect GetMenuState GetMenuString GetMessage GetMessageExtraInfo GetMessagePos GetMessageTime GetMetaFile GetMetaFileBitsEx GetMetaRgn GetMiterLimit GetModuleFileName GetModuleHandle GetMsgProc GetMultipleTrustee GetMultipleTrusteeOperation GetNamedPipeHandleState GetNamedPipeInfo GetNamedSecurityInfo GetNearestColor GetNearestPaletteIndex GetNextDlgGroupItem GetNextDlgTabItem GetNextWindow GetNumberFormat GetNumberOfConsoleInputEvents GetNumberOfConsoleMouseButtons GetNumberOfEventLogRecords GetObject GetObjectType GetOEMCP GetOldestEventLogRecord GetOpenClipboardWindow GetOpenFileName GetOutlineTextMetrics GetOverlappedResult GetPaletteEntries GetParent GetPath GetPixel GetPolyFillMode GetPrinter GetPrinterData GetPrinterDriver GetPrinterDriverDirectory GetPrintProcessorDirectory GetPriorityClass GetPriorityClipboardFormat GetPrivateObjectSecurity GetPrivateProfileInt GetPrivateProfileSection GetPrivateProfileSectionNames GetPrivateProfileString GetPrivateProfileStruct GetProcAddress GetProcessAffinityMask GetProcessHeap GetProcessHeaps GetProcessPriorityBoost GetProcessShutdownParameters GetProcessTimes GetProcessVersion GetProcessWindowStation GetProcessWorkingSetSize GetProfileInt GetProfileSection GetProfileString GetProp GetQueuedCompletionStatus GetQueueStatus GetRasterizerCaps GetRegionData GetRgnBox GetROP2 GetSaveFileName GetScrollInfo GetScrollPos GetScrollRange GetSecurityDescriptorControl GetSecurityDescriptorDacl GetSecurityDescriptorGroup GetSecurityDescriptorLength GetSecurityDescriptorOwner GetSecurityDescriptorSacl GetSecurityInfo GetServiceDisplayName GetServiceKeyName GetShortPathName GetSidIdentifierAuthority GetSidLengthRequired GetSidSubAuthority GetSidSubAuthorityCount GetStartupInfo GetStdHandle GetStockObject GetStretchBltMode GetStringTypeA GetStringTypeEx GetStringTypeW GetSubMenu GetSysColor GetSysColorBrush GetSysModalWindow GetSystemDefaultLangID GetSystemDefaultLCID GetSystemDirectory GetSystemInfo GetSystemMenu GetSystemMetrics GetSystemPaletteEntries GetSystemPaletteUse GetSystemTime GetSystemTimeAdjustment GetSystemTimeAsFileTime GetTabbedTextExtent GetTapeParameters GetTapePosition GetTapeStatus GetTempFileName GetTempPath GetTextAlign GetTextCharacterExtra GetTextCharset GetTextCharsetInfo GetTextColor GetTextExtentExPoint GetTextExtentPoint GetTextExtentPoint32 GetTextFace GetTextMetrics GetThreadContext GetThreadDesktop GetThreadLocale GetThreadPriority GetThreadPriorityBoost GetThreadSelectorEntry GetThreadTimes GetTickCount GetTimeFormat GetTimeZoneInformation GetTokenInformation GetTopWindow GetTrusteeForm GetTrusteeName GetTrusteeType GetUpdateRect GetUpdateRgn GetUserDefaultLangID GetUserDefaultLCID GetUserName GetUserObjectInformation GetUserObjectSecurity GetVersion GetVersionEx GetViewportExtEx GetViewportOrgEx GetVolumeInformation GetWindow GetWindowContextHelpId GetWindowDC GetWindowExtEx GetWindowLong GetWindowOrgEx GetWindowPlacement GetWindowRect GetWindowRgn GetWindowsDirectory GetWindowTask GetWindowText GetWindowTextLength GetWindowThreadProcessId GetWindowWord GetWinMetaFileBits GetWorldTransform GlobalAddAtom GlobalAlloc GlobalCompact GlobalDeleteAtom GlobalDiscard GlobalFindAtom GlobalFix GlobalFlags GlobalFree GlobalGetAtomName GlobalHandle GlobalLock GlobalLRUNewest GlobalLRUOldest GlobalMemoryStatus GlobalReAlloc GlobalSize GlobalUnfix GlobalUnlock GlobalUnWire GlobalWire GrayString HandlerRoutine HeapAlloc HeapCompact HeapCreate HeapDestroy HeapLock HeapReAlloc HeapSize HeapUnlock HeapValidate HeapWalk HideCaret HiliteMenuItem ImageList_Add ImageList_AddMasked ImageList_BeginDrag ImageList_Create ImageList_Destroy ImageList_DragEnter ImageList_DragLeave ImageList_DragMove ImageList_DragShowNolock ImageList_Draw ImageList_DrawEx ImageList_EndDrag ImageList_ExtractIcon ImageList_GetBkColor ImageList_GetDragImage ImageList_GetIcon ImageList_GetIconSize ImageList_GetImageCount ImageList_GetImageInfo ImageList_LoadBitmap ImageList_LoadImage ImageList_Merge ImageList_Read ImageList_Remove ImageList_Replace ImageList_ReplaceIcon ImageList_SetBkColor ImageList_SetDragCursorImage ImageList_SetIconSize ImageList_SetOverlayImage ImageList_Write ImmAssociateContext ImmConfigureIME ImmCreateContext ImmDestroyContext ImmEnumRegisterWord ImmEscape ImmGetCandidateList ImmGetCandidateListCount ImmGetCandidateWindow ImmGetCompositionFont ImmGetCompositionString ImmGetCompositionWindow ImmGetContext ImmGetConversionList ImmGetConversionStatus ImmGetDefaultIMEWnd ImmGetDescription ImmGetGuideLine ImmGetIMEFileName ImmGetOpenStatus ImmGetProperty ImmGetRegisterWordStyle ImmGetStatusWindowPos ImmGetVirtualKey ImmInstallIME ImmIsIME ImmIsUIMessage ImmNotifyIME ImmRegisterWord ImmReleaseContext ImmSetCandidateWindow ImmSetCompositionFont ImmSetCompositionString ImmSetCompositionWindow ImmSetConversionStatus ImmSetOpenStatus ImmSetStatusWindowPos ImmSimulateHotKey ImmUnregisterWord ImpersonateDdeClientWindow ImpersonateLoggedOnUser ImpersonateNamedPipeClient ImpersonateSelf InflateRect InitAtomTable InitCommonControls InitializeAcl InitializeCriticalSection InitializeSecurityDescriptor InitializeSid InitiateSystemShutdown InSendMessage InsertMenu InsertMenuItem Int32x32To64 Int64ShllMod32 Int64ShraMod32 Int64ShrlMod32 InterlockedCompareExchange InterlockedDecrement InterlockedExchange InterlockedExchangeAdd InterlockedIncrement IntersectClipRect IntersectRect InvalidateRect InvalidateRgn InvertRect InvertRgn IOCTL_DISK_CHECK_VERIFY IOCTL_DISK_EJECT_MEDIA IOCTL_DISK_FORMAT_TRACKS IOCTL_DISK_GET_DRIVE_GEOMETRY IOCTL_DISK_GET_DRIVE_LAYOUT IOCTL_DISK_GET_MEDIA_TYPES IOCTL_DISK_GET_PARTITION_INFO IOCTL_DISK_LOAD_MEDIA IOCTL_DISK_MEDIA_REMOVAL IOCTL_DISK_PERFORMANCE IOCTL_DISK_REASSIGN_BLOCKS IOCTL_DISK_SET_DRIVE_LAYOUT IOCTL_DISK_SET_PARTITION_INFO IOCTL_DISK_VERIFY IOCTL_SERIAL_LSRMST_INSERT IOCTL_STORAGE_CHECK_VERIFY IOCTL_STORAGE_EJECT_MEDIA IOCTL_STORAGE_GET_MEDIA_TYPES IOCTL_STORAGE_LOAD_MEDIA IOCTL_STORAGE_MEDIA_REMOVAL IsBadCodePtr IsBadHugeReadPtr IsBadHugeWritePtr IsBadReadPtr IsBadStringPtr IsBadWritePtr IsCharAlpha IsCharAlphaNumeric IsCharLower IsCharUpper IsChild IsClipboardFormatAvailable IsDBCSLeadByte IsDBCSLeadByteEx IsDebuggerPresent IsDialogMessage IsDlgButtonChecked IsIconic IsMenu IsProcessorFeaturePresent IsRectEmpty IsTextUnicode IsValidAcl IsValidCodePage IsValidLocale IsValidSecurityDescriptor IsValidSid IsWindow IsWindowEnabled IsWindowUnicode IsWindowVisible IsZoomed JournalPlaybackProc JournalRecordProc keybd_event KeyboardProc KillTimer LBItemFromPt LCMapString LeaveCriticalSection LimitEmsPages LineDDA LineDDAProc LineTo LoadAccelerators LoadBitmap LoadCursor LoadCursorFromFile LoadIcon LoadImage LoadKeyboardLayout LoadLibrary LoadLibraryEx LoadMenu LoadMenuIndirect LoadModule LoadResource LoadString LocalAlloc LocalCompact LocalDiscard LocalFileTimeToFileTime LocalFlags LocalFree LocalHandle LocalLock LocalReAlloc LocalShrink LocalSize LocalUnlock LockFile LockFileEx LockResource LockSegment LockServiceDatabase LockWindowUpdate LogonUser LookupAccountName LookupAccountSid LookupIconIdFromDirectory LookupIconIdFromDirectoryEx LookupPrivilegeDisplayName LookupPrivilegeName LookupPrivilegeValue LookupSecurityDescriptorParts LPtoDP LSEnumProviders LSFreeHandle LSGetMessage LSQuery LSRelease LSRequest LSUpdate lstrcat LSTRCMP LSTRCMPI lstrcpy lstrcpyn lstrlen LZClose LZCopy LZDone LZInit LZOpenFile LZRead LZSeek LZStart MakeAbsoluteSD MakeDragList MakeProcInstance MakeSelfRelativeSD MapDialogRect MapGenericMask MapViewOfFile MapViewOfFileEx MapVirtualKey MapVirtualKeyEx MapWindowPoints MenuHelp MenuItemFromPoint MessageBeep MessageBox MessageBoxEx MessageBoxIndirect MessageProc ModifyMenu ModifyWorldTransform mouse_event MouseProc MoveFile MoveFileEx MoveMemory MoveToEx MoveWindow MsgWaitForMultipleObjects MsgWaitForMultipleObjectsEx MulDiv MultiByteToWideChar MultinetGetConnectionPerformance NDdeGetErrorString NDdeGetShareSecurity NDdeGetTrustedShare NDdeIsValidAppTopicList NDdeIsValidShareName NDdeSetShareSecurity NDdeSetTrustedShare NDdeShareAdd NDdeShareDel NDdeShareEnum NDdeShareGetInfo NDdeShareSetInfo NDdeTrustedShareEnum NetAccessAdd NetAccessCheck NetAccessDel NetAccessEnum NetAccessGetInfo NetAccessGetUserPerms NetAccessSetInfo NetAlertRaise NetAlertRaiseEx NetApiBufferAllocate NetApiBufferFree NetApiBufferReallocate NetApiBufferSize NetAuditClear NetAuditRead Netbios NetConfigGet NetConfigGetAll NetConfigSet NetConnectionEnum NetErrorLogClear NetErrorLogRead NetFileClose NetFileEnum NetFileGetInfo NetGetAnyDCName NetGetDCName NetGetDisplayInformationIndex NetGroupAdd NetGroupAddUser NetGroupDel NetGroupDelUser NetGroupEnum NetGroupGetInfo NetGroupGetUsers NetGroupSetInfo NetGroupSetUsers NetHandleGetInfo NetHandleSetInfo NetLocalGroupAdd NetLocalGroupAddMember NetLocalGroupAddMembers NetLocalGroupDel NetLocalGroupDelMember NetLocalGroupDelMembers NetLocalGroupEnum NetLocalGroupGetInfo NetLocalGroupGetMembers NetLocalGroupSetInfo NetLocalGroupSetMembers NetMessageBufferSend NetMessageNameAdd NetMessageNameDel NetMessageNameEnum NetMessageNameGetInfo NetQueryDisplayInformation NetRemoteTOD NetReplExportDirAdd NetReplExportDirDel NetReplExportDirEnum NetReplExportDirGetInfo NetReplExportDirLock NetReplExportDirSetInfo NetReplExportDirUnlock NetReplGetInfo NetReplImportDirAdd NetReplImportDirDel NetReplImportDirEnum NetReplImportDirGetInfo NetReplImportDirLock NetReplImportDirUnlock NetReplSetInfo NetScheduleJobAdd NetScheduleJobDel NetScheduleJobEnum NetScheduleJobGetInfo NetServerDiskEnum NetServerEnum NetServerGetInfo NetServerSetInfo NetServerTransportAdd NetServerTransportDel NetServerTransportEnum NetServiceControl NetServiceEnum NetServiceGetInfo NetServiceInstall NetSessionDel NetSessionEnum NetSessionGetInfo NetShareAdd NetShareCheck NetShareDel NetShareEnum NetShareGetInfo NetShareSetInfo NetStatisticsGet NetStatisticsGet2 NetUseAdd NetUseDel NetUseEnum NetUseGetInfo NetUserAdd NetUserChangePassword NetUserDel NetUserEnum NetUserGetGroups NetUserGetInfo NetUserGetLocalGroups NetUserModalsGet NetUserModalsSet NetUserSetGroups NetUserSetInfo NetWkstaGetInfo NetWkstaSetInfo NetWkstaTransportAdd NetWkstaTransportDel NetWkstaTransportEnum NetWkstaUserEnum NetWkstaUserGetInfo NetWkstaUserSetInfo NotifyBootConfigStatus NotifyChangeEventLog ObjectCloseAuditAlarm ObjectDeleteAuditAlarm ObjectOpenAuditAlarm ObjectPrivilegeAuditAlarm OemKeyScan OemToAnsi OemToAnsiBuff OemToChar OemToCharBuff OffsetClipRgn OffsetRect OffsetRgn OffsetViewportOrgEx OffsetWindowOrgEx OFNHookProc OFNHookProcOldStyle OpenBackupEventLog OpenClipboard OpenDesktop OpenEvent OpenEventLog OpenFile OpenFileMapping OpenIcon OpenInputDesktop OpenMutex OpenPrinter OpenProcess OpenProcessToken OpenSCManager OpenSemaphore OpenService OpenThreadToken OpenWaitableTimer OpenWindowStation ORASADFunc OutputDebugString OutputProc PackDDElParam PagePaintHook PageSetupDlg PageSetupHook PaintDesktop PaintRgn PatBlt PathToRegion PeekConsoleInput PeekMessage PeekNamedPipe PlayEnhMetaFile PlayEnhMetaFileRecord PlayMetaFile PlayMetaFileRecord PlgBlt PolyBezier PolyBezierTo PolyDraw PolylineTo PolyPolygon PolyPolyline PolyTextOut PostAppMessage PostMessage PostQueuedCompletionStatus PostQuitMessage PostThreadMessage PrepareTape PrintDlg PrinterMessageBox PrinterProperties PrintHookProc PrivilegeCheck PrivilegedServiceAuditAlarm PropEnumProc PropEnumProcEx PropertySheet PropSheetPageProc PropSheetProc PtInRect PtInRegion PtVisible PulseEvent PurgeComm QueryDosDevice QueryPerformanceCounter QueryPerformanceFrequency QueryServiceConfig QueryServiceLockStatus QueryServiceObjectSecurity QueryServiceStatus QueueUserAPC RaiseException RASADFunc RasAdminAcceptNewConnection RasAdminConnectionHangupNotification RasAdminFreeBuffer RasAdminGetErrorString RasAdminGetIpAddressForUser RasAdminGetUserAccountServer RasAdminPortClearStatistics RasAdminPortDisconnect RasAdminPortEnum RasAdminPortGetInfo RasAdminReleaseIpAddress RasAdminServerGetInfo RasAdminUserGetInfo RasAdminUserSetInfo RasConnectionNotification RasCreatePhonebookEntry RasDeleteEntry RasDial RasDialDlg RasDialFunc RasDialFunc1 RasDialFunc2 RasEditPhonebookEntry RasEntryDlg RasEnumAutodialAddresses RasEnumConnections RasEnumDevices RasEnumEntries RasGetAutodialAddress RasGetAutodialEnable RasGetAutodialParam RasGetConnectStatus RasGetCountryInfo RasGetCredentials RasGetEntryDialParams RasGetEntryProperties RasGetErrorString RasGetProjectionInfo RasGetSubEntryHandle RasGetSubEntryProperties RasHangUp Rsmonitordlg RasPBDlgFunc RasPhonebookDlg RasRenameEntry RasSecurityDialogBegin RasSecurityDialogComplete RasSecurityDialogEnd RasSecurityDialogGetInfo RasSecurityDialogReceive RasSecurityDialogSend RasSetAutodialAddress RasSetAutodialEnable RasSetAutodialParam RasSetCredentials RasSetEntryDialParams RasSetEntryProperties RasSetSubEntryProperties RasValidateEntryName ReadConsole ReadConsoleInput ReadConsoleOutput ReadConsoleOutputAttribute ReadConsoleOutputCharacter ReadDirectoryChangesW ReadEventLog ReadFile ReadFileEx ReadPrinter ReadProcessMemory RealizePalette RectInRegion RectVisible RedrawWindow RegCloseKey RegConnectRegistry RegCreateKey RegCreateKeyEx RegDeleteKey RegDeleteValue RegEnumKey RegEnumKeyEx RegEnumValue RegFlushKey RegGetKeySecurity RegisterClass RegisterClassEx RegisterClipboardFormat RegisterDialogClasses RegisterEventSource RegisterHotKey RegisterServiceCtrlHandler RegisterWindowMessage RegLoadKey RegNotifyChangeKeyValue RegOpenKey RegOpenKeyEx RegQueryInfoKey RegQueryMultipleValues RegQueryValue RegQueryValueEx RegReplaceKey RegRestoreKey RegSaveKey RegSetKeySecurity RegSetValue RegSetValueEx RegUnLoadKey ReleaseCapture ReleaseDC ReleaseMutex ReleaseSemaphore RemoveDirectory RemoveFontResource RemoveMenu RemoveProp ReplaceText ReplyMessage ReportEvent ResetDC ResetEvent ResetPrinter ResizePalette RestoreDC ResumeThread ReuseDDElParam RevertToSelf RoundRect SaveDC ScaleViewportExtEx ScaleWindowExtEx ScheduleJob ScreenSaverConfigureDialog ScreenSaverProc ScreenToClient ScrollConsoleScreenBuffer ScrollDC ScrollWindow ScrollWindowEx SearchPath SelectClipPath SelectClipRgn SelectObject SelectPalette SendAsyncProc SendDlgItemMessage SendMessage SendMessageCallback SendMessageTimeout SendNotifyMessage ServiceMain SetAbortProc SetAclInformation SetActiveWindow SetArcDirection SetBitmapBits SetBitmapDimensionEx SetBkColor SetBkMode SetBoundsRect SetBrushOrgEx SetCapture SetCaretBlinkTime SetCaretPos SetClassLong SetClassWord SetClipboardData SetClipboardViewer SetColorAdjustment SetColorSpace SetCommBreak SetCommConfig SetCommMask SetCommState SetCommTimeouts SetComputerName SetConsoleActiveScreenBuffer SetConsoleCP SetConsoleCtrlHandler SetConsoleCursorInfo SetConsoleCursorPosition SetConsoleMode SetConsoleOutputCP SetConsoleScreenBufferSize SetConsoleTextAttribute SetConsoleTitle SetConsoleWindowInfo SetCurrentDirectory SetCursor SetCursorPos SetDebugErrorLevel SetDefaultCommConfig SetDeviceGammaRamp SetDIBColorTable SetDIBits SetDIBitsToDevice SetDlgItemInt SetDlgItemText SetDoubleClickTime SetEndOfFile SetEnhMetaFileBits SetEntriesInAcl SetEnvironmentVariable SetErrorMode SetEvent SetFileApisToANSI SetFileApisToOEM SetFileAttributes SetFilePointer SetFileSecurity SetFileTime SetFocus SetForegroundWindow SetForm SetGraphicsMode SetHandleCount SetHandleInformation SetICMMode SetICMProfile SetJob SetKernelObjectSecurity SetKeyboardState SetLastError SetLastErrorEx SetLocaleInfo SetLocalTime SetMailslotInfo SetMapMode SetMapperFlags SetMenu SetMenuContextHelpId SetMenuDefaultItem SetMenuItemBitmaps SetMenuItemInfo SetMessageExtraInfo SetMessageQueue SetMetaFileBitsEx SetMetaRgn SetMiterLimit SetNamedPipeHandleState SetPaletteEntries SetParent SetPixel SetPixelV SetPolyFillMode SetPort SetPrinter SetPrinterData SetPriorityClass SetPrivateObjectSecurity SetProcessAffinityMask SetProcessPriorityBoost SetProcessShutdownParameters SetProcessWindowStation SetProcessWorkingSetSize SetProp SetRect SetRectEmpty SetRectRgn SetROP2 SetScrollInfo SetScrollPos SetScrollRange SetSecurityDescriptorDacl SetSecurityDescriptorGroup SetSecurityDescriptorOwner SetSecurityDescriptorSacl SetSecurityInfo SetServiceBits SetServiceObjectSecurity SetServiceStatus SetStdHandle SetStretchBltMode SetSwapAreaSize SetSysColors SetSysModalWindow SetSystemCursor SetSystemPaletteUse SetSystemPowerState SetSystemTime SetSystemTimeAdjustment SetTapeParameters SetTapePosition SetTextAlign SetTextCharacterExtra SetTextColor SetTextJustification SetThreadAffinityMask SetThreadContext SetThreadDesktop SetThreadIdealProcessor SetThreadLocale SetThreadPriority SetThreadPriorityBoost SetThreadToken SetTimer SetTimeZoneInformation SetTokenInformation SetUnhandledExceptionFilter SetupComm SetupHookProc SetUserObjectInformation SetUserObjectSecurity SetViewportExtEx SetViewportOrgEx SetVolumeLabel SetWaitableTimer SetWindowContextHelpId SetWindowExtEx SetWindowLong SetWindowOrgEx SetWindowPlacement SetWindowPos SetWindowRgn SetWindowsHook SetWindowsHookEx SetWindowText SetWindowWord SetWinMetaFileBits SetWorldTransform SHAddToRecentDocs SHAppBarMessage SHBrowseForFolder SHChangeNotify Shell_NotifyIcon ShellAbout ShellExecute ShellExecuteEx ShellProc SHFileOperation SHFreeNameMappings SHGetDataFromIDList SHGetDesktopFolder SHGetFileInfo SHGetInstanceExplorer SHGetMalloc SHGetPathFromIDList SHGetSpecialFolderLocation SHLoadInProc ShowCaret ShowCursor ShowHideMenuCtl ShowOwnedPopups ShowScrollBar ShowWindow ShowWindowAsync SignalObjectAndWait SizeofResource SleepEx SnmpExtensionInit SnmpExtensionInitEx SnmpExtensionQuery SnmpExtensionTrap SnmpMgrClose SnmpMgrGetTrap SnmpMgrOidToStr SnmpMgrOpen SnmpMgrRequest SnmpMgrStrToOid SnmpMgrTrapListen SnmpUtilMemAlloc SnmpUtilMemFree SnmpUtilMemReAlloc SnmpUtilOidAppend SnmpUtilOidCmp SnmpUtilOidCpy SnmpUtilOidFree SnmpUtilOidNCmp SnmpUtilVarBindCpy SnmpUtilVarBindListCpy SnmpUtilVarBindFree SnmpUtilVarBindListFree SOBailOut SOBeginTable SOEndColumnInfo SOEndFieldInfo SOEndFontTable SOEndPalette SOEndTable SOEndTabStops SOGetInfo SOGetScanLineBuffer SOPutBitmapHeader SOPutBreak SOPutChar SOPutCharAttr SOPutCharFontById SOPutCharFontByName SOPutCharHeight SOPutCharX SOPutColumnInfo SOPutDataCell SOPutEmbeddedObject SOPutField SOPutFieldInfo SOPutFontTableEntry SOPutHdrEntry SOPutMoreText SOPutMoreVarField SOPutPaletteEntry SOPutParaAlign SOPutParaIndents SOPutParaMargins SOPutParaSpacing SOPutScanLineData SOPutSectionName SOPutSectionType SOPutSpecialCharX SOPutSubdocInfo SOPutTableCellInfo SOPutTableRowFormat SOPutTabStop SOPutTextCell SOPutVarField SOPutVectorHeader SOSetDateBase SOStartColumnInfo SOStartFieldInfo SOStartFontTable SOStartPalette SOStartTabStops SoundSentryProc SOVectorAttr SOVectorObject SUUserPopData SUUserPushData SUUserRetrieveData SUUserSaveData StartDoc StartDocPrinter StartPage StartPagePrinter StartService StartServiceCtrlDispatcher StretchBlt StretchDIBits StrokeAndFillPath StrokePath SubtractRect SuspendThread SwapMouseButton SwitchDesktop SwitchToFiber SwitchToThread SysMsgProc SystemParametersInfo SystemTimeToFileTime SystemTimeToTzSpecificLocalTime TabbedTextOut TerminateProcess TerminateThread TextOut TileWindows TimerProc TlsAlloc TlsFree TlsGetValue TlsSetValue ToAscii ToAsciiEx ToUnicode ToUnicodeEx TrackMouseEvent TrackPopupMenu TrackPopupMenuEx TransactNamedPipe TranslateAccelerator TranslateCharsetInfo TranslateMDISysAccel TranslateMessage TransmitCommChar TryEnterCriticalSection UInt32x32To64 UndeleteFile UnhandledExceptionFilter UnhookWindowsHook UnhookWindowsHookEx UnionRect UnloadKeyboardLayout UnlockFile UnlockFileEx UnlockResource UnlockSegment UnlockServiceDatabase UnmapViewOfFile UnpackDDElParam UnrealizeObject UnregisterClass UnregisterHotKey UpdateColors UpdateICMRegKey UpdateResource UpdateWindow ValidateRect ValidateRgn VerFindFile VerInstallFile VerLanguageName VerQueryValue VirtualAlloc VirtualAllocEx VirtualFree VirtualFreeEx VirtualLock VirtualProtect VirtualProtectEx VirtualQuery VirtualQueryEx VirtualUnlock VkKeyScan VkKeyScanEx VwStreamCloseFunc VwStreamOpenFunc VwStreamReadFunc VwStreamReadRecordFunc VwStreamSectionFunc VwStreamSeekFunc VwStreamTellFunc WaitCommEvent WaitForDebugEvent WaitForInputIdle WaitForMultipleObjects WaitForMultipleObjectsEx WaitForPrinterChange WaitForSingleObject WaitForSingleObjectEx WaitMessage WaitNamedPipe WideCharToMultiByte WidenPath WindowFromDC WindowFromPoint WindowProc WinExec WinHelp WinLoadTrustProvider WinMain WinSubmitCertificate WinTrustProviderClientInitialize WinTrustProviderClientUnload WinTrustProviderPing WinTrustProviderServerInitialize WinTrustProviderServerUnload WinTrustProviderSubmitCertificate WinTrustProviderVerifyTrust WinTrustSipInitialize WinTrustSubjectCheckContentInfo WinTrustSubjectEnumCertificates WinTrustSubjectGetCertHeader WinTrustSubjectGetCertificate WinTrustSubjectGetName WinVerifyTrust WNetAddConnection WNetAddConnection2 WNetAddConnection3 WNetCancelConnection WNetCancelConnection2 WNetCloseEnum WNetConnectionDialog WNetDisconnectDialog WNetEnumResource WNetGetConnection WNetGetLastError WNetGetUniversalName WNetGetUser WNetOpenEnum WriteConsole WriteConsoleInput WriteConsoleOutput WriteConsoleOutputAttribute WriteConsoleOutputCharacter WriteFile WriteFileEx WritePrinter WritePrivateProfileSection WritePrivateProfileString WritePrivateProfileStruct WriteProcessMemory WriteProfileSection WriteProfileString WriteTapemark wsprintf wvsprintf Yield ZeroMemory ABM_ACTIVATE ABM_GETAUTOHIDEBAR ABM_GETSTATE ABM_GETTASKBARPOS ABM_NEW ABM_QUERYPOS ABM_REMOVE ABM_SETAUTOHIDEBAR ABM_SETPOS ABM_WINDOWPOSCHANGED ABN_FULLSCREENAPP ABN_POSCHANGED ABN_STATECHANGE ABN_WINDOWARRANGE ACM_OPEN ACM_PLAY ACM_STOP ACN_START ACN_STOP BM_CLICK BM_GETCHECK BM_GETIMAGE BM_GETSTATE BM_SETCHECK BM_SETIMAGE BM_SETSTATE BM_SETSTYLE BN_CLICKED BN_DBLCLK BN_DISABLE BN_DOUBLECLICKED BN_HILITE BN_KILLFOCUS BN_PAINT BN_PUSHED BN_SETFOCUS BN_UNHILITE BN_UNPUSHED CB_ADDSTRING CB_DELETESTRING CB_DIR CB_FINDSTRING CB_FINDSTRINGEXACT CB_GETCOUNT CB_GETCURSEL CB_GETDROPPEDCONTROLRECT CB_GETDROPPEDSTATE CB_GETDROPPEDWIDTH CB_GETEDITSEL CB_GETEXTENDEDUI CB_GETHORIZONTALEXTENT CB_GETITEMDATA CB_GETITEMHEIGHT CB_GETLBTEXT CB_GETLBTEXTLEN CB_GETLOCALE CB_GETTOPINDEX CB_INITSTORAGE CB_INSERTSTRING CB_LIMITTEXT CB_RESETCONTENT CB_SELECTSTRING CB_SETCURSEL CB_SETDROPPEDWIDTH CB_SETEDITSEL CB_SETEXTENDEDUI CB_SETHORIZONTALEXTENT CB_SETITEMDATA CB_SETITEMHEIGHT CB_SETLOCALE CB_SETTOPINDEX CB_SHOWDROPDOWN CBN_CLOSEUP CBN_DBLCLK CBN_DROPDOWN CBN_EDITCHANGE CBN_EDITUPDATE CBN_ERRSPACE CBN_KILLFOCUS CBN_SELCHANGE CBN_SELENDCANCEL CBN_SELENDOK CBN_SETFOCUS CDM_GETFILEPATH CDM_GETFOLDERIDLIST CDM_GETFOLDERPATH CDM_GETSPEC CDM_HIDECONTROL CDM_SETCONTROLTEXT CDM_SETDEFEXT CDN_FILEOK CDN_FOLDERCHANGE CDN_HELP CDN_INITDONE CDN_SELCHANGE CDN_SHAREVIOLATION CDN_TYPECHANGE COLOROKSTRING CPL_DBLCLK CPL_EXIT CPL_GETCOUNT CPL_INIT CPL_INQUIRE CPL_NEWINQUIRE CPL_SELECT CPL_STOP DBT_CONFIGCHANGECANCELED DBT_CONFIGCHANGED DBT_DEVICEARRIVAL DBT_DEVICEQUERYREMOVE DBT_DEVICEQUERYREMOVEFAILED DBT_DEVICEREMOVECOMPLETE DBT_DEVICEREMOVEPENDING DBT_DEVICETYPESPECIFIC DBT_QUERYCHANGECONFIG DBT_USERDEFINED DL_BEGINDRAG DL_CANCELDRAG DL_DRAGGING DL_DROPPED DM_GETDEFID DM_REPOSITION DM_SETDEFID EM_CANPASTE EM_CANUNDO EM_CHARFROMPOS EM_DISPLAYBAND EM_EMPTYUNDOBUFFER EM_EXGETSEL EM_EXLIMITTEXT EM_EXLINEFROMCHAR EM_EXSETSEL EM_FINDTEXT EM_FINDWORDBREAK EM_FMTLINES EM_FORMATRANGE EM_GETCHARFORMAT EM_GETEVENTMASK EM_GETFIRSTVISIBLELINE EM_GETHANDLE EM_GETIMECOLOR EM_GETIMEOPTIONS EM_GETLIMITTEXT EM_GETLINE EM_GETLINECOUNT EM_GETMARGINS EM_GETMODIFY EM_GETOLEINTERFACE EM_GETOPTIONS EM_GETPARAFORMAT EM_GETPASSWORDCHAR EM_GETPUNCTUATION EM_GETRECT EM_GETSEL EM_GETSELTEXT EM_GETTEXTRANGE EM_GETTHUMB EM_GETWORDBREAKPROC EM_GETWORDBREAKPROCEX EM_GETWORDWRAPMODE EM_HIDESELECTION EM_LIMITTEXT EM_LINEFROMCHAR EM_LINEINDEX EM_LINELENGTH EM_LINESCROLL EM_PASTESPECIAL EM_POSFROMCHAR EM_REPLACESEL EM_REQUESTRESIZE EM_SCROLL EM_SCROLLCARET EM_SELECTIONTYPE EM_SETBKGNDCOLOR EM_SETCHARFORMAT EM_SETEVENTMASK EM_SETHANDLE EM_SETIMECOLOR EM_SETIMEOPTIONS EM_SETLIMITTEXT EM_SETMARGINS EM_SETMODIFY EM_SETOLEINTERFACE EM_SETOPTIONS EM_SETPARAFORMAT EM_SETPASSWORDCHAR EM_SETPUNCTUATION EM_SETREADONLY EM_SETRECT EM_SETRECTNP EM_SETSEL EM_SETTABSTOPS EM_SETTARGETDEVICE EM_SETWORDBREAK EM_SETWORDBREAKPROC EM_SETWORDBREAKPROCEX EM_SETWORDWRAPMODE EM_STREAMIN EM_STREAMOUT EM_UNDO EN_CHANGE EN_CORRECTTEXT EN_DROPFILES EN_ERRSPACE EN_HSCROLL EN_IMECHANGE EN_KILLFOCUS EN_MAXTEXT EN_MSGFILTER EN_OLEOPFAILED EN_PROTECTED EN_REQUESTRESIZE EN_SAVECLIPBOARD EN_SELCHANGE EN_SETFOCUS EN_STOPNOUNDO EN_UPDATE EN_VSCROLL FILEOKSTRING FINDMSGSTRING FM_GETDRIVEINFO FM_GETFILESEL FM_GETFILESELLFN FM_GETFOCUS FM_GETSELCOUNT FM_GETSELCOUNTLFN FM_REFRESH_WINDOWS FM_RELOAD_EXTENSIONS FMEVENT_HELPMENUITEM FMEVENT_HELPSTRING FMEVENT_INITMENU FMEVENT_LOAD FMEVENT_SELCHANGE FMEVENT_TOOLBARLOAD FMEVENT_UNLOAD FMEVENT_USER_REFRESH HDM_DELETEITEM HDM_GETITEM HDM_GETITEMCOUNT HDM_HITTEST HDM_INSERTITEM HDM_LAYOUT HDM_SETITEM HDN_BEGINTRACK HDN_DIVIDERDBLCLICK HDN_ENDTRACK HDN_ITEMCHANGED HDN_ITEMCHANGING HDN_ITEMCLICK HDN_ITEMDBLCLICK HDN_TRACK HELPMSGSTRING HKM_GETHOTKEY HKM_SETHOTKEY HKM_SETRULES IMC_CLOSESTATUSWINDOW IMC_GETCANDIDATEPOS IMC_GETCOMPOSITIONFONT IMC_GETCOMPOSITIONWINDOW IMC_GETCONVERSIONMODE IMC_GETOPENSTATUS IMC_GETSENTENCEMODE IMC_GETSTATUSWINDOWPOS IMC_OPENSTATUSWINDOW IMC_SETCANDIDATEPOS IMC_SETCOMPOSITIONFONT IMC_SETCOMPOSITIONWINDOW IMC_SETCONVERSIONMODE IMC_SETOPENSTATUS IMC_SETSENTENCEMODE IMC_SETSTATUSWINDOWPOS IMN_CHANGECANDIDATE IMN_CLOSECANDIDATE IMN_CLOSESTATUSWINDOW IMN_GUIDELINE IMN_OPENCANDIDATE IMN_OPENSTATUSWINDOW IMN_SETCANDIDATEPOS IMN_SETCOMPOSITIONFONT IMN_SETCOMPOSITIONWINDOW IMN_SETCONVERSIONMODE IMN_SETOPENSTATUS IMN_SETSENTENCEMODE IMN_SETSTATUSWINDOWPOS LB_ADDFILE LB_ADDSTRING LB_DELETESTRING LB_DIR LB_FINDSTRING LB_FINDSTRINGEXACT LB_GETANCHORINDEX LB_GETCARETINDEX LB_GETCOUNT LB_GETCURSEL LB_GETHORIZONTALEXTENT LB_GETITEMDATA LB_GETITEMHEIGHT LB_GETITEMRECT LB_GETLOCALE LB_GETSEL LB_GETSELCOUNT LB_GETSELITEMS LB_GETTEXT LB_GETTEXTLEN LB_GETTOPINDEX LB_INITSTORAGE LB_INSERTSTRING LB_ITEMFROMPOINT LB_RESETCONTENT LB_SELECTSTRING LB_SELITEMRANGE LB_SELITEMRANGEEX LB_SETANCHORINDEX LB_SETCARETINDEX LB_SETCOLUMNWIDTH LB_SETCOUNT LB_SETCURSEL LB_SETHORIZONTALEXTENT LB_SETITEMDATA LB_SETITEMHEIGHT LB_SETLOCALE LB_SETSEL LB_SETTABSTOPS LB_SETTOPINDEX LBN_DBLCLK LBN_ERRSPACE LBN_KILLFOCUS LBN_SELCANCEL LBN_SELCHANGE LBN_SETFOCUS LBSELCHSTRING LVM_ARRANGE LVM_CREATEDRAGIMAGE LVM_DELETEALLITEMS LVM_DELETECOLUMN LVM_DELETEITEM LVM_EDITLABEL LVM_ENSUREVISIBLE LVM_FINDITEM LVM_GETBKCOLOR LVM_GETCALLBACKMASK LVM_GETCOLUMN LVM_GETCOLUMNWIDTH LVM_GETCOUNTPERPAGE LVM_GETEDITCONTROL LVM_GETIMAGELIST LVM_GETISEARCHSTRING LVM_GETITEM LVM_GETITEMCOUNT LVM_GETITEMPOSITION LVM_GETITEMRECT LVM_GETITEMSPACING LVM_GETITEMSTATE LVM_GETITEMTEXT LVM_GETNEXTITEM LVM_GETORIGIN LVM_GETSELECTEDCOUNT LVM_GETSTRINGWIDTH LVM_GETTEXTBKCOLOR LVM_GETTEXTCOLOR LVM_GETTOPINDEX LVM_GETVIEWRECT LVM_HITTEST LVM_INSERTCOLUMN LVM_INSERTITEM LVM_REDRAWITEMS LVM_SCROLL LVM_SETBKCOLOR LVM_SETCALLBACKMASK LVM_SETCOLUMN LVM_SETCOLUMNWIDTH LVM_SETIMAGELIST LVM_SETITEM LVM_SETITEMCOUNT LVM_SETITEMPOSITION LVM_SETITEMPOSITION32 LVM_SETITEMSTATE LVM_SETITEMTEXT LVM_SETTEXTBKCOLOR LVM_SETTEXTCOLOR LVM_SORTITEMS LVM_UPDATE LVN_BEGINDRAG LVN_BEGINLABELEDIT LVN_BEGINRDRAG LVN_COLUMNCLICK LVN_DELETEALLITEMS LVN_DELETEITEM LVN_ENDLABELEDIT LVN_GETDISPINFO LVN_INSERTITEM LVN_ITEMCHANGED LVN_ITEMCHANGING LVN_KEYDOWN LVN_SETDISPINFO NIM_ADD NIM_DELETE NIM_MODIFY NM_CLICK NM_DBLCLK NM_KILLFOCUS NM_OUTOFMEMORY NM_RCLICK NM_RDBLCLK NM_RETURN NM_SETFOCUS PBM_DELTAPOS PBM_SETPOS PBM_SETRANGE PBM_SETSTEP PBM_STEPIT PBT_APMBATTERYLOW PBT_APMOEMEVENT PBT_APMPOWERSTATUSCHANGE PBT_APMQUERYSUSPEND PBT_APMQUERYSUSPENDFAILED PBT_APMRESUMECRITICAL PBT_APMRESUMESUSPEND PBT_APMSUSPEND PSM_ADDPAGE PSM_APPLY PSM_CANCELTOCLOSE PSM_CHANGED PSM_GETCURRENTPAGEHWND PSM_GETTABCONTROL PSM_ISDIALOGMESSAGE PSM_PRESSBUTTON PSM_QUERYSIBLINGS PSM_REBOOTSYSTEM PSM_REMOVEPAGE PSM_RESTARTWINDOWS PSM_SETCURSEL PSM_SETCURSELID PSM_SETFINISHTEXT PSM_SETTITLE PSM_SETWIZBUTTONS PSM_UNCHANGED PSN_APPLY PSN_HELP PSN_KILLACTIVE PSN_QUERYCANCEL PSN_RESET PSN_SETACTIVE PSN_WIZBACK PSN_WIZFINISH PSN_WIZNEXT SB_GETBORDERS SB_GETPARTS SB_GETRECT SB_GETTEXT SB_GETTEXTLENGTH SB_SETMINHEIGHT SB_SETPARTS SB_SETTEXT SB_SIMPLE SBM_ENABLE_ARROWS SBM_GETPOS SBM_GETRANGE SBM_GETSCROLLINFO SBM_SETPOS SBM_SETRANGE SBM_SETRANGEREDRAW SBM_SETSCROLLINFO SETRGBSTRING SHAREVISTRING STM_GETICON STM_GETIMAGE STM_SETICON STM_SETIMAGE STN_CLICKED STN_DBLCLK STN_DISABLE STN_ENABLE TB_ADDBITMAP TB_ADDBUTTONS TB_ADDSTRING TB_AUTOSIZE TB_BUTTONCOUNT TB_BUTTONSTRUCTSIZE TB_CHANGEBITMAP TB_CHECKBUTTON TB_COMMANDTOINDEX TB_CUSTOMIZE TB_DELETEBUTTON TB_ENABLEBUTTON TB_GETBITMAP TB_GETBITMAPFLAGS TB_GETBUTTON TB_GETBUTTONTEXT TB_GETITEMRECT TB_GETROWS TB_GETSTATE TB_GETTOOLTIPS TB_HIDEBUTTON TB_INDETERMINATE TB_INSERTBUTTON TB_ISBUTTONCHECKED TB_ISBUTTONENABLED TB_ISBUTTONHIDDEN TB_ISBUTTONINDETERMINATE TB_ISBUTTONPRESSED TB_PRESSBUTTON TB_SAVERESTORE TB_SETBITMAPSIZE TB_SETBUTTONSIZE TB_SETCMDID TB_SETPARENT TB_SETROWS TB_SETSTATE TB_SETTOOLTIPS TBM_CLEARSEL TBM_CLEARTICS TBM_GETCHANNELRECT TBM_GETLINESIZE TBM_GETNUMTICS TBM_GETPAGESIZE TBM_GETPOS TBM_GETPTICS TBM_GETRANGEMAX TBM_GETRANGEMIN TBM_GETSELEND TBM_GETSELSTART TBM_GETTHUMBLENGTH TBM_GETTHUMBRECT TBM_GETTIC TBM_GETTICPOS TBM_SETLINESIZE TBM_SETPAGESIZE TBM_SETPOS TBM_SETRANGE TBM_SETRANGEMAX TBM_SETRANGEMIN TBM_SETSEL TBM_SETSELEND TBM_SETSELSTART TBM_SETTHUMBLENGTH TBM_SETTIC TBM_SETTICFREQ TBN_BEGINADJUST TBN_BEGINDRAG TBN_CUSTHELP TBN_ENDADJUST TBN_ENDDRAG TBN_GETBUTTONINFO TBN_QUERYDELETE TBN_QUERYINSERT TBN_RESET TBN_TOOLBARCHANGE TCM_ADJUSTRECT TCM_DELETEALLITEMS TCM_DELETEITEM TCM_GETCURFOCUS TCM_GETCURSEL TCM_GETIMAGELIST TCM_GETITEM TCM_GETITEMCOUNT TCM_GETITEMRECT TCM_GETROWCOUNT TCM_GETTOOLTIPS TCM_HITTEST TCM_INSERTITEM TCM_REMOVEIMAGE TCM_SETCURFOCUS TCM_SETCURSEL TCM_SETIMAGELIST TCM_SETITEM TCM_SETITEMEXTRA TCM_SETITEMSIZE TCM_SETPADDING TCM_SETTOOLTIPS TCN_KEYDOWN TCN_SELCHANGE TCN_SELCHANGING TTM_ACTIVATE TTM_DELTOOL TTM_ENUMTOOLS TTM_GETCURRENTTOOL TTM_GETTEXT TTM_GETTOOLCOUNT TTM_GETTOOLINFO TTM_HITTEST TTM_NEWTOOLRECT TTM_RELAYEVENT TTM_SETDELAYTIME TTM_SETTOOLINFO TTM_UPDATETIPTEXT TTM_WINDOWFROMPOINT TTN_NEEDTEXT TTN_POP TTN_SHOW TVM_CREATEDRAGIMAGE TVM_DELETEITEM TVM_EDITLABEL TVM_ENDEDITLABELNOW TVM_ENSUREVISIBLE TVM_EXPAND TVM_GETCOUNT TVM_GETEDITCONTROL TVM_GETIMAGELIST TVM_GETINDENT TVM_GETISEARCHSTRING TVM_GETITEM TVM_GETITEMRECT TVM_GETNEXTITEM TVM_GETVISIBLECOUNT TVM_HITTEST TVM_INSERTITEM TVM_SELECTITEM TVM_SETIMAGELIST TVM_SETINDENT TVM_SETITEM TVM_SORTCHILDREN TVM_SORTCHILDRENCB TVN_BEGINDRAG TVN_BEGINLABELEDIT TVN_BEGINRDRAG TVN_DELETEITEM TVN_ENDLABELEDIT TVN_GETDISPINFO TVN_ITEMEXPANDED TVN_ITEMEXPANDING TVN_KEYDOWN TVN_SELCHANGED TVN_SELCHANGING TVN_SETDISPINFO UDM_GETACCEL UDM_GETBASE UDM_GETBUDDY UDM_GETPOS UDM_GETRANGE UDM_SETACCEL UDM_SETBASE UDM_SETBUDDY UDM_SETPOS UDM_SETRANGE UDN_DELTAPOS WM_ACTIVATE WM_ACTIVATEAPP WM_ASKCBFORMATNAME WM_CANCELJOURNAL WM_CANCELMODE WM_CAPTURECHANGED WM_CHANGECBCHAIN WM_CHAR WM_CHARTOITEM WM_CHILDACTIVATE WM_CHOOSEFONT_GETLOGFONT WM_CHOOSEFONT_SETFLAGS WM_CHOOSEFONT_SETLOGFONT WM_CLEAR WM_CLOSE WM_COMMAND WM_COMPACTING WM_COMPAREITEM WM_CONTEXTMENU WM_COPY WM_COPYDATA WM_CPL_LAUNCH WM_CPL_LAUNCHED WM_CREATE WM_CTLCOLORBTN WM_CTLCOLORDLG WM_CTLCOLOREDIT WM_CTLCOLORLISTBOX WM_CTLCOLORMSGBOX WM_CTLCOLORSCROLLBAR WM_CTLCOLORSTATIC WM_CUT WM_DDE_ACK WM_DDE_ADVISE WM_DDE_DATA WM_DDE_EXECUTE WM_DDE_INITIATE WM_DDE_POKE WM_DDE_REQUEST WM_DDE_TERMINATE WM_DDE_UNADVISE WM_DEADCHAR WM_DELETEITEM WM_DESTROY WM_DESTROYCLIPBOARD WM_DEVICECHANGE WM_DEVMODECHANGE WM_DISPLAYCHANGE WM_DRAWCLIPBOARD WM_DRAWITEM WM_DROPFILES WM_ENABLE WM_ENDSESSION WM_ENTERIDLE WM_ENTERMENULOOP WM_ENTERSIZEMOVE WM_ERASEBKGND WM_EXITMENULOOP WM_EXITSIZEMOVE WM_FONTCHANGE WM_GETDLGCODE WM_GETFONT WM_GETHOTKEY WM_GETICON WM_GETMINMAXINFO WM_GETTEXT WM_GETTEXTLENGTH WM_HELP WM_HOTKEY WM_HSCROLL WM_HSCROLLCLIPBOARD WM_ICONERASEBKGND WM_IME_CHAR WM_IME_COMPOSITION WM_IME_COMPOSITIONFULL WM_IME_CONTROL WM_IME_ENDCOMPOSITION WM_IME_KEYDOWN WM_IME_KEYUP WM_IME_NOTIFY WM_IME_SELECT WM_IME_SETCONTEXT WM_IME_STARTCOMPOSITION WM_INITDIALOG WM_INITMENU WM_INITMENUPOPUP WM_INPUTLANGCHANGE WM_INPUTLANGCHANGEREQUEST WM_KEYDOWN WM_KEYUP WM_KILLFOCUS WM_LBUTTONDBLCLK WM_LBUTTONDOWN WM_LBUTTONUP WM_MBUTTONDBLCLK WM_MBUTTONDOWN WM_MBUTTONUP WM_MDIACTIVATE WM_MDICASCADE WM_MDICREATE WM_MDIDESTROY WM_MDIGETACTIVE WM_MDIICONARRANGE WM_MDIMAXIMIZE WM_MDINEXT WM_MDIREFRESHMENU WM_MDIRESTORE WM_MDISETMENU WM_MDITILE WM_MEASUREITEM WM_MENUCHAR WM_MENUSELECT WM_MOUSEACTIVATE WM_MOUSEMOVE WM_MOUSEWHEEL WM_MOVE WM_MOVING WM_NCACTIVATE WM_NCCALCSIZE WM_NCCREATE WM_NCDESTROY WM_NCHITTEST WM_NCLBUTTONDBLCLK WM_NCLBUTTONDOWN WM_NCLBUTTONUP WM_NCMBUTTONDBLCLK WM_NCMBUTTONDOWN WM_NCMBUTTONUP WM_NCMOUSEMOVE WM_NCPAINT WM_NCRBUTTONDBLCLK WM_NCRBUTTONDOWN WM_NCRBUTTONUP WM_NEXTDLGCTL WM_NOTIFY WM_NOTIFYFORMAT WM_PAINT WM_PAINTCLIPBOARD WM_PAINTICON WM_PALETTECHANGED WM_PALETTEISCHANGING WM_PARENTNOTIFY WM_PASTE WM_POWER WM_POWERBROADCAST WM_PRINT WM_PRINTCLIENT WM_PSD_ENVSTAMPRECT WM_PSD_FULLPAGERECT WM_PSD_GREEKTEXTRECT WM_PSD_MARGINRECT WM_PSD_MINMARGINRECT WM_PSD_PAGESETUPDLG WM_PSD_YAFULLPAGERECT WM_QUERYDRAGICON WM_QUERYENDSESSION WM_QUERYNEWPALETTE WM_QUERYOPEN WM_QUEUESYNC WM_QUIT WM_RASDIALEVENT WM_RBUTTONDBLCLK WM_RBUTTONDOWN WM_RBUTTONUP WM_RENDERALLFORMATS WM_RENDERFORMAT WM_SETCURSOR WM_SETFOCUS WM_SETFONT WM_SETHOTKEY WM_SETICON WM_SETREDRAW WM_SETTEXT WM_SETTINGCHANGE WM_SHOWWINDOW WM_SIZE WM_SIZECLIPBOARD WM_SIZING WM_SPOOLERSTATUS WM_STYLECHANGED WM_STYLECHANGING WM_SYSCHAR WM_SYSCOLORCHANGE WM_SYSCOMMAND WM_SYSDEADCHAR WM_SYSKEYDOWN WM_SYSKEYUP WM_TCARD WM_TIMECHANGE WM_TIMER WM_UNDO WM_USER WM_USERCHANGED WM_VKEYTOITEM WM_VSCROLL WM_VSCROLLCLIPBOARD WM_WINDOWPOSCHANGED WM_WINDOWPOSCHANGING WM_WININICHANGE ABC ABCFLOAT ACCEL AccelTableEntry ACCESS_ALLOWED_ACE ACCESS_DENIED_ACE ACCESS_MASK ACCESSTIMEOUT ACE ACE_HEADER ACL ACL_REVISION_INFORMATION ACL_SIZE_INFORMATION ACTION_HEADER ADAPTER_STATUS ADDJOB_INFO_1 ADMIN_OTHER_INFO ANIMATIONINFO APPBARDATA AsnAny AsnObjectIdentifier AsnOctetString AT_ENUM AT_INFO AUDIT_ENTRY BITMAP BITMAPCOREHEADER BITMAPCOREINFO BITMAPFILEHEADER BITMAPINFO BITMAPINFOHEADER BITMAPV4HEADER BLOB BROWSEINFO BY_HANDLE_FILE_INFORMATION CANDIDATEFORM CANDIDATELIST CBT_CREATEWND CBTACTIVATESTRUCT CHAR_INFO CHARFORMAT CHARRANGE CHARSET CHARSETINFO CHOOSECOLOR CHOOSEFONT CIDA CIEXYZ CIEXYZTRIPLE CLIENTCREATESTRUCT CMINVOKECOMMANDINFO COLORADJUSTMENT COLORMAP COLORREF COMMCONFIG COMMPROP COMMTIMEOUTS COMPAREITEMSTRUCT COMPCOLOR COMPOSITIONFORM COMSTAT CONFIG_INFO_0 CONNECTION_INFO_0 CONNECTION_INFO_1 CONSOLE_CURSOR_INFO CONSOLE_SCREEN_BUFFER_INFO CONTEXT CONVCONTEXT CONVINFO COORD COPYDATASTRUCT CPINFO CPLINFO CREATE_PROCESS_DEBUG_INFO CREATE_THREAD_DEBUG_INFO CREATESTRUCT CSADDR_INFO CURRENCYFMT CURSORDIR CURSORSHAPE CWPRETSTRUCT CWPSTRUCT DATATYPES_INFO_1 DCB DDEACK DDEADVISE DDEDATA DDELN DDEML_MSG_HOOK_DATA DDEPOKE DDEUP DEBUG_EVENT DEBUGHOOKINFO DELETEITEMSTRUCT DEV_BROADCAST_HDR DEV_BROADCAST_OEM DEV_BROADCAST_PORT _DEV_BROADCAST_USERDEFINED DEV_BROADCAST_VOLUME DEVMODE DEVNAMES DIBSECTION DirEntry DISK_GEOMETRY DISK_PERFORMANCE DLGITEMTEMPLATE DLGITEMTEMPLATEEX DLGTEMPLATE DLGTEMPLATEEX DOC_INFO_1 DOC_INFO_2 DOCINFO DRAGLISTINFO DRAWITEMSTRUCT DRAWTEXTPARAMS DRIVE_LAYOUT_INFORMATION DRIVER_INFO_1 DRIVER_INFO_2 DRIVER_INFO_3 DROPFILES EDITSTREAM EMR EMRANGLEARC EMRARC EMRARCTO EMRCHORD EMRPIE EMRBITBLT EMRCREATEBRUSHINDIRECT EMRCREATECOLORSPACE EMRCREATEDIBPATTERNBRUSHPT EMRCREATEMONOBRUSH EMRCREATEPALETTE EMRCREATEPEN EMRELLIPSE EMRRECTANGLE EMREOF EMREXCLUDECLIPRECT EMRINTERSECTCLIPRECT EMREXTCREATEFONTINDIRECTW EMREXTCREATEPEN EMREXTFLOODFILL EMREXTSELECTCLIPRGN EMREXTTEXTOUTA EMREXTTEXTOUTW EMRFILLPATH EMRSTROKEANDFILLPATH EMRSTROKEPATH EMRFILLRGN EMRFORMAT EMRFRAMERGN EMRGDICOMMENT EMRINVERTRGN EMRPAINTRGN EMRLINETO EMRMOVETOEX EMRMASKBLT EMRMODIFYWORLDTRANSFORM EMROFFSETCLIPRGN EMRPLGBLT EMRPOLYDRAW EMRPOLYDRAW16 EMRPOLYLINE EMRPOLYBEZIER EMRPOLYGON EMRPOLYBEZIERTO EMRPOLYLINETO EMRPOLYLINE16 EMRPOLYBEZIER16 EMRPOLYGON16 EMRPOLYBEZIERTO16 EMRPOLYLINETO16 EMRPOLYPOLYLINE EMRPOLYPOLYGON EMRPOLYPOLYLINE16 EMRPOLYPOLYGON16 EMRPOLYTEXTOUTA EMRPOLYTEXTOUTW EMRRESIZEPALETTE EMRRESTOREDC EMRROUNDRECT EMRSCALEVIEWPORTEXTEX EMRSCALEWINDOWEXTEX EMRSELECTCOLORSPACE EMRDELETECOLORSPACE EMRSELECTOBJECT EMRDELETEOBJECT EMRSELECTPALETTE EMRSETARCDIRECTION EMRSETBKCOLOR EMRSETTEXTCOLOR EMRSETCOLORADJUSTMENT EMRSETDIBITSTODEVICE EMRSETMAPPERFLAGS EMRSETMITERLIMIT EMRSETPALETTEENTRIES EMRSETPIXELV EMRSETVIEWPORTEXTEX EMRSETWINDOWEXTEX EMRSETVIEWPORTORGEX EMRSETWINDOWORGEX EMRSETBRUSHORGEX EMRSETWORLDTRANSFORM EMRSTRETCHBLT EMRSTRETCHDIBITS EMRTEXT ENCORRECTTEXT ENDROPFILES ENHMETAHEADER ENHMETARECORD ENOLEOPFAILED ENPROTECTED ENSAVECLIPBOARD ENUM_SERVICE_STATUS ENUMLOGFONT ENUMLOGFONTEX ERRLOG_OTHER_INFO EVENTLOGRECORD EVENTMSG EXCEPTION_DEBUG_INFO EXCEPTION_POINTERS EXCEPTION_RECORD EXPLICIT_ACCESS EXIT_PROCESS_DEBUG_INFO EXIT_THREAD_DEBUG_INFO EXT_BUTTON EXTLOGFONT EXTLOGPEN FILE_INFO_2 FILE_INFO_3 FILE_NOTIFY_INFORMATION FILEDESCRIPTOR FILEGROUPDESCRIPTOR FILETIME FILTERKEYS FIND_NAME_BUFFER FIND_NAME_HEADER FINDREPLACE FINDTEXT FINDTEXTEX FIXED FMS_GETDRIVEINFO FMS_GETFILESEL FMS_LOAD FMS_TOOLBARLOAD FOCUS_EVENT_RECORD FOLDERSETTINGS FontDirEntry FontGroupHdr FONTSIGNATURE FORM_INFO_1 FORMAT_PARAMETERS FORMATRANGE FVSHOWINFO GCP_RESULTS GENERIC_MAPPING GLYPHMETRICS GROUP_INFO_0 GROUP_INFO_1 GROUP_INFO_2 GROUP_INFO_1002 GROUP_INFO_1005 GROUP_USERS_INFO_0 GROUP_USERS_INFO_1 HANDLE HANDLE_INFO_1 HANDLETABLE HD_HITTESTINFO HD_ITEM HD_LAYOUT HD_NOTIFY HELPINFO HELPWININFO HIGHCONTRAST HSZPAIR HW_PROFILE_INFO ICONINFO ICONMETRICS ICONRESDIR IMAGEINFO INPUT_RECORD ITEMIDLIST JOB_INFO_1 JOB_INFO_2 JOB_INFO_3 KERNINGPAIR KEY_EVENT_RECORD LANA_ENUM LARGE_INTEGER LDT_ENTRY LIST_ENTRY LOAD_DLL_DEBUG_INFO LOCALESIGNATURE LOCALGROUP_INFO_0 LOCALGROUP_INFO_1 LOCALGROUP_INFO_1002 LOCALGROUP_MEMBERS_INFO_0 LOCALGROUP_MEMBERS_INFO_1 LOCALGROUP_MEMBERS_INFO_2 LOCALGROUP_MEMBERS_INFO_3 LOCALGROUP_USERS_INFO_0 LOCALHEADER LOGBRUSH LOGCOLORSPACE LOGFONT LOGPALETTE LOGPEN LS_CHALLDATA LS_CHALLENGE LS_MSG_DIGEST LUID LUID_AND_ATTRIBUTES LV_COLUMN LV_DISPINFO LV_FINDINFO LV_HITTESTINFO LV_ITEM LV_KEYDOWN MAT2 MDICREATESTRUCT MEASUREITEMSTRUCT MEMORY_BASIC_INFORMATION MEMORYSTATUS MENU_EVENT_RECORD MENUEX_TEMPLATE_HEADER MENUEX_TEMPLATE_ITEM MenuHeader MENUHELPID MENUITEMINFO MENUITEMTEMPLATE MENUITEMTEMPLATEHEADER MESSAGE_RESOURCE_DATA MESSAGE_RESOURCE_ENTRY METAFILEPICT METAHEADER METARECORD MINIMIZEDMETRICS MINMAXINFO MODEMDEVCAPS MODEMSETTINGS MONCBSTRUCT MONCONVSTRUCT MONERRSTRUCT MONHSZSTRUCT MONITOR_INFO_1 MONITOR_INFO_2 MONLINKSTRUCT MONMSGSTRUCT MOUSE_EVENT_RECORD MOUSEHOOKSTRUCT MOUSEKEYS MSG MSG_INFO_0 MSG_INFO_1 MSGBOXPARAMS MSGFILTER MULTIKEYHELP NAME_BUFFER NCB NCCALCSIZE_PARAMS NDDESHAREINFO NETCONNECTINFOSTRUCT NET_DISPLAY_GROUP NET_DISPLAY_MACHINE NET_DISPLAY_USER NETRESOURCE NEWCPLINFO NEWHEADER NEWTEXTMETRIC NEWTEXTMETRICEX NM_LISTVIEW NM_TREEVIEW NM_UPDOWN NMHDR NONCLIENTMETRICS NormalMenuItem NOTIFYICONDATA NRESARRAY NS_SERVICE_INFO NUMBERFMT OFNOTIFY OFSTRUCT OPENFILENAME OSVERSIONINFO OUTLINETEXTMETRIC OUTPUT_DEBUG_STRING_INFO OVERLAPPED PAGESETUPDLG PAINTSTRUCT PALETTEENTRY PANOSE PARAFORMAT PARTITION_INFORMATION POINT POINTFX POINTL POINTS POLYTEXT PopupMenuItem PORT_INFO_1 PORT_INFO_2 PORT_INFO_3 PREVENT_MEDIA_REMOVAL PRINTDLG PRINTER_DEFAULTS PRINTER_INFO_2 PRINTER_INFO_3 PRINTER_INFO_4 PRINTER_INFO_5 PRINTER_INFO_6 PRINTER_NOTIFY_INFO PRINTER_NOTIFY_INFO_DATA PRINTER_NOTIFY_OPTIONS PRINTER_NOTIFY_OPTIONS_TYPE PRINTPROCESSOR_INFO_1 PRIVILEGE_SET PROCESS_HEAP_ENTRY PROCESS_INFORMATION PROPSHEETHEADER PROPSHEETPAGE PROTOCOL_INFO PROVIDOR_INFO_1 PSHNOTIFY PUNCTUATION QUERY_SERVICE_CONFIG QUERY_SERVICE_LOCK_STATUS RAS_PARAMETERS RAS_PARAMS_VALUE RAS_PORT_0 RAS_PORT_1 RAS_PORT_STATISTICS RAS_PPP_ATCP_RESULT RAS_PPP_IPCP_RESULT RAS_PPP_IPXCP_RESULT RAS_PPP_NBFCP_RESULT RAS_PPP_PROJECTION_RESULT RAS_SECURITY_INFO RAS_SERVER_0 RAS_USER_0 RASADPARAMS RASAMB RASAUTODIALENTRY RASCONN RASCONNSTATUS RASCREDENTIALS RASCTRYINFO RASDEVINFO RASDIALDLG RASDIALEXTENSIONS RASDIALPARAMS RASENTRY RASENTRYDLG RASENTRYNAME RASIPADDR Rsmonitordlg RASNOUSER RASPBDLG RASPPPIP RASPPPIPX RASPPPNBF RASSLIP RASTERIZER_STATUS REASSIGN_BLOCKS RASSUBENTRY RECT RECTL REGISTERWORD REMOTE_NAME_INFO REOBJECT REPASTESPECIAL REPL_EDIR_INFO_0 REPL_EDIR_INFO_1 REPL_EDIR_INFO_2 REPL_EDIR_INFO_1000 REPL_EDIR_INFO_1001 REPL_IDIR_INFO_0 REPL_IDIR_INFO_1 REPL_INFO_0 REPL_INFO_1000 REPL_INFO_1002 REPL_INFO_1003 REQRESIZE RESDIR RESOURCEHEADER RFC1157VarBind RFC1157VarBindList RGBQUAD RGBTRIPLE RGNDATA RGNDATAHEADER RIP_INFO SCROLLINFO SECURITY_ATTRIBUTES SECURITY_DESCRIPTOR SECURITY_DESCRIPTOR_CONTROL SECURITY_MESSAGE SECURITY_QUALITY_OF_SERVICE SELCHANGE SERIALKEYS SERVER_INFO_100 SERVER_INFO_101 SERVER_INFO_102 SERVER_INFO_402 SERVER_INFO_403 SERVER_INFO_502 SERVER_INFO_503 SERVER_INFO_1005 SERVER_INFO_1107 SERVER_INFO_1010 SERVER_INFO_1016 SERVER_INFO_1017 SERVER_INFO_1018 SERVER_INFO_1501 SERVER_INFO_1502 SERVER_INFO_1503 SERVER_INFO_1506 SERVER_INFO_1509 SERVER_INFO_1510 SERVER_INFO_1511 SERVER_INFO_1512 SERVER_INFO_1513 SERVER_INFO_1515 SERVER_INFO_1516 SERVER_INFO_1518 SERVER_INFO_1523 SERVER_INFO_1528 SERVER_INFO_1529 SERVER_INFO_1530 SERVER_INFO_1533 SERVER_INFO_1534 SERVER_INFO_1535 SERVER_INFO_1538 SERVER_INFO_1539 SERVER_INFO_1540 SERVER_INFO_1541 SERVER_INFO_1542 SERVER_INFO_1544 SERVER_INFO_1550 SERVER_INFO_1552 SERVER_TRANSPORT_INFO_0 SERVICE_ADDRESS SERVICE_ADDRESSES SERVICE_INFO SERVICE_INFO_0 SERVICE_INFO_1 SERVICE_INFO_2 SERVICE_STATUS SERVICE_TABLE_ENTRY SERVICE_TYPE_INFO_ABS SERVICE_TYPE_VALUE_ABS SESSION_BUFFER SESSION_HEADER SESSION_INFO_0 SESSION_INFO_1 SESSION_INFO_2 SESSION_INFO_10 SESSION_INFO_502 SET_PARTITION_INFORMATION SHARE_INFO_0 SHARE_INFO_1 SHARE_INFO_2 SHARE_INFO_502 SHARE_INFO_1004 SHARE_INFO_1006 SHARE_INFO_1501 SHELLEXECUTEINFO SHFILEINFO SHFILEOPSTRUCT SHITEMID SHNAMEMAPPING SID SID_AND_ATTRIBUTES SID_IDENTIFIER_AUTHORITY SINGLE_LIST_ENTRY SIZE SMALL_RECT SOARCINFO SOBITMAPHEADER SOBORDER SOCOLUMN SOCPARCANGLE SOCPPIEANGLE SOCPTEXTATPOINT SODATACELL SOEMBEDDEDGRAPHIC SOEMBEDDEDOBJECT SOEMBEDINFO SOFIELD SOFILTERINFO SOGROUPINFO SOLOGBRUSH SOLOGFONT SOLOGPEN SOPARAINDENTS SOPATHINFO SOPOINT SOPOLYINFO SORECT SOTAB SOTABLECELLINFO SOTEXTATARCANGLE SOTEXTATPOINT SOTEXTCELL SOTEXTINRECT SOTRANSFORM SOVECTORHEADER SOUNDSENTRY STARTUPINFO STAT_SERVER_0 STAT_WORKSTATION_0 STD_ALERT STICKYKEYS STRRET StringFileInfo StringTable STYLEBUF STYLESTRUCT SYSTEM_ALARM_ACE SYSTEM_AUDIT_ACE SYSTEM_INFO SYSTEM_POWER_STATUS SYSTEMTIME TAPE_ERASE TAPE_GET_DRIVE_PARAMETERS TAPE_GET_MEDIA_PARAMETERS TAPE_GET_POSITION TAPE_PREPARE TAPE_SET_DRIVE_PARAMETERS TAPE_SET_MEDIA_PARAMETERS TAPE_WRITE_MARKS TBADDBITMAP TBBUTTON TBNOTIFY TBSAVEPARAMS TC_HITTESTINFO TC_ITEM TC_ITEMHEADER TC_KEYDOWN TEXTMETRIC TEXTRANGE TIME_OF_DAY_INFO TIME_ZONE_INFORMATION TOGGLEKEYS TOKEN_CONTROL TOKEN_DEFAULT_DACL TOKEN_GROUPS TOKEN_OWNER TOKEN_PRIMARY_GROUP TOKEN_PRIVILEGES TOKEN_SOURCE TOKEN_STATISTICS TOKEN_USER TOOLINFO TOOLTIPTEXT TPMPARAMS TRACKMOUSEEVENT TRANSMIT_FILE_BUFFERS TRUSTEE TTHITTESTINFO TTPOLYCURVE TTPOLYGONHEADER TV_DISPINFO TV_HITTESTINFO TV_INSERTSTRUCT TV_ITEM TV_KEYDOWN TV_SORTCB UDACCEL ULARGE_INTEGER UNIVERSAL_NAME_INFO UNLOAD_DLL_DEBUG_INFO USE_INFO_0 USE_INFO_1 USE_INFO_2 USER_INFO_0 USER_INFO_1 USER_INFO_2 USER_INFO_3 USER_INFO_10 USER_INFO_11 USER_INFO_20 USER_INFO_21 USER_INFO_22 USER_INFO_1003 USER_INFO_1005 USER_INFO_1006 USER_INFO_1007 USER_INFO_1008 USER_INFO_1009 USER_INFO_1010 USER_INFO_1011 USER_INFO_1012 USER_INFO_1013 USER_INFO_1014 USER_INFO_1017 USER_INFO_1018 USER_INFO_1020 USER_INFO_1023 USER_INFO_1024 USER_INFO_1025 USER_INFO_1051 USER_INFO_1052 USER_INFO_1053 USER_MODALS_INFO_0 USER_MODALS_INFO_1 USER_MODALS_INFO_2 USER_MODALS_INFO_3 USER_MODALS_INFO_1001 USER_MODALS_INFO_1002 USER_MODALS_INFO_1003 USER_MODALS_INFO_1004 USER_MODALS_INFO_1005 USER_MODALS_INFO_1006 USER_MODALS_INFO_1007 USEROBJECTFLAGS USER_OTHER_INFO VALENT VarFileInfo VERIFY_INFORMATION VS_FIXEDFILEINFO VS_VERSION_INFO WIN32_FILE_ATTRIBUTE_DATA WIN32_FIND_DATA WIN32_STREAM_ID WIN_CERTIFICATE WIN_TRUST_ACTDATA_CONTEXT_WITH_SUBJECT WIN_TRUST_ACTDATA_SUBJECT_ONLY WIN_TRUST_SUBJECT_FILE WIN_TRUST_SIP_SUBJECT WINDOW_BUFFER_SIZE_RECORD WINDOWPLACEMENT WINDOWPOS WINTRUST_CLIENT_TP_DISPATCH_TABLE WINTRUST_CLIENT_TP_INFO WINTRUST_PROVIDER_CLIENT_INFO WINTRUST_PROVIDER_CLIENT_SERVICES WINTRUST_PROVIDER_SERVER_INFO WINTRUST_PROVIDER_SERVER_SERVICES WINTRUST_SERVER_TP_DISPATCH_TABLE WINTRUST_SERVER_TP_INFO WINTRUST_SIP_DISPATCH_TABLE WINTRUST_SIP_INFO WKSTA_INFO_100 WKSTA_INFO_101 WKSTA_INFO_102 WKSTA_INFO_302 WKSTA_INFO_402 WKSTA_TRANSPORT_INFO_0 WKSTA_USER_INFO_0 WKSTA_USER_INFO_1 WKSTA_USER_INFO_1101 WNDCLASS WNDCLASSEX XFORM ACCESS_MODE ACL_INFORMATION_CLASS FD_FLAGS GET_FILEEX_INFO_LEVELS MEDIA_TYPE MULTIPLE_TRUSTEE_OPERATION RASCONNSTATE RASPROJECTION SE_OBJECT_TYPE SECURITY_IMPERSONATION_LEVEL SHCONTF SHGNO SID_NAME_USE TOKEN_INFORMATION_CLASS TOKEN_TYPE TRUSTEE_FORM TRUSTEE_TYPE Animate_Close Animate_Create Animate_Open Animate_Play Animate_Seek Animate_Stop CMYK FORWARD_WM_NOTIFY GetBValue GetCValue GetGValue GetKValue GetMValue GetRValue GetYValue HANDLE_WM_NOTIFY hasOverlappedIoCompleted Header_DeleteItem Header_GetItem Header_GetItemCount Header_InsertItem Header_Layout Header_SetItem HIBYTE HIWORD ImageList_AddIcon INDEXTOOVERLAYMASK INDEXTOSTATEIMAGEMASK LANGIDFROMLCID ListView_Arrange ListView_CreateDragImage ListView_DeleteAllItems ListView_DeleteColumn ListView_DeleteItem ListView_EditLabel ListView_EnsureVisible ListView_FindItem ListView_GetBkColor ListView_GetCallbackMask ListView_GetColumn ListView_GetColumnWidth ListView_GetCountPerPage ListView_GetEditControl ListView_GetImageList ListView_GetISearchString ListView_GetItem ListView_GetItemCount ListView_GetItemPosition ListView_GetItemRect ListView_GetItemSpacing ListView_GetItemState ListView_GetItemText ListView_GetNextItem ListView_GetOrigin ListView_GetSelectedCount ListView_GetStringWidth ListView_GetTextBkColor ListView_GetTextColor ListView_GetTopIndex ListView_GetViewRect ListView_HitTest ListView_InsertColumn ListView_InsertItem ListView_Scroll ListView_SetBkColor ListView_SetCallbackMask ListView_SetColumn ListView_SetColumnWidth ListView_SetImageList ListView_SetItem ListView_SetItemCount ListView_SetItemPosition ListView_SetItemPosition32 ListView_SetItemState ListView_SetItemText ListView_SetTextBkColor ListView_SetTextColor ListView_SortItems ListView_Update LOBYTE LOWORD MAKEINTATOM MAKEINTRESOURCE MAKELANGID MAKELCID MAKELONG MAKELPARAM MAKELRESULT MAKEPOINTS MAKEROP4 MAKEWORD PALETTEINDEX PALETTERGB POINTSTOPOINT POINTTOPOINTS PRIMARYLANGID PropSheet_AddPage PropSheet_Apply PropSheet_CancelToClose PropSheet_Changed PropSheet_GetCurrentPageHwnd PropSheet_GetTabControl PropSheet_IsDialogMessage PropSheet_PressButton PropSheet_QuerySiblings PropSheet_RebootSystem PropSheet_RemovePage PropSheet_RestartWindows PropSheet_SetCurSel PropSheet_SetCurSelByID PropSheet_SetFinishText PropSheet_SetTitle PropSheet_SetWizButtons PropSheet_UnChanged RGB SOANGLETENTHS SOPALETTEINDEX SOPALETTERGB SORGB SOSETRATIO SORTIDFROMLCID SUBLANGID TabCtrl_AdjustRect TabCtrl_DeleteAllItems TabCtrl_DeleteItem TabCtrl_GetCurFocus TabCtrl_GetCurSel TabCtrl_GetImageList TabCtrl_GetItem TabCtrl_GetItemCount TabCtrl_GetItemRect TabCtrl_GetRowCount TabCtrl_GetToolTips TabCtrl_HitTest TabCtrl_InsertItem TabCtrl_RemoveImage TabCtrl_SetCurFocus TabCtrl_SetCurSel TabCtrl_SetImageList TabCtrl_SetItem TabCtrl_SetItemExtra TabCtrl_SetItemSize TabCtrl_SetPadding TabCtrl_SetToolTips TreeView_CreateDragImage TreeView_DeleteAllItems TreeView_DeleteItem TreeView_EditLabel TreeView_EndEditLabelNow TreeView_EnsureVisible TreeView_Expand TreeView_GetChild TreeView_GetCount TreeView_GetDropHilite TreeView_GetEditControl TreeView_GetFirstVisible TreeView_GetImageList TreeView_GetIndent TreeView_GetISearchString TreeView_GetItem TreeView_GetItemRect TreeView_GetNextItem TreeView_GetNextSibling TreeView_GetNextVisible TreeView_GetParent TreeView_GetPrevSibling TreeView_GetPrevVisible TreeView_GetRoot TreeView_GetSelection TreeView_GetVisibleCount TreeView_HitTest TreeView_InsertItem TreeView_Select TreeView_SelectItem TreeView_SelectDropTarget TreeView_SelectSetFirstVisible TreeView_SetImageList TreeView_SetIndent TreeView_SetItem TreeView_SortChildren TreeView_SortChildrenCB XTYP_ADVDATA XTYP_ADVREQ XTYP_ADVSTART XTYP_ADVSTOP XTYP_CONNECT XTYP_CONNECT_CONFIRM XTYP_DISCONNECT XTYP_ERROR XTYP_EXECUTE XTYP_MONITOR XTYP_POKE XTYP_REGISTER XTYP_REQUEST XTYP_UNREGISTER XTYP_WILDCONNECT XTYP_XACT_COMPLETE STRICT ULONG PULONG USHORT PUSHORT UCHAR PUCHAR PSZ NULL FALSE TRUE IN OUT OPTIONAL pascal CDECL CALLBACK WINAPI WINAPIV APIENTRY APIPRIVATE PASCAL FAR NEAR CONST DWORD BOOL BYTE WORD FLOAT PFLOAT PBOOL LPBOOL PBYTE LPBYTE PINT LPINT PWORD LPWORD LPLONG PDWORD LPDWORD LPVOID LPCVOID INT UINT PUINT WPARAM LPARAM LRESULT SPHANDLE LPHANDLE HGLOBAL HLOCAL GLOBALHANDLE LOCALHANDLE FARPROC NEARPROC PROC HKEY PHKEY HMETAFILE HINSTANCE HMODULE HRGN HRSRC HSPRITE HLSURF HSTR HTASK HWINSTA HKL HFILE MAKEWORD MAKELONG LOWORD HIWORD LOBYTE HIBYTE FILETIME PFILETIME LPFILETIME HWND HMENU HFONT HBRUSH WCHAR POINT ATOM INT_PTR _In_ _Out_ LPWSTR HACCEL MSG ACCELERATORS ALT AUTO3STATE AUTOCHECKBOX AUTORADIOBUTTON BEGIN BITMAP BLOCK BUTTON CAPTION CHARACTERISTICS CHECKBOX CLASS COMBOBOX CONTROL CTEXT CURSOR DEFPUSHBUTTON DIALOG DIALOGEX DISCARDABLE EDITTEXT END EXSTYLE FONT GROUPBOX ICON LANGUAGE LISTBOX LTEXT MENU MENUEX MENUITEM MESSAGETABLE POPUP PUSHBUTTON RADIOBUTTON RCDATA RTEXT SCROLLBAR SEPARATOR SHIFT STATE3 STRINGTABLE STYLE TEXTINCLUDE VALUE VERSION VERSIONINFO VIRTKEY"
  return autocomplete_set
end

function cpp.get_calltip()
  local calltip_add =
  {
    "__acrt_iob_func|__cdecl __acrt_iob_func(unsigned index);",
    "__iob_func|__cdecl __iob_func(void);",
    "__ms_sscanf|__cdecl __ms_sscanf(const char*  __restrict__ _Src,const char*  __restrict__ _Format,...);",
    "__ms_scanf|__cdecl __ms_scanf(const char*  __restrict__ _Format,...);",
    "__ms_fscanf|__cdecl __ms_fscanf(FILE*  __restrict__ _File,const char*  __restrict__ _Format,...);",
    "__ms_printf|__cdecl __ms_printf(const char*  __restrict__ , ... );",
    "__ms_vprintf|__cdecl __ms_vprintf (const char*  __restrict__ , va_list);",
    "__ms_fprintf|__cdecl __ms_fprintf (FILE*  __restrict__ , const char*  __restrict__ , ...);",
    "__ms_vfprintf|__cdecl __ms_vfprintf (FILE*  __restrict__ , const char*  __restrict__ , va_list);",
    "__ms_sprintf|__cdecl __ms_sprintf (char*  __restrict__ , const char*  __restrict__ , ...);",
    "__ms_vsprintf|__cdecl __ms_vsprintf (char*  __restrict__ , const char*  __restrict__ , va_list);",
    "__stdio_common_vsprintf|__cdecl __stdio_common_vsprintf(unsigned __int64 options, char* str, size_t len, const char* format, _locale_t locale, va_list valist);",
    "__stdio_common_vfprintf|__cdecl __stdio_common_vfprintf(unsigned __int64 options, FILE* file, const char* format, _locale_t locale, va_list valist);",
    "__stdio_common_vsscanf|__cdecl __stdio_common_vsscanf(unsigned __int64 options, const char* input, size_t length, const char* format, _locale_t locale, va_list valist);",
    "__stdio_common_vfscanf|__cdecl __stdio_common_vfscanf(unsigned __int64 options, FILE* file, const char* format, _locale_t locale, va_list valist);",
    "fprintf|__cdecl fprintf(FILE*  __restrict__ _File,const char*  __restrict__ _Format,...);",
    "printf|__cdecl printf(const char*  __restrict__ _Format,...);",
    "sprintf|__cdecl sprintf(char*  __restrict__ _Dest,const char*  __restrict__ _Format,...);",
    "vfprintf|__cdecl vfprintf(FILE*  __restrict__ _File,const char*  __restrict__ _Format,va_list _ArgList);",
    "vprintf|__cdecl vprintf(const char*  __restrict__ _Format,va_list _ArgList);",
    "vsprintf|__cdecl vsprintf(char*  __restrict__ _Dest,const char*  __restrict__ _Format,va_list _Args);",
    "fscanf|__cdecl fscanf(FILE*  __restrict__ _File,const char*  __restrict__ _Format,...);",
    "scanf|__cdecl scanf(const char*  __restrict__ _Format,...);",
    "sscanf|__cdecl sscanf(const char*  __restrict__ _Src,const char*  __restrict__ _Format,...);",
    "vasprintf|__cdecl vasprintf(char**  __restrict__ _Ret,const char*  __restrict__ _Format,va_list _Args);",
    "asprintf|__cdecl asprintf(char**  __restrict__ _Ret,const char*  __restrict__ _Format,...);",
    "vfscanf|int vfscanf (FILE* __stream,  const char* __format, __builtin_va_list __local_argv);",
    "vsscanf|int vsscanf (const char*  __restrict__ __source, const char*  __restrict__ __format, __builtin_va_list __local_argv);",
    "vscanf|int vscanf(const char* __format,  __builtin_va_list __local_argv);",
    "__ms_vscanf|__cdecl __ms_vscanf(const char*  __restrict__ Format, va_list argp);",
    "__ms_vfscanf|__cdecl __ms_vfscanf (FILE*  __restrict__ fp, const char*  __restrict__ Format,va_list argp);",
    "__ms_vsscanf|__cdecl __ms_vsscanf (const char*  __restrict__ _Str,const char*  __restrict__ Format,va_list argp);",
    "_filbuf|__cdecl _filbuf(FILE* _File);",
    "_flsbuf|__cdecl _flsbuf(int _Ch,FILE* _File);",
    "_fsopen|__cdecl _fsopen(const char* _Filename,const char* _Mode);",
    "_fsopen|__cdecl _fsopen(const char* _Filename,const char* _Mode,int _ShFlag);",
    "clearerr|__cdecl clearerr(FILE* _File);",
    "fclose|__cdecl fclose(FILE* _File);",
    "_fcloseall|__cdecl _fcloseall(void);",
    "fdopen|__cdecl fdopen(int _FileHandle,const char* _Mode);",
    "_fdopen|__cdecl _fdopen(int _FileHandle,const char* _Mode);",
    "feof|__cdecl feof(FILE* _File);",
    "ferror|__cdecl ferror(FILE* _File);",
    "fflush|__cdecl fflush(FILE* _File);",
    "fgetc|__cdecl fgetc(FILE* _File);",
    "_fgetchar|__cdecl _fgetchar(void);",
    "fgets|__cdecl fgets(char*  __restrict__ _Buf,int _MaxCount,FILE*  __restrict__ _File);",
    "_fileno|__cdecl _fileno(FILE* _File);",
    "fileno|__cdecl fileno(FILE* _File);",
    "_tempnam|__cdecl _tempnam(const char* _DirName,const char* _FilePrefix);",
    "_flushall|__cdecl _flushall(void);",
    "fopen|__cdecl fopen(const char*  __restrict__ _Filename,const char*  __restrict__ _Mode);",
    "fopen64|FILE* fopen64(const char*  __restrict__ filename,const char*  __restrict__  mode);",
    "fputc|__cdecl fputc(int _Ch,FILE* _File);",
    "_fputchar|__cdecl _fputchar(int _Ch);",
    "fputs|__cdecl fputs(const char*  __restrict__ _Str,FILE*  __restrict__ _File);",
    "fread|__cdecl fread(void*  __restrict__ _DstBuf,size_t _ElementSize,size_t _Count,FILE*  __restrict__ _File);",
    "freopen|__cdecl freopen(const char*  __restrict__ _Filename,const char*  __restrict__ _Mode,FILE*  __restrict__ _File);",
    "fsetpos|__cdecl fsetpos(FILE* _File,const fpos_t* _Pos);",
    "fseek|__cdecl fseek(FILE* _File,long _Offset,int _Origin);",
    "ftell|__cdecl ftell(FILE* _File);",
    "_fseeki64|__cdecl _fseeki64(FILE* _File,__int64 _Offset,int _Origin);",
    "_ftelli64|__cdecl _ftelli64(FILE* _File);",
    "fseeko64|int fseeko64(FILE*  stream, _off64_t offset, int whence);",
    "fseeko|int fseeko(FILE*  stream, _off_t offset, int whence);",
    "ftello|_off_t ftello(FILE*  stream);",
    "ftello64|_off64_t ftello64(FILE*  stream);",
    "fwrite|__cdecl fwrite(const void*  __restrict__ _Str,size_t _Size,size_t _Count,FILE*  __restrict__ _File);",
    "getc|__cdecl getc(FILE* _File);",
    "getchar|__cdecl getchar(void);",
    "_getmaxstdio|__cdecl _getmaxstdio(void);",
    "gets|__cdecl gets(char* _Buffer);",
    "_getw|__cdecl _getw(FILE* _File);",
    "perror|__cdecl perror(const char* _ErrMsg);",
    "_pclose|__cdecl _pclose(FILE* _File);",
    "_popen|__cdecl _popen(const char* _Command,const char* _Mode);",
    "putc|__cdecl putc(int _Ch,FILE* _File);",
    "putchar|__cdecl putchar(int _Ch);",
    "puts|__cdecl puts(const char* _Str);",
    "_putw|__cdecl _putw(int _Word,FILE* _File);",
    "remove|__cdecl remove(const char* _Filename);",
    "rename|__cdecl rename(const char* _OldFilename,const char* _NewFilename);",
    "_unlink|__cdecl _unlink(const char* _Filename);",
    "unlink|__cdecl unlink(const char* _Filename);",
    "rewind|__cdecl rewind(FILE* _File);",
    "_rmtmp|__cdecl _rmtmp(void);",
    "setbuf|__cdecl setbuf(FILE*  __restrict__ _File,char*  __restrict__ _Buffer);",
    "_setmaxstdio|__cdecl _setmaxstdio(int _Max);",
    "_set_output_format|__cdecl _set_output_format(unsigned int _Format);",
    "_get_output_format|__cdecl _get_output_format(void);",
    "setvbuf|__cdecl setvbuf(FILE*  __restrict__ _File,char*  __restrict__ _Buf,int _Mode,size_t _Size);",
    "_scprintf|__cdecl _scprintf(const char*  __restrict__ _Format,...);",
    "_snscanf|__cdecl _snscanf(const char*  __restrict__ _Src,size_t _MaxCount,const char*  __restrict__ _Format,...);",
    "tmpfile|__cdecl tmpfile(void);",
    "tmpnam|__cdecl tmpnam(char* _Buffer);",
    "ungetc|__cdecl ungetc(int _Ch,FILE* _File);",
    "_vsnprintf|__cdecl _vsnprintf(char*  __restrict__ _Dest,size_t _Count,const char*  __restrict__ _Format,va_list _Args);",
    "_snprintf|__cdecl _snprintf(char*  __restrict__ _Dest,size_t _Count,const char*  __restrict__ _Format,...);",
    "__gets_chk|__cdecl __gets_chk(char* , size_t);",
    "vsnprintf|int vsnprintf (char*  __restrict__ __stream, size_t __n, const char*  __restrict__ __format, va_list __local_argv);",
    "snprintf|int snprintf (char*  __restrict__ __stream, size_t __n, const char*  __restrict__ __format, ...);",
    "__ms_snprintf|__cdecl __ms_snprintf(char*  __restrict__ s, size_t n, const char*  __restrict__  format, ...);",
    "_vscprintf|__cdecl _vscprintf(const char*  __restrict__ _Format,va_list _ArgList);",
    "_set_printf_count_output|__cdecl _set_printf_count_output(int _Value);",
    "_get_printf_count_output|__cdecl _get_printf_count_output(void);",
    "__ms_swscanf|__cdecl __ms_swscanf(const wchar_t*  __restrict__ _Src,const wchar_t*  __restrict__ _Format,...);",
    "__ms_wscanf|__cdecl __ms_wscanf(const wchar_t*  __restrict__ _Format,...);",
    "__ms_fwscanf|__cdecl __ms_fwscanf(FILE*  __restrict__ _File,const wchar_t*  __restrict__ _Format,...);",
    "__ms_fwprintf|__cdecl __ms_fwprintf(FILE*  __restrict__ _File,const wchar_t*  __restrict__ _Format,...);",
    "__ms_wprintf|__cdecl __ms_wprintf(const wchar_t*  __restrict__ _Format,...);",
    "__ms_vfwprintf|__cdecl __ms_vfwprintf(FILE*  __restrict__ _File,const wchar_t*  __restrict__ _Format,va_list _ArgList);",
    "__ms_vwprintf|__cdecl __ms_vwprintf(const wchar_t*  __restrict__ _Format,va_list _ArgList);",
    "__ms_swprintf|__cdecl __ms_swprintf(wchar_t*  __restrict__ , const wchar_t*  __restrict__ , ...);",
    "__ms_vswprintf|__cdecl __ms_vswprintf(wchar_t*  __restrict__ , const wchar_t*  __restrict__ ,va_list);",
    "__stdio_common_vswprintf|__cdecl __stdio_common_vswprintf(unsigned __int64 options, wchar_t* str, size_t len, const wchar_t* format, _locale_t locale, va_list valist);",
    "__stdio_common_vfwprintf|__cdecl __stdio_common_vfwprintf(unsigned __int64 options, FILE* file, const wchar_t* format, _locale_t locale, va_list valist);",
    "__stdio_common_vswscanf|__cdecl __stdio_common_vswscanf(unsigned __int64 options, const wchar_t* input, size_t length, const wchar_t* format, _locale_t locale, va_list valist);",
    "__stdio_common_vfwscanf|__cdecl __stdio_common_vfwscanf(unsigned __int64 options, FILE* file, const wchar_t* format, _locale_t locale, va_list valist);",
    "fwscanf|__cdecl fwscanf(FILE*  __restrict__ _File,const wchar_t*  __restrict__ _Format,...);",
    "swscanf|__cdecl swscanf(const wchar_t*  __restrict__ _Src,const wchar_t*  __restrict__ _Format,...);",
    "wscanf|__cdecl wscanf(const wchar_t*  __restrict__ _Format,...);",
    "__ms_vwscanf|__cdecl __ms_vwscanf (const wchar_t*  __restrict__ , va_list);",
    "__ms_vfwscanf|__cdecl __ms_vfwscanf (FILE*  __restrict__ ,const wchar_t*  __restrict__ ,va_list);",
    "__ms_vswscanf|__cdecl __ms_vswscanf (const wchar_t*  __restrict__ ,const wchar_t*  __restrict__ ,va_list);",
    "fwprintf|__cdecl fwprintf(FILE*  __restrict__ _File,const wchar_t*  __restrict__ _Format,...);",
    "wprintf|__cdecl wprintf(const wchar_t*  __restrict__ _Format,...);",
    "vfwprintf|__cdecl vfwprintf(FILE*  __restrict__ _File,const wchar_t*  __restrict__ _Format,va_list _ArgList);",
    "vwprintf|__cdecl vwprintf(const wchar_t*  __restrict__ _Format,va_list _ArgList);",
    "_wfsopen|__cdecl _wfsopen(const wchar_t* _Filename,const wchar_t* _Mode);",
    "_wfsopen|__cdecl _wfsopen(const wchar_t* _Filename,const wchar_t* _Mode,int _ShFlag);",
    "fgetwc|__cdecl fgetwc(FILE* _File);",
    "_fgetwchar|__cdecl _fgetwchar(void);",
    "fputwc|__cdecl fputwc(wchar_t _Ch,FILE* _File);",
    "_fputwchar|__cdecl _fputwchar(wchar_t _Ch);",
    "getwc|__cdecl getwc(FILE* _File);",
    "getwchar|__cdecl getwchar(void);",
    "putwc|__cdecl putwc(wchar_t _Ch,FILE* _File);",
    "putwchar|__cdecl putwchar(wchar_t _Ch);",
    "ungetwc|__cdecl ungetwc(wint_t _Ch,FILE* _File);",
    "fgetws|__cdecl fgetws(wchar_t*  __restrict__ _Dst,int _SizeInWords,FILE*  __restrict__ _File);",
    "fputws|__cdecl fputws(const wchar_t*  __restrict__ _Str,FILE*  __restrict__ _File);",
    "_getws|__cdecl _getws(wchar_t* _String);",
    "_putws|__cdecl _putws(const wchar_t* _Str);",
    "_vsnwprintf|__cdecl _vsnwprintf(wchar_t*  __restrict__ _Dest,size_t _Count,const wchar_t*  __restrict__ _Format,va_list _Args);",
    "_scwprintf|__cdecl _scwprintf(const wchar_t*  __restrict__ _Format,...);",
    "_swprintf_c|__cdecl _swprintf_c(wchar_t*  __restrict__ _DstBuf,size_t _SizeInWords,const wchar_t*  __restrict__ _Format,...);",
    "_vswprintf_c|__cdecl _vswprintf_c(wchar_t*  __restrict__ _DstBuf,size_t _SizeInWords,const wchar_t*  __restrict__ _Format,va_list _ArgList);",
    "_snwprintf|__cdecl _snwprintf(wchar_t*  __restrict__ _Dest,size_t _Count,const wchar_t*  __restrict__ _Format,...);",
    "_vscwprintf|__cdecl _vscwprintf(const wchar_t*  __restrict__ _Format,va_list _ArgList);",
    "__ms_snwprintf|__cdecl __ms_snwprintf (wchar_t*  __restrict__ s, size_t n, const wchar_t*  __restrict__ format, ...);",
    "__ms_vsnwprintf|__cdecl __ms_vsnwprintf (wchar_t*  __restrict__ , size_t, const wchar_t*  __restrict__ , va_list);",
    "_swprintf|__cdecl _swprintf(wchar_t*  __restrict__ _Dest,const wchar_t*  __restrict__ _Format,...);",
    "_vswprintf|__cdecl _vswprintf(wchar_t*  __restrict__ _Dest,const wchar_t*  __restrict__ _Format,va_list _Args);",
    "_wtempnam|__cdecl _wtempnam(const wchar_t* _Directory,const wchar_t* _FilePrefix);",
    "_snwscanf|__cdecl _snwscanf(const wchar_t*  __restrict__ _Src,size_t _MaxCount,const wchar_t*  __restrict__ _Format,...);",
    "_wfdopen|__cdecl _wfdopen(int _FileHandle ,const wchar_t* _Mode);",
    "_wfopen|__cdecl _wfopen(const wchar_t*  __restrict__ _Filename,const wchar_t* __restrict__  _Mode);",
    "_wfreopen|__cdecl _wfreopen(const wchar_t*  __restrict__ _Filename,const wchar_t*  __restrict__ _Mode,FILE*  __restrict__ _OldFile);",
    "_wperror|__cdecl _wperror(const wchar_t* _ErrMsg);",
    "_wpopen|__cdecl _wpopen(const wchar_t* _Command,const wchar_t* _Mode);",
    "_wremove|__cdecl _wremove(const wchar_t* _Filename);",
    "_wtmpnam|__cdecl _wtmpnam(wchar_t* _Buffer);",
    "_fgetwc_nolock|__cdecl _fgetwc_nolock(FILE* _File);",
    "_fputwc_nolock|__cdecl _fputwc_nolock(wchar_t _Ch,FILE* _File);",
    "_ungetwc_nolock|__cdecl _ungetwc_nolock(wint_t _Ch,FILE* _File);",
    "_fgetc_nolock|__cdecl _fgetc_nolock(FILE* _File);",
    "_fputc_nolock|__cdecl _fputc_nolock(int _Char, FILE* _File);",
    "_getc_nolock|__cdecl _getc_nolock(FILE* _File);",
    "_putc_nolock|__cdecl _putc_nolock(int _Char, FILE* _File);",
    "_lock_file|__cdecl _lock_file(FILE* _File);",
    "_unlock_file|__cdecl _unlock_file(FILE* _File);",
    "_fclose_nolock|__cdecl _fclose_nolock(FILE* _File);",
    "_fflush_nolock|__cdecl _fflush_nolock(FILE* _File);",
    "_fread_nolock|__cdecl _fread_nolock(void*  __restrict__ _DstBuf,size_t _ElementSize,size_t _Count,FILE*  __restrict__ _File);",
    "_fseek_nolock|__cdecl _fseek_nolock(FILE* _File,long _Offset,int _Origin);",
    "_ftell_nolock|__cdecl _ftell_nolock(FILE* _File);",
    "_fseeki64_nolock|__cdecl _fseeki64_nolock(FILE* _File,__int64 _Offset,int _Origin);",
    "_ftelli64_nolock|__cdecl _ftelli64_nolock(FILE* _File);",
    "_fwrite_nolock|__cdecl _fwrite_nolock(const void*  __restrict__ _DstBuf,size_t _Size,size_t _Count,FILE*  __restrict__ _File);",
    "_ungetc_nolock|__cdecl _ungetc_nolock(int _Ch,FILE* _File);",
    "tempnam|__cdecl tempnam(const char* _Directory,const char* _FilePrefix);",
    "fcloseall|__cdecl fcloseall(void);",
    "fdopen|__cdecl fdopen(int _FileHandle,const char* _Format);",
    "fgetchar|__cdecl fgetchar(void);",
    "flushall|__cdecl flushall(void);",
    "fputchar|__cdecl fputchar(int _Ch);",
    "getw|__cdecl getw(FILE* _File);",
    "putw|__cdecl putw(int _Ch,FILE* _File);",
    "rmtmp|__cdecl rmtmp(void);",
    "_wspawnl|__cdecl _wspawnl(int _Mode,const wchar_t* _Filename,const wchar_t* _ArgList,...);",
    "_wspawnle|__cdecl _wspawnle(int _Mode,const wchar_t* _Filename,const wchar_t* _ArgList,...);",
    "_wspawnlp|__cdecl _wspawnlp(int _Mode,const wchar_t* _Filename,const wchar_t* _ArgList,...);",
    "_wspawnlpe|__cdecl _wspawnlpe(int _Mode,const wchar_t* _Filename,const wchar_t* _ArgList,...);",
    "_wspawnv|__cdecl _wspawnv(int _Mode,const wchar_t* _Filename,const wchar_t* const* _ArgList);",
    "_wspawnve|__cdecl _wspawnve(int _Mode,const wchar_t* _Filename,const wchar_t* const* _ArgList,const wchar_t* const* _Env);",
    "_wspawnvp|__cdecl _wspawnvp(int _Mode,const wchar_t* _Filename,const wchar_t* const* _ArgList);",
    "_wspawnvpe|__cdecl _wspawnvpe(int _Mode,const wchar_t* _Filename,const wchar_t* const* _ArgList,const wchar_t* const* _Env);",
    "_spawnv|__cdecl _spawnv(int _Mode,const char* _Filename,const char* const* _ArgList);",
    "_spawnve|__cdecl _spawnve(int _Mode,const char* _Filename,const char* const* _ArgList,const char* const* _Env);",
    "_spawnvp|__cdecl _spawnvp(int _Mode,const char* _Filename,const char* const* _ArgList);",
    "_spawnvpe|__cdecl _spawnvpe(int _Mode,const char* _Filename,const char* const* _ArgList,const char* const* _Env);",
    "_memccpy|__cdecl _memccpy(void* _Dst,const void* _Src,int _Val,size_t _MaxCount);",
    "memchr|__cdecl memchr(const void* _Buf ,int _Val,size_t _MaxCount);",
    "_memicmp|__cdecl _memicmp(const void* _Buf1,const void* _Buf2,size_t _Size);",
    "_memicmp_l|__cdecl _memicmp_l(const void* _Buf1,const void* _Buf2,size_t _Size,_locale_t _Locale);",
    "memcmp|__cdecl memcmp(const void* _Buf1,const void* _Buf2,size_t _Size);",
    "memcpy|__cdecl memcpy(void*  __restrict__ _Dst,const void*  __restrict__ _Src,size_t _Size);",
    "memcpy_s|__cdecl memcpy_s (void* _dest,size_t _numberOfElements,const void* _src,size_t _count);",
    "mempcpy|__cdecl mempcpy (void* _Dst, const void* _Src, size_t _Size);",
    "memset|__cdecl memset(void* _Dst,int _Val,size_t _Size);",
    "memccpy|__cdecl memccpy(void* _Dst,const void* _Src,int _Val,size_t _Size);",
    "memicmp|__cdecl memicmp(const void* _Buf1,const void* _Buf2,size_t _Size);",
    "_strset|__cdecl _strset(char* _Str,int _Val);",
    "_strset_l|__cdecl _strset_l(char* _Str,int _Val,_locale_t _Locale);",
    "strcpy|__cdecl strcpy(char*  __restrict__ _Dest,const char*  __restrict__ _Source);",
    "strcat|__cdecl strcat(char*  __restrict__ _Dest,const char*  __restrict__ _Source);",
    "strcmp|__cdecl strcmp(const char* _Str1,const char* _Str2);",
    "strlen|__cdecl strlen(const char* _Str);",
    "strnlen|__cdecl strnlen(const char* _Str,size_t _MaxCount);",
    "memmove|__cdecl memmove(void* _Dst,const void* _Src,size_t _Size);",
    "_strdup|__cdecl _strdup(const char* _Src);",
    "strchr|__cdecl strchr(const char* _Str,int _Val);",
    "_stricmp|__cdecl _stricmp(const char* _Str1,const char* _Str2);",
    "_strcmpi|__cdecl _strcmpi(const char* _Str1,const char* _Str2);",
    "_stricmp_l|__cdecl _stricmp_l(const char* _Str1,const char* _Str2,_locale_t _Locale);",
    "strcoll|__cdecl strcoll(const char* _Str1,const char* _Str2);",
    "_strcoll_l|__cdecl _strcoll_l(const char* _Str1,const char* _Str2,_locale_t _Locale);",
    "_stricoll|__cdecl _stricoll(const char* _Str1,const char* _Str2);",
    "_stricoll_l|__cdecl _stricoll_l(const char* _Str1,const char* _Str2,_locale_t _Locale);",
    "_strncoll|__cdecl _strncoll (const char* _Str1,const char* _Str2,size_t _MaxCount);",
    "_strncoll_l|__cdecl _strncoll_l(const char* _Str1,const char* _Str2,size_t _MaxCount,_locale_t _Locale);",
    "_strnicoll|__cdecl _strnicoll (const char* _Str1,const char* _Str2,size_t _MaxCount);",
    "_strnicoll_l|__cdecl _strnicoll_l(const char* _Str1,const char* _Str2,size_t _MaxCount,_locale_t _Locale);",
    "strcspn|__cdecl strcspn(const char* _Str,const char* _Control);",
    "_strerror|__cdecl _strerror(const char* _ErrMsg);",
    "strerror|__cdecl strerror(int);",
    "_strlwr|__cdecl _strlwr(char* _String);",
    "strlwr_l|char* strlwr_l(char* _String,_locale_t _Locale);",
    "strncat|__cdecl strncat(char*  __restrict__ _Dest,const char*  __restrict__ _Source,size_t _Count);",
    "strncmp|__cdecl strncmp(const char* _Str1,const char* _Str2,size_t _MaxCount);",
    "_strnicmp|__cdecl _strnicmp(const char* _Str1,const char* _Str2,size_t _MaxCount);",
    "_strnicmp_l|__cdecl _strnicmp_l(const char* _Str1,const char* _Str2,size_t _MaxCount,_locale_t _Locale);",
    "strncpy|char* strncpy(char*  __restrict__ _Dest,const char*  __restrict__ _Source,size_t _Count);",
    "_strnset|__cdecl _strnset(char* _Str,int _Val,size_t _MaxCount);",
    "_strnset_l|__cdecl _strnset_l(char* str,int c,size_t count,_locale_t _Locale);",
    "strpbrk|__cdecl strpbrk(const char* _Str,const char* _Control);",
    "strrchr|__cdecl strrchr(const char* _Str,int _Ch);",
    "_strrev|__cdecl _strrev(char* _Str);",
    "strspn|__cdecl strspn(const char* _Str,const char* _Control);",
    "strstr|__cdecl strstr(const char* _Str,const char* _SubStr);",
    "strtok|__cdecl strtok(char*  __restrict__ _Str,const char*  __restrict__ _Delim);",
    "strtok_r|char* strtok_r(char*  __restrict__ _Str, const char*  __restrict__ _Delim, char**  __restrict__ __last);",
    "_strupr|__cdecl _strupr(char* _String);",
    "_strupr_l|char* _strupr_l(char* _String,_locale_t _Locale);",
    "strxfrm|__cdecl strxfrm(char*  __restrict__ _Dst,const char*  __restrict__ _Src,size_t _MaxCount);",
    "_strxfrm_l|__cdecl _strxfrm_l(char*  __restrict__ _Dst,const char*  __restrict__ _Src,size_t _MaxCount,_locale_t _Locale);",
    "strdup|__cdecl strdup(const char* _Src);",
    "strcmpi|__cdecl strcmpi(const char* _Str1,const char* _Str2);",
    "stricmp|__cdecl stricmp(const char* _Str1,const char* _Str2);",
    "strlwr|__cdecl strlwr(char* _Str);",
    "strnicmp|__cdecl strnicmp(const char* _Str1,const char* _Str,size_t _MaxCount);",
    "strncasecmp|__cdecl strncasecmp (const char* , const char* , size_t);",
    "strcasecmp|__cdecl strcasecmp (const char* , const char* );",
    "strnset|__cdecl strnset(char* _Str,int _Val,size_t _MaxCount);",
    "strrev|__cdecl strrev(char* _Str);",
    "strset|__cdecl strset(char* _Str,int _Val);",
    "strupr|__cdecl strupr(char* _Str);",
    "_wcsdup|__cdecl _wcsdup(const wchar_t* _Str);",
    "wcscat|__cdecl wcscat(wchar_t*  __restrict__ _Dest,const wchar_t*  __restrict__ _Source);",
    "wcschr|__cdecl wcschr(const wchar_t* _Str,wchar_t _Ch);",
    "wcscmp|__cdecl wcscmp(const wchar_t* _Str1,const wchar_t* _Str2);",
    "wcscpy|__cdecl wcscpy(wchar_t*  __restrict__ _Dest,const wchar_t*  __restrict__ _Source);",
    "wcscspn|__cdecl wcscspn(const wchar_t* _Str,const wchar_t* _Control);",
    "wcslen|__cdecl wcslen(const wchar_t* _Str);",
    "wcsnlen|__cdecl wcsnlen(const wchar_t* _Src,size_t _MaxCount);",
    "wcsncat|wchar_t* wcsncat(wchar_t*  __restrict__ _Dest,const wchar_t*  __restrict__ _Source,size_t _Count);",
    "wcsncmp|__cdecl wcsncmp(const wchar_t* _Str1,const wchar_t* _Str2,size_t _MaxCount);",
    "wcsncpy|wchar_t* wcsncpy(wchar_t*  __restrict__ _Dest,const wchar_t*  __restrict__ _Source,size_t _Count);",
    "_wcsncpy_l|__cdecl _wcsncpy_l(wchar_t*  __restrict__ _Dest,const wchar_t*  __restrict__ _Source,size_t _Count,_locale_t _Locale);",
    "wcspbrk|__cdecl wcspbrk(const wchar_t* _Str,const wchar_t* _Control);",
    "wcsrchr|__cdecl wcsrchr(const wchar_t* _Str,wchar_t _Ch);",
    "wcsspn|__cdecl wcsspn(const wchar_t* _Str,const wchar_t* _Control);",
    "wcsstr|__cdecl wcsstr(const wchar_t* _Str,const wchar_t* _SubStr);",
    "wcstok|__cdecl wcstok(wchar_t*  __restrict__ _Str,const wchar_t*  __restrict__ _Delim);",
    "_wcserror|__cdecl _wcserror(int _ErrNum);",
    "__wcserror|__cdecl __wcserror(const wchar_t* _Str);",
    "_wcsicmp|__cdecl _wcsicmp(const wchar_t* _Str1,const wchar_t* _Str2);",
    "_wcsicmp_l|__cdecl _wcsicmp_l(const wchar_t* _Str1,const wchar_t* _Str2,_locale_t _Locale);",
    "_wcsnicmp|__cdecl _wcsnicmp(const wchar_t* _Str1,const wchar_t* _Str2,size_t _MaxCount);",
    "_wcsnicmp_l|__cdecl _wcsnicmp_l(const wchar_t* _Str1,const wchar_t* _Str2,size_t _MaxCount,_locale_t _Locale);",
    "_wcsnset|__cdecl _wcsnset(wchar_t* _Str,wchar_t _Val,size_t _MaxCount);",
    "_wcsrev|__cdecl _wcsrev(wchar_t* _Str);",
    "_wcsset|__cdecl _wcsset(wchar_t* _Str,wchar_t _Val);",
    "_wcslwr|__cdecl _wcslwr(wchar_t* _String);",
    "_wcslwr_l|wchar_t* _wcslwr_l(wchar_t* _String,_locale_t _Locale);",
    "_wcsupr|__cdecl _wcsupr(wchar_t* _String);",
    "_wcsupr_l|wchar_t* _wcsupr_l(wchar_t* _String,_locale_t _Locale);",
    "wcsxfrm|__cdecl wcsxfrm(wchar_t*  __restrict__ _Dst,const wchar_t*  __restrict__ _Src,size_t _MaxCount);",
    "_wcsxfrm_l|__cdecl _wcsxfrm_l(wchar_t*  __restrict__ _Dst,const wchar_t*  __restrict__ _Src,size_t _MaxCount,_locale_t _Locale);",
    "wcscoll|__cdecl wcscoll(const wchar_t* _Str1,const wchar_t* _Str2);",
    "_wcscoll_l|__cdecl _wcscoll_l(const wchar_t* _Str1,const wchar_t* _Str2,_locale_t _Locale);",
    "_wcsicoll|__cdecl _wcsicoll(const wchar_t* _Str1,const wchar_t* _Str2);",
    "_wcsicoll_l|__cdecl _wcsicoll_l(const wchar_t* _Str1,const wchar_t* _Str2,_locale_t _Locale);",
    "_wcsncoll|__cdecl _wcsncoll(const wchar_t* _Str1,const wchar_t* _Str2,size_t _MaxCount);",
    "_wcsncoll_l|__cdecl _wcsncoll_l(const wchar_t* _Str1,const wchar_t* _Str2,size_t _MaxCount,_locale_t _Locale);",
    "_wcsnicoll|__cdecl _wcsnicoll(const wchar_t* _Str1,const wchar_t* _Str2,size_t _MaxCount);",
    "_wcsnicoll_l|__cdecl _wcsnicoll_l(const wchar_t* _Str1,const wchar_t* _Str2,size_t _MaxCount,_locale_t _Locale);",
    "wcsdup|__cdecl wcsdup(const wchar_t* _Str);",
    "wcsicmp|__cdecl wcsicmp(const wchar_t* _Str1,const wchar_t* _Str2);",
    "wcsnicmp|__cdecl wcsnicmp(const wchar_t* _Str1,const wchar_t* _Str2,size_t _MaxCount);",
    "wcsnset|__cdecl wcsnset(wchar_t* _Str,wchar_t _Val,size_t _MaxCount);",
    "wcsrev|__cdecl wcsrev(wchar_t* _Str);",
    "wcsset|__cdecl wcsset(wchar_t* _Str,wchar_t _Val);",
    "wcslwr|__cdecl wcslwr(wchar_t* _Str);",
    "wcsupr|__cdecl wcsupr(wchar_t* _Str);",
    "wcsicoll|__cdecl wcsicoll(const wchar_t* _Str1,const wchar_t* _Str2);",
    "___mb_cur_max_func|__cdecl ___mb_cur_max_func(void);",
    "_set_purecall_handler|__cdecl _set_purecall_handler(_purecall_handler _Handler);",
    "_get_purecall_handler|__cdecl _get_purecall_handler(void);",
    "_set_invalid_parameter_handler|__cdecl _set_invalid_parameter_handler(_invalid_parameter_handler _Handler);",
    "_get_invalid_parameter_handler|__cdecl _get_invalid_parameter_handler(void);",
    "_errno|__cdecl _errno(void);",
    "_set_errno|__cdecl _set_errno(int _Value);",
    "_get_errno|__cdecl _get_errno(int* _Value);",
    "__doserrno|__cdecl __doserrno(void);",
    "_set_doserrno|__cdecl _set_doserrno(unsigned long _Value);",
    "_get_doserrno|__cdecl _get_doserrno(unsigned long* _Value);",
    "__sys_errlist|__cdecl __sys_errlist(void);",
    "__sys_nerr|__cdecl __sys_nerr(void);",
    "__declspec|extern __declspec(dllimport) char* _sys_errlist[1];",
    "__declspec|extern __declspec(dllimport) int _sys_nerr;",
    "__p___argv|__cdecl __p___argv(void);",
    "__p__fmode|__cdecl __p__fmode(void);",
    "__p___argc|__cdecl __p___argc(void);",
    "__p___wargv|__cdecl __p___wargv(void);",
    "__p__environ|__cdecl __p__environ(void);",
    "__p__wenviron|__cdecl __p__wenviron(void);",
    "__p__pgmptr|__cdecl __p__pgmptr(void);",
    "__p__wpgmptr|__cdecl __p__wpgmptr(void);",
    "_get_pgmptr|__cdecl _get_pgmptr(char** _Value);",
    "_get_wpgmptr|__cdecl _get_wpgmptr(wchar_t** _Value);",
    "_set_fmode|__cdecl _set_fmode(int _Mode);",
    "_get_fmode|__cdecl _get_fmode(int* _PMode);",
    "_get_environ|__cdecl _get_environ(char*** );",
    "_get_wenviron|__cdecl _get_wenviron(wchar_t*** );",
    "_get_osplatform|__cdecl _get_osplatform(unsigned int* _Value);",
    "_get_osver|__cdecl _get_osver(unsigned int* _Value);",
    "_get_winver|__cdecl _get_winver(unsigned int* _Value);",
    "_get_winmajor|__cdecl _get_winmajor(unsigned int* _Value);",
    "_get_winminor|__cdecl _get_winminor(unsigned int* _Value);",
    "_CountofType|UNALIGNED _CountofType (&_Array)[_SizeOfArray]))[_SizeOfArray];",
    "exit|__MINGW_NOTHROW exit(int _Code);",
    "_exit|__MINGW_NOTHROW _exit(int _Code);",
    "quick_exit|__MINGW_NOTHROW quick_exit(int _Code);",
    "_Exit|__cdecl _Exit(int);",
    "_set_abort_behavior|__cdecl _set_abort_behavior(unsigned int _Flags,unsigned int _Mask);",
    "abs|__cdecl abs(int _X);",
    "labs|__cdecl labs(long _X);",
    "_abs64|__cdecl _abs64(__int64);",
    "atexit|__cdecl atexit(void (__cdecl* )(void));",
    "at_quick_exit|__cdecl at_quick_exit(void (__cdecl* )(void));",
    "atof|__cdecl atof(const char* _String);",
    "_atof_l|__cdecl _atof_l(const char* _String,_locale_t _Locale);",
    "atoi|__cdecl atoi(const char* _Str);",
    "_atoi_l|__cdecl _atoi_l(const char* _Str,_locale_t _Locale);",
    "atol|__cdecl atol(const char* _Str);",
    "_atol_l|__cdecl _atol_l(const char* _Str,_locale_t _Locale);",
    "bsearch|__cdecl bsearch(const void* _Key,const void* _Base,size_t _NumOfElements,size_t _SizeOfElements,int (__cdecl* _PtFuncCompare)(const void* ,const void* ));",
    "qsort|__cdecl qsort(void* _Base,size_t _NumOfElements,size_t _SizeOfElements,int (__cdecl* _PtFuncCompare)(const void* ,const void* ));",
    "_byteswap_ushort|__cdecl _byteswap_ushort(unsigned short _Short);",
    "_byteswap_ulong|__cdecl _byteswap_ulong (unsigned long _Long);",
    "_byteswap_uint64|__cdecl _byteswap_uint64(unsigned __int64 _Int64);",
    "div|__cdecl div(int _Numerator,int _Denominator);",
    "getenv|__cdecl getenv(const char* _VarName);",
    "_itoa|__cdecl _itoa(int _Value,char* _Dest,int _Radix);",
    "_i64toa|__cdecl _i64toa(__int64 _Val,char* _DstBuf,int _Radix);",
    "_ui64toa|__cdecl _ui64toa(unsigned __int64 _Val,char* _DstBuf,int _Radix);",
    "_atoi64|__cdecl _atoi64(const char* _String);",
    "_atoi64_l|__cdecl _atoi64_l(const char* _String,_locale_t _Locale);",
    "_strtoi64|__cdecl _strtoi64(const char* _String,char** _EndPtr,int _Radix);",
    "_strtoi64_l|__cdecl _strtoi64_l(const char* _String,char** _EndPtr,int _Radix,_locale_t _Locale);",
    "_strtoui64|__cdecl _strtoui64(const char* _String,char** _EndPtr,int _Radix);",
    "_strtoui64_l|__cdecl _strtoui64_l(const char* _String,char** _EndPtr,int _Radix,_locale_t _Locale);",
    "ldiv|__cdecl ldiv(long _Numerator,long _Denominator);",
    "_ltoa|__cdecl _ltoa(long _Value,char* _Dest,int _Radix);",
    "mblen|__cdecl mblen(const char* _Ch,size_t _MaxCount);",
    "_mblen_l|__cdecl _mblen_l(const char* _Ch,size_t _MaxCount,_locale_t _Locale);",
    "_mbstrlen|__cdecl _mbstrlen(const char* _Str);",
    "_mbstrlen_l|__cdecl _mbstrlen_l(const char* _Str,_locale_t _Locale);",
    "_mbstrnlen|__cdecl _mbstrnlen(const char* _Str,size_t _MaxCount);",
    "_mbstrnlen_l|__cdecl _mbstrnlen_l(const char* _Str,size_t _MaxCount,_locale_t _Locale);",
    "mbtowc|__cdecl mbtowc(wchar_t*  __restrict__ _DstCh,const char*  __restrict__ _SrcCh,size_t _SrcSizeInBytes);",
    "_mbtowc_l|__cdecl _mbtowc_l(wchar_t*  __restrict__ _DstCh,const char*  __restrict__ _SrcCh,size_t _SrcSizeInBytes,_locale_t _Locale);",
    "mbstowcs|__cdecl mbstowcs(wchar_t*  __restrict__ _Dest,const char*  __restrict__ _Source,size_t _MaxCount);",
    "_mbstowcs_l|__cdecl _mbstowcs_l(wchar_t*  __restrict__ _Dest,const char*  __restrict__ _Source,size_t _MaxCount,_locale_t _Locale);",
    "mkstemp|__cdecl mkstemp(char* template_name);",
    "rand|__cdecl rand(void);",
    "_set_error_mode|__cdecl _set_error_mode(int _Mode);",
    "srand|__cdecl srand(unsigned int _Seed);",
    "rand_s|__cdecl rand_s(unsigned int* randomValue);",
    "strtod|__MINGW_NOTHROW strtod(const char*  __restrict__ _Str,char**  __restrict__ _EndPtr);",
    "strtof|__MINGW_NOTHROW strtof(const char*  __restrict__ nptr, char**  __restrict__ endptr);",
    "strtold|__MINGW_NOTHROW strtold(const char*  __restrict__ , char**  __restrict__ );",
    "_strtod_l|__cdecl _strtod_l(const char*  __restrict__ _Str,char**  __restrict__ _EndPtr,_locale_t _Locale);",
    "strtol|__cdecl strtol(const char*  __restrict__ _Str,char**  __restrict__ _EndPtr,int _Radix);",
    "_strtol_l|__cdecl _strtol_l(const char*  __restrict__ _Str,char**  __restrict__ _EndPtr,int _Radix,_locale_t _Locale);",
    "strtoul|__cdecl strtoul(const char*  __restrict__ _Str,char**  __restrict__ _EndPtr,int _Radix);",
    "_strtoul_l|__cdecl _strtoul_l(const char*  __restrict__ _Str,char**  __restrict__ _EndPtr,int _Radix,_locale_t _Locale);",
    "system|__cdecl system(const char* _Command);",
    "_ultoa|__cdecl _ultoa(unsigned long _Value,char* _Dest,int _Radix);",
    "wctomb|__cdecl wctomb(char* _MbCh,wchar_t _WCh);",
    "_wctomb_l|__cdecl _wctomb_l(char* _MbCh,wchar_t _WCh,_locale_t _Locale);",
    "wcstombs|__cdecl wcstombs(char*  __restrict__ _Dest,const wchar_t*  __restrict__ _Source,size_t _MaxCount);",
    "_wcstombs_l|__cdecl _wcstombs_l(char*  __restrict__ _Dest,const wchar_t*  __restrict__ _Source,size_t _MaxCount,_locale_t _Locale);",
    "calloc|__cdecl calloc(size_t _NumOfElements,size_t _SizeOfElements);",
    "free|__cdecl free(void* _Memory);",
    "malloc|__cdecl malloc(size_t _Size);",
    "realloc|__cdecl realloc(void* _Memory,size_t _NewSize);",
    "_recalloc|__cdecl _recalloc(void* _Memory,size_t _Count,size_t _Size);",
    "_aligned_free|__cdecl _aligned_free(void* _Memory);",
    "_aligned_malloc|__cdecl _aligned_malloc(size_t _Size,size_t _Alignment);",
    "_aligned_offset_malloc|__cdecl _aligned_offset_malloc(size_t _Size,size_t _Alignment,size_t _Offset);",
    "_aligned_realloc|__cdecl _aligned_realloc(void* _Memory,size_t _Size,size_t _Alignment);",
    "_aligned_recalloc|__cdecl _aligned_recalloc(void* _Memory,size_t _Count,size_t _Size,size_t _Alignment);",
    "_aligned_offset_realloc|__cdecl _aligned_offset_realloc(void* _Memory,size_t _Size,size_t _Alignment,size_t _Offset);",
    "_aligned_offset_recalloc|__cdecl _aligned_offset_recalloc(void* _Memory,size_t _Count,size_t _Size,size_t _Alignment,size_t _Offset);",
    "_itow|__cdecl _itow(int _Value,wchar_t* _Dest,int _Radix);",
    "_ltow|__cdecl _ltow(long _Value,wchar_t* _Dest,int _Radix);",
    "_ultow|__cdecl _ultow(unsigned long _Value,wchar_t* _Dest,int _Radix);",
    "wcstod|__cdecl wcstod(const wchar_t*  __restrict__ _Str,wchar_t**  __restrict__ _EndPtr);",
    "wcstof|__cdecl wcstof(const wchar_t*  __restrict__ nptr, wchar_t**  __restrict__ endptr);",
    "wcstold|__cdecl wcstold(const wchar_t*  __restrict__, wchar_t**  __restrict__);",
    "_wcstod_l|__cdecl _wcstod_l(const wchar_t*  __restrict__ _Str,wchar_t**  __restrict__ _EndPtr,_locale_t _Locale);",
    "wcstol|__cdecl wcstol(const wchar_t*  __restrict__ _Str,wchar_t**  __restrict__ _EndPtr,int _Radix);",
    "_wcstol_l|__cdecl _wcstol_l(const wchar_t*  __restrict__ _Str,wchar_t**  __restrict__ _EndPtr,int _Radix,_locale_t _Locale);",
    "wcstoul|__cdecl wcstoul(const wchar_t*  __restrict__ _Str,wchar_t**  __restrict__ _EndPtr,int _Radix);",
    "_wcstoul_l|__cdecl _wcstoul_l(const wchar_t*  __restrict__ _Str,wchar_t**  __restrict__ _EndPtr,int _Radix,_locale_t _Locale);",
    "_wgetenv|__cdecl _wgetenv(const wchar_t* _VarName);",
    "_wsystem|__cdecl _wsystem(const wchar_t* _Command);",
    "_wtof|__cdecl _wtof(const wchar_t* _Str);",
    "_wtof_l|__cdecl _wtof_l(const wchar_t* _Str,_locale_t _Locale);",
    "_wtoi|__cdecl _wtoi(const wchar_t* _Str);",
    "_wtoi_l|__cdecl _wtoi_l(const wchar_t* _Str,_locale_t _Locale);",
    "_wtol|__cdecl _wtol(const wchar_t* _Str);",
    "_wtol_l|__cdecl _wtol_l(const wchar_t* _Str,_locale_t _Locale);",
    "_i64tow|__cdecl _i64tow(__int64 _Val,wchar_t* _DstBuf,int _Radix);",
    "_ui64tow|__cdecl _ui64tow(unsigned __int64 _Val,wchar_t* _DstBuf,int _Radix);",
    "_wtoi64|__cdecl _wtoi64(const wchar_t* _Str);",
    "_wtoi64_l|__cdecl _wtoi64_l(const wchar_t* _Str,_locale_t _Locale);",
    "_wcstoi64|__cdecl _wcstoi64(const wchar_t* _Str,wchar_t** _EndPtr,int _Radix);",
    "_wcstoi64_l|__cdecl _wcstoi64_l(const wchar_t* _Str,wchar_t** _EndPtr,int _Radix,_locale_t _Locale);",
    "_wcstoui64|__cdecl _wcstoui64(const wchar_t* _Str,wchar_t** _EndPtr,int _Radix);",
    "_wcstoui64_l|__cdecl _wcstoui64_l(const wchar_t* _Str ,wchar_t** _EndPtr,int _Radix,_locale_t _Locale);",
    "_putenv|__cdecl _putenv(const char* _EnvString);",
    "_wputenv|__cdecl _wputenv(const wchar_t* _EnvString);",
    "_fullpath|__cdecl _fullpath(char* _FullPath,const char* _Path,size_t _SizeInBytes);",
    "_ecvt|__cdecl _ecvt(double _Val,int _NumOfDigits,int* _PtDec,int* _PtSign);",
    "_fcvt|__cdecl _fcvt(double _Val,int _NumOfDec,int* _PtDec,int* _PtSign);",
    "_gcvt|__cdecl _gcvt(double _Val,int _NumOfDigits,char* _DstBuf);",
    "_atodbl|__cdecl _atodbl(_CRT_DOUBLE* _Result,char* _Str);",
    "_atoldbl|__cdecl _atoldbl(_LDOUBLE* _Result,char* _Str);",
    "_atoflt|__cdecl _atoflt(_CRT_FLOAT* _Result,char* _Str);",
    "_atodbl_l|__cdecl _atodbl_l(_CRT_DOUBLE* _Result,char* _Str,_locale_t _Locale);",
    "_atoldbl_l|__cdecl _atoldbl_l(_LDOUBLE* _Result,char* _Str,_locale_t _Locale);",
    "_atoflt_l|__cdecl _atoflt_l(_CRT_FLOAT* _Result,char* _Str,_locale_t _Locale);",
    "_lrotl|__cdecl _lrotl(unsigned long,int);",
    "_lrotr|__cdecl _lrotr(unsigned long,int);",
    "_makepath|__cdecl _makepath(char* _Path,const char* _Drive,const char* _Dir,const char* _Filename,const char* _Ext);",
    "_onexit|__cdecl _onexit(_onexit_t _Func);",
    "_rotl64|__cdecl _rotl64(unsigned __int64 _Val,int _Shift);",
    "_rotr64|__cdecl _rotr64(unsigned __int64 Value,int Shift);",
    "_rotr|__cdecl _rotr(unsigned int _Val,int _Shift);",
    "_rotl|__cdecl _rotl(unsigned int _Val,int _Shift);",
    "_rotr64|__cdecl _rotr64(unsigned __int64 _Val,int _Shift);",
    "_searchenv|__cdecl _searchenv(const char* _Filename,const char* _EnvVar,char* _ResultPath);",
    "_splitpath|__cdecl _splitpath(const char* _FullPath,char* _Drive,char* _Dir,char* _Filename,char* _Ext);",
    "_swab|__cdecl _swab(char* _Buf1,char* _Buf2,int _SizeInBytes);",
    "_wfullpath|__cdecl _wfullpath(wchar_t* _FullPath,const wchar_t* _Path,size_t _SizeInWords);",
    "_wmakepath|__cdecl _wmakepath(wchar_t* _ResultPath,const wchar_t* _Drive,const wchar_t* _Dir,const wchar_t* _Filename,const wchar_t* _Ext);",
    "_wsearchenv|__cdecl _wsearchenv(const wchar_t* _Filename,const wchar_t* _EnvVar,wchar_t* _ResultPath);",
    "_wsplitpath|__cdecl _wsplitpath(const wchar_t* _FullPath,wchar_t* _Drive,wchar_t* _Dir,wchar_t* _Filename,wchar_t* _Ext);",
    "_beep|__cdecl _beep(unsigned _Frequency,unsigned _Duration);",
    "_seterrormode|__cdecl _seterrormode(int _Mode);",
    "_sleep|__cdecl _sleep(unsigned long _Duration);",
    "ecvt|__cdecl ecvt(double _Val,int _NumOfDigits,int* _PtDec,int* _PtSign);",
    "fcvt|__cdecl fcvt(double _Val,int _NumOfDec,int* _PtDec,int* _PtSign);",
    "gcvt|__cdecl gcvt(double _Val,int _NumOfDigits,char* _DstBuf);",
    "itoa|__cdecl itoa(int _Val,char* _DstBuf,int _Radix);",
    "ltoa|__cdecl ltoa(long _Val,char* _DstBuf,int _Radix);",
    "putenv|__cdecl putenv(const char* _EnvString);",
    "swab|__cdecl swab(char* _Buf1,char* _Buf2,int _SizeInBytes);",
    "ultoa|__cdecl ultoa(unsigned long _Val,char* _Dstbuf,int _Radix);",
    "onexit|__cdecl onexit(onexit_t _Func);",
    "lldiv|__cdecl lldiv(long long, long long);",
    "llabs|__cdecl llabs(long long);",
    "strtoll|__cdecl strtoll(const char*  __restrict__, char**  __restrict, int);",
    "strtoull|__cdecl strtoull(const char*  __restrict__, char**  __restrict__, int);",
    "atoll|__cdecl atoll (const char* );",
    "wtoll|__cdecl wtoll (const wchar_t* );",
    "lltoa|__cdecl lltoa (long long, char* , int);",
    "ulltoa|__cdecl ulltoa (unsigned long long , char* , int);",
    "lltow|__cdecl lltow (long long, wchar_t* , int);",
    "ulltow|__cdecl ulltow (unsigned long long, wchar_t* , int);",
    "__daylight|__cdecl __daylight(void);",
    "__dstbias|__cdecl __dstbias(void);",
    "__timezone|__cdecl __timezone(void);",
    "__tzname|__cdecl __tzname(void);",
    "_get_daylight|__cdecl _get_daylight(int* _Daylight);",
    "_get_dstbias|__cdecl _get_dstbias(long* _Daylight_savings_bias);",
    "_get_timezone|__cdecl _get_timezone(long* _Timezone);",
    "asctime|__cdecl asctime(const struct tm* _Tm);",
    "asctime_s|__cdecl asctime_s (char* _Buf,size_t _SizeInWords,const struct tm* _Tm);",
    "_ctime32|__cdecl _ctime32(const __time32_t* _Time);",
    "_ctime32_s|__cdecl _ctime32_s (char* _Buf,size_t _SizeInBytes,const __time32_t* _Time);",
    "clock|__cdecl clock(void);",
    "_difftime32|__cdecl _difftime32(__time32_t _Time1,__time32_t _Time2);",
    "_gmtime32|__cdecl _gmtime32(const __time32_t* _Time);",
    "_gmtime32_s|__cdecl _gmtime32_s (struct tm* _Tm,const __time32_t* _Time);",
    "_localtime32|__cdecl _localtime32(const __time32_t* _Time);",
    "_localtime32_s|__cdecl _localtime32_s (struct tm* _Tm,const __time32_t* _Time);",
    "strftime|__cdecl strftime(char*  __restrict__ _Buf,size_t _SizeInBytes,const char*  __restrict__ _Format,const struct tm*  __restrict__ _Tm);",
    "_strftime_l|__cdecl _strftime_l(char*  __restrict__ _Buf,size_t _Max_size,const char*  __restrict__ _Format,const struct tm*  __restrict__ _Tm,_locale_t _Locale);",
    "_strdate|__cdecl _strdate(char* _Buffer);",
    "_strdate_s|__cdecl _strdate_s (char* _Buf,size_t _SizeInBytes);",
    "_strtime|__cdecl _strtime(char* _Buffer);",
    "_strtime_s|__cdecl _strtime_s (char* _Buf ,size_t _SizeInBytes);",
    "_time32|__cdecl _time32(__time32_t* _Time);",
    "_mktime32|__cdecl _mktime32(struct tm* _Tm);",
    "_mkgmtime32|__cdecl _mkgmtime32(struct tm* _Tm);",
    "tzset|__cdecl tzset(void);",
    "_tzset|__cdecl _tzset(void);",
    "_difftime64|__cdecl _difftime64(__time64_t _Time1,__time64_t _Time2);",
    "_ctime64|__cdecl _ctime64(const __time64_t* _Time);",
    "_ctime64_s|__cdecl _ctime64_s (char* _Buf,size_t _SizeInBytes,const __time64_t* _Time);",
    "_gmtime64|__cdecl _gmtime64(const __time64_t* _Time);",
    "_gmtime64_s|__cdecl _gmtime64_s (struct tm* _Tm,const __time64_t* _Time);",
    "_localtime64|__cdecl _localtime64(const __time64_t* _Time);",
    "_localtime64_s|__cdecl _localtime64_s (struct tm* _Tm,const __time64_t* _Time);",
    "_mktime64|__cdecl _mktime64(struct tm* _Tm);",
    "_mkgmtime64|__cdecl _mkgmtime64(struct tm* _Tm);",
    "_time64|__cdecl _time64(__time64_t* _Time);",
    "_getsystime|__cdecl _getsystime(struct tm* _Tm);",
    "_setsystime|__cdecl _setsystime(struct tm* _Tm,unsigned _MilliSec);",
    "_wasctime|__cdecl _wasctime(const struct tm* _Tm);",
    "_wasctime_s|__cdecl _wasctime_s (wchar_t* _Buf,size_t _SizeInWords,const struct tm* _Tm);",
    "_wctime32|__cdecl _wctime32(const __time32_t* _Time);",
    "_wctime32_s|__cdecl _wctime32_s (wchar_t* _Buf,size_t _SizeInWords,const __time32_t* _Time);",
    "wcsftime|__cdecl wcsftime(wchar_t*  __restrict__ _Buf,size_t _SizeInWords,const wchar_t*  __restrict__ _Format,const struct tm*  __restrict__ _Tm);",
    "_wcsftime_l|__cdecl _wcsftime_l(wchar_t*  __restrict__ _Buf,size_t _SizeInWords,const wchar_t*  __restrict__ _Format,const struct tm*  __restrict__ _Tm,_locale_t _Locale);",
    "_wstrdate|__cdecl _wstrdate(wchar_t* _Buffer);",
    "_wstrdate_s|__cdecl _wstrdate_s (wchar_t* _Buf,size_t _SizeInWords);",
    "_wstrtime|__cdecl _wstrtime(wchar_t* _Buffer);",
    "_wstrtime_s|__cdecl _wstrtime_s (wchar_t* _Buf,size_t _SizeInWords);",
    "_wctime64|__cdecl _wctime64(const __time64_t* _Time);",
    "_wctime64_s|__cdecl _wctime64_s (wchar_t* _Buf,size_t _SizeInWords,const __time64_t* _Time);",
    "_wctime|__cdecl _wctime(const time_t* );",
    "_wctime_s|__cdecl _wctime_s(wchar_t* , size_t, const time_t* );",
    "mingw_gettimeofday|__cdecl mingw_gettimeofday (struct timeval* p, struct timezone* z);",
    "_wassert|__cdecl _wassert(const wchar_t* _Message,const wchar_t* _File,unsigned _Line);",
    "_assert|__cdecl _assert (const char* _Message, const char* _File, unsigned _Line);",
    "_configthreadlocale|__cdecl _configthreadlocale(int _Flag);",
    "setlocale|__cdecl setlocale(int _Category,const char* _Locale);",
    "localeconv|__cdecl localeconv(void);",
    "_get_current_locale|__cdecl _get_current_locale(void);",
    "_create_locale|__cdecl _create_locale(int _Category,const char* _Locale);",
    "_free_locale|__cdecl _free_locale(_locale_t _Locale);",
    "__get_current_locale|__cdecl __get_current_locale(void);",
    "__create_locale|__cdecl __create_locale(int _Category,const char* _Locale);",
    "__free_locale|__cdecl __free_locale(_locale_t _Locale);",
    "___lc_codepage_func|__cdecl ___lc_codepage_func(void);",
    "_wsetlocale|__cdecl _wsetlocale(int _Category,const wchar_t* _Locale);",
    "_controlfp|__MINGW_NOTHROW _controlfp (unsigned int _NewValue, unsigned int _Mask);",
    "_controlfp_s|__cdecl _controlfp_s(unsigned int* _CurrentState, unsigned int _NewValue, unsigned int _Mask);",
    "_control87|__MINGW_NOTHROW _control87 (unsigned int _NewValue, unsigned int _Mask);",
    "_fpreset|__MINGW_NOTHROW _fpreset (void);",
    "fpreset|__MINGW_NOTHROW fpreset (void);",
    "__fpecode|__MINGW_NOTHROW __fpecode(void);",
    "_chgsign|__MINGW_NOTHROW _chgsign (double _X);",
    "_copysign|__MINGW_NOTHROW _copysign (double _Number,double _Sign);",
    "_logb|__MINGW_NOTHROW _logb (double);",
    "_nextafter|__MINGW_NOTHROW _nextafter (double, double);",
    "_scalb|__MINGW_NOTHROW _scalb (double, long);",
    "_finite|__MINGW_NOTHROW _finite (double);",
    "_fpclass|__MINGW_NOTHROW _fpclass (double);",
    "_isnan|__MINGW_NOTHROW _isnan (double);",
    "_chgsignl|__cdecl _chgsignl (long double);",
    "__pctype_func|short*  __pctype_func(void);",
    "__updatetlocinfo|__cdecl __updatetlocinfo(void);",
    "__updatetmbcinfo|__cdecl __updatetmbcinfo(void);",
    "_isctype|__cdecl _isctype(int _C,int _Type);",
    "_isctype_l|__cdecl _isctype_l(int _C,int _Type,_locale_t _Locale);",
    "isalpha|__cdecl isalpha(int _C);",
    "_isalpha_l|__cdecl _isalpha_l(int _C,_locale_t _Locale);",
    "isupper|__cdecl isupper(int _C);",
    "_isupper_l|__cdecl _isupper_l(int _C,_locale_t _Locale);",
    "islower|__cdecl islower(int _C);",
    "_islower_l|__cdecl _islower_l(int _C,_locale_t _Locale);",
    "isdigit|__cdecl isdigit(int _C);",
    "_isdigit_l|__cdecl _isdigit_l(int _C,_locale_t _Locale);",
    "isxdigit|__cdecl isxdigit(int _C);",
    "_isxdigit_l|__cdecl _isxdigit_l(int _C,_locale_t _Locale);",
    "isspace|__cdecl isspace(int _C);",
    "_isspace_l|__cdecl _isspace_l(int _C,_locale_t _Locale);",
    "ispunct|__cdecl ispunct(int _C);",
    "_ispunct_l|__cdecl _ispunct_l(int _C,_locale_t _Locale);",
    "isalnum|__cdecl isalnum(int _C);",
    "_isalnum_l|__cdecl _isalnum_l(int _C,_locale_t _Locale);",
    "isprint|__cdecl isprint(int _C);",
    "_isprint_l|__cdecl _isprint_l(int _C,_locale_t _Locale);",
    "isgraph|__cdecl isgraph(int _C);",
    "_isgraph_l|__cdecl _isgraph_l(int _C,_locale_t _Locale);",
    "iscntrl|__cdecl iscntrl(int _C);",
    "_iscntrl_l|__cdecl _iscntrl_l(int _C,_locale_t _Locale);",
    "toupper|__cdecl toupper(int _C);",
    "tolower|__cdecl tolower(int _C);",
    "_tolower|__cdecl _tolower(int _C);",
    "_tolower_l|__cdecl _tolower_l(int _C,_locale_t _Locale);",
    "_toupper|__cdecl _toupper(int _C);",
    "_toupper_l|__cdecl _toupper_l(int _C,_locale_t _Locale);",
    "__isascii|__cdecl __isascii(int _C);",
    "__toascii|__cdecl __toascii(int _C);",
    "__iscsymf|__cdecl __iscsymf(int _C);",
    "__iscsym|__cdecl __iscsym(int _C);",
    "isblank|__cdecl isblank(int _C);",
    "iswalpha|__cdecl iswalpha(wint_t _C);",
    "_iswalpha_l|__cdecl _iswalpha_l(wint_t _C,_locale_t _Locale);",
    "iswupper|__cdecl iswupper(wint_t _C);",
    "_iswupper_l|__cdecl _iswupper_l(wint_t _C,_locale_t _Locale);",
    "iswlower|__cdecl iswlower(wint_t _C);",
    "_iswlower_l|__cdecl _iswlower_l(wint_t _C,_locale_t _Locale);",
    "iswdigit|__cdecl iswdigit(wint_t _C);",
    "_iswdigit_l|__cdecl _iswdigit_l(wint_t _C,_locale_t _Locale);",
    "iswxdigit|__cdecl iswxdigit(wint_t _C);",
    "_iswxdigit_l|__cdecl _iswxdigit_l(wint_t _C,_locale_t _Locale);",
    "iswspace|__cdecl iswspace(wint_t _C);",
    "_iswspace_l|__cdecl _iswspace_l(wint_t _C,_locale_t _Locale);",
    "iswpunct|__cdecl iswpunct(wint_t _C);",
    "_iswpunct_l|__cdecl _iswpunct_l(wint_t _C,_locale_t _Locale);",
    "iswalnum|__cdecl iswalnum(wint_t _C);",
    "_iswalnum_l|__cdecl _iswalnum_l(wint_t _C,_locale_t _Locale);",
    "iswprint|__cdecl iswprint(wint_t _C);",
    "_iswprint_l|__cdecl _iswprint_l(wint_t _C,_locale_t _Locale);",
    "iswgraph|__cdecl iswgraph(wint_t _C);",
    "_iswgraph_l|__cdecl _iswgraph_l(wint_t _C,_locale_t _Locale);",
    "iswcntrl|__cdecl iswcntrl(wint_t _C);",
    "_iswcntrl_l|__cdecl _iswcntrl_l(wint_t _C,_locale_t _Locale);",
    "iswascii|__cdecl iswascii(wint_t _C);",
    "isleadbyte|__cdecl isleadbyte(int _C);",
    "_isleadbyte_l|__cdecl _isleadbyte_l(int _C,_locale_t _Locale);",
    "towupper|__cdecl towupper(wint_t _C);",
    "_towupper_l|__cdecl _towupper_l(wint_t _C,_locale_t _Locale);",
    "towlower|__cdecl towlower(wint_t _C);",
    "_towlower_l|__cdecl _towlower_l(wint_t _C,_locale_t _Locale);",
    "iswctype|__cdecl iswctype(wint_t _C,wctype_t _Type);",
    "_iswctype_l|__cdecl _iswctype_l(wint_t _C,wctype_t _Type,_locale_t _Locale);",
    "__iswcsymf|__cdecl __iswcsymf(wint_t _C);",
    "_iswcsymf_l|__cdecl _iswcsymf_l(wint_t _C,_locale_t _Locale);",
    "__iswcsym|__cdecl __iswcsym(wint_t _C);",
    "_iswcsym_l|__cdecl _iswcsym_l(wint_t _C,_locale_t _Locale);",
    "is_wctype|__cdecl is_wctype(wint_t _C,wctype_t _Type);",
    "iswblank|__cdecl iswblank(wint_t _C);",
    "isascii|__cdecl isascii(int _C);",
    "toascii|__cdecl toascii(int _C);",
    "iscsymf|__cdecl iscsymf(int _C);",
    "iscsym|__cdecl iscsym(int _C);",
    "MessageBox|int MessageBox(HWND hWnd, LPCTSTR lpText, LPCTSTR lpCaption, UINT uType);",
    "SendMessage|LRESULT SendMessage(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam);"
  }
  return calltip_add
end

function cpp.get_reqular()
  local symbol_reqular_exp = "\\s*(?:[\\w+]+[_a-zA-Z0-9 ]*[ \\t*]+|^)([_a-zA-Z]+[~_a-zA-Z0-9:]*)\\s*\\([^\\(^;^=^<^>]*\\)[a-zA-Z\\s ]*\\{.*$"
  return symbol_reqular_exp
end

function cpp.create_bakup(path)
  local cpp_code = {
    "user_cpp = {}\n",
    "\n",
    "require(\"eu_sci\")\n",
    "\n",
    "function user_cpp.get_styles()\n",
    "  local style_t = {\n",
    "    -- [SCE_C_COMMENT] = 0x008000,\n",
    "    -- [SCE_C_COMMENTLINE] = 0x008000,\n",
    "    -- [SCE_C_WORD] = 0x0000FF,\n",
    "    -- [SCE_C_WORD2] = 0x0000FF,\n",
    "    -- [SCE_C_GLOBALCLASS] = 0x800000,\n",
    "    -- [SCE_C_STRING] = 0x008000,\n",
    "    -- [SCE_C_NUMBER] = 0xFF0000,\n",
    "    -- [SCE_C_OPERATOR] = 0xB000B0,\n",
    "    -- [SCE_C_PREPROCESSOR] = 0xFF8000,\n",
    "    -- [SCE_C_PREPROCESSORCOMMENT] = 0xFF8000,\n",
    "    -- [SCE_C_PREPROCESSORCOMMENTDOC] = 0xFF8000,\n",
    "    -- [SCE_C_TRIPLEVERBATIM] = 0xB000B0,\n",
    "    -- [SCE_C_VERBATIM] = 0xB000B0,\n",
    "    -- [SCE_C_COMMENTDOC] = 0x808080,\n",
    "    -- [SCE_C_COMMENTLINEDOC] = 0x808080,\n",
    "    -- [SCE_C_COMMENTDOCKEYWORD] = 0x808080,\n",
    "    -- [SCE_C_COMMENTDOCKEYWORDERROR] = 0x800000,\n",
    "    -- [SCE_C_TASKMARKER] = 0x208080,\n",
    "  }\n",
    "  return style_t\n",
    "end\n",
    "\n",    
    "function user_cpp.get_keywords()\n",
     " local keywords0_set = \"__asm __based __cdecl __declspec __except __far __fastcall __finally __fortran __huge __inline __int16 __int32 __int64 __int8 __interrupt __leave __loadds __near __pascal __saveregs __segment __segname __self __stdcall __try __uuidof auto bool break case char const continue default defined do double else enum extern for goto return if int long float register short signed sizeof static struct switch typedef union unsigned void volatile while __multiple_inheritance __single_inheritance __virtual_inheritance catch class const_cast delete dynamic_cast explicit export false friend inline __inline__ __inline __auto_type auto char8_t char16_t char32_t wchar_t nullptr_t nothrow_t _Bool complex _Complex _Imaginary imaginary __w64 __wchar_t __int8 __int16 __int32 __int64 __m64 __m128 __m128d __m128i __m256 __m256d __m256i __m512 __m512d __m512i __mmask8 __mmask16 __mmask32 __mmask64 __int3264 __ptr32 __ptr64 __sptr __uptr __int128 __float80 __float128 __fp16 __complex__ __real__ __imag__ __complex128 _Decimal32 _Decimal64 _Decimal128 decimal32 decimal64 decimal128 int128 qfloat errno_t fenv_t femode_t fexcept_t imaxdiv_t float_t double_t jmp_buf sigjmp_buf sig_atomic_t sigset_t pid_t va_list atomic_flag atomic_bool atomic_char atomic_schar atomic_uchar atomic_short atomic_ushort atomic_int atomic_uint atomic_long atomic_ulong atomic_llong atomic_ullong atomic_char16_t atomic_char32_t atomic_wchar_t atomic_intptr_t atomic_uintptr_t atomic_size_t atomic_ptrdiff_t atomic_intmax_t atomic_uintmax_t size_t rsize_t ptrdiff_t max_align_t int8_t int16_t int32_t int64_t uint8_t uint16_t uint32_t uint64_t intptr_t uintptr_t intmax_t uintmax_t ssize_t locale_t FILE fpos_t off_t div_t ldiv_t lldiv_t cnd_t thrd_t tss_t mtx_t tss_dtor_t thrd_start_t once_flag clock_t time_t wint_t mbstate_t wctrans_t wctype_t stdin stdout stderr sptr_t mutable namespace new operator private protected public reinterpret_cast static_cast template this throw true try typeid typename using virtual wchar_t dllexport dllimport naked thread uuid pascal\"\n",
     " local keywords1_set = \"a64l abort abs asprintf __asprintf atexit atof atoi atol atoll at_quick_exit available basename bcmp bcopy bsearch __builtin_alloca __builtin_index __builtin_memchr __builtin_rindex __builtin_strchr __builtin_strpbrk __builtin_strrchr __builtin_strstr bzero __bzero calloc canonicalize_file_name cfree clearenv clearerr clearerr_unlocked Copyright ctermid __ctype_get_mb_cur_max cuserid div dprintf drand48 drand48_r ecvt ecvt_r erand48 erand48_r exit __extension__ fclose fcloseall fcvt fcvt_r fdopen feof feof_unlocked ferror ferror_unlocked fflush fflush_unlocked ffs ffsl ffsll fgetc fgetc_unlocked fgetpos fgetpos64 fgets fgets_unlocked fileno fileno_unlocked flockfile fmemopen fopen fopen64 fopencookie __format__ fprintf fputc fputc_unlocked fputs fputs_unlocked fread fread_unlocked free freopen freopen64 fscanf fseek _fseeki64 fseeko fseeko64 fsetpos fsetpos64 ftell ftello ftello64 ftrylockfile funlockfile fwrite fwrite_unlocked gcvt getc getchar getchar_unlocked getc_unlocked getdelim __getdelim getenv getline getloadavg getpt gets getsubopt getw grantpt if index initstate initstate_r _IO_getc _IO_putc __isoc99_fscanf __isoc99_scanf __isoc99_sscanf __isoc99_vfscanf __isoc99_vscanf __isoc99_vsscanf jrand48 jrand48_r l64a labs lcong48 lcong48_r ldiv llabs lldiv lrand48 lrand48_r malloc mblen mbstowcs mbtowc memccpy memchr memcmp memcpy memfrob memmem memmove mempcpy __mempcpy memrchr memset mkdtemp mkostemp mkostemp64 mkostemps mkostemps64 mkstemp mkstemp64 mkstemps mkstemps64 mktemp mrand48 mrand48_r nrand48 nrand48_r obstack_printf obstack_vprintf on_exit open_memstream optimizations or pclose perror popen posix_memalign posix_openpt printf ptsname ptsname_r putc putchar putchar_unlocked putc_unlocked putenv puts putw qecvt qecvt_r qfcvt qfcvt_r qgcvt qsort qsort_r quick_exit rand random random_r rand_r rawmemchr read realloc realpath remove rename renameat return rewind rindex rpmatch S S2 scanf __secure_getenv seed48 seed48_r setbuf setbuffer setenv setkey setlinebuf setstate setstate_r setvbuf snprintf sprintf srand srand48 srand48_r srandom srandom_r sscanf standard stpcpy __stpcpy stpncpy __stpncpy strcasecmp strcasecmp_l strcasestr strcat strchr strchrnul strcmp strcoll strcoll_l strcpy strcspn strdup strdupa strerror strerror_l strerror_r strfry strlen strncasecmp strncasecmp_l strncat strncmp strncpy strndup strndupa strnlen strpbrk strrchr strsep strsignal strspn strstr strtod strtod_l strtof strtof_l strtok __strtok_r strtok_r strtol strtold strtold_l strtoll strtol_l strtoll_l strtoq strtoul strtoull strtoul_l strtoull_l strtouq strverscmp strxfrm strxfrm_l system tempnam tmpfile tmpfile64 tmpnam tmpnam_r to __typeof ungetc unlockpt unsetenv valloc vasprintf vdprintf vfprintf vfscanf void vprintf vscanf vsnprintf vsprintf vsscanf wcstombs wctomb word written  __xpg_strerror_r\"\n",
     " local keywords2_set = \"if elif else endif ifdef elifdef ifndef elifndef define undef include include_next import using pragma line error warning warn message region endregion sccs ident assert unassert\"\n",
     " local keywords3_set = \"_T TEXT VOID PVOID LPVOID LPCVOID BOOL PBOOL LPBOOL BOOLEAN PBOOLEAN BYTE PBYTE LPBYTE WORD PWORD LPWORD ATOM DWORD PDWORD LPDWORD UCHAR PUCHAR SHORT PSHORT USHORT PUSHORT INT PINT LPINT UINT PUINT LONG PLONG LPLONG ULONG PULONG FLOAT PFLOAT LONGLONG PLONGLONG ULONGLONG PULONGLONG DWORDLONG PDWORDLONG LARGE_INTEGER PLARGE_INTEGER ULARGE_INTEGER PULARGE_INTEGER FLOAT128 PFLOAT128 M128A PM128A LONG64 PLONG64 ULONG64 PULONG64 DWORD64 PDWORD64 LONG32 PLONG32 ULONG32 PULONG32 DWORD32 PDWORD32 DWORD_PTR PDWORD_PTR SHANDLE_PTR HANDLE_PTR UHALF_PTR PUHALF_PTR HALF_PTR PHALF_PTR INT_PTR PINT_PTR UINT_PTR PUINT_PTR LONG_PTR PLONG_PTR ULONG_PTR PULONG_PTR INT8 INT16 INT32 INT64 UINT8 UINT16 UINT32 UINT64 PINT8 PINT16 PINT32 PINT64 PUINT8 PUINT16 PUINT32 PUINT64 CHAR LPSTR LPCSTR WCHAR LPWSTR LPCWSTR TCHAR LPTSTR LPCTSTR WPARAM LPARAM LRESULT HRESULT HANDLE PHANDLE HGLOBAL HLOCAL HINSTANCE HMODULE HWND HHOOK HEVENT HGDIOBJ HKEY HACCEL HBITMAP HBRUSH HCOLORSPACE HDC HGLRC HDESK HENHMETAFILE HFONT HICON HMENU HMETAFILE HPALETTE HPEN HRGN HRSRC HSPRITE HLSURF HSTR HTASK HWINSTA HKL HWINEVENTHOOK HMONITOR HUMPD HFILE HCURSOR HDWP HINTERNET PHKEY MSG LPMSG NMHDR LPNMHDR LCID PLCID LANGID PSID SID PISID LUID PLUID ACL PACL LGRPID LCTYPE CALTYPE CALID CPINFO LPCPINFO GEOID GEOTYPE GEOCLASS XFORM LPXFORM CONTEXT PCONTEXT ACCESS_MASK KSPIN_LOCK SIZE_T PSIZE_T SSIZE_T PSSIZE_T RECT LPRECT RECTL LPRECTL POINT LPPOINT POINTL SIZE LPSIZE SIZEL LPSIZEL POINTS COLORREF LPCOLORREF RGBQUAD LPRGBQUAD BITMAP LPBITMAP FILETIME LPFILETIME SYSTEMTIME LPSYSTEMTIME GUID LPGUID LPCGUID IID LPIID CLSID LPCLSID FMTID LPFMTID REFGUID REFIID REFCLSID REFFMTID WNDCLASS WNDCLASSEX LOGFONT LOGBRUSH VARIANT\"\n",
     " return keywords0_set,keywords1_set,keywords2_set,keywords3_set\n",
    "end\n",
    "\n",
    "function user_cpp.get_autocomplete()\n",
    "  local autocomplete_set = \"define elif else endif error ifdef ifndef include include_next line pragma undef __asm __based __cdecl __declspec __except __far __fastcall __finally __fortran __huge __inline __int16 __int32 __int64 __int8 __interrupt __leave __loadds __near __pascal __saveregs __segment __segname __self __stdcall __try __uuidof auto bool break case char const continue default defined do double else enum extern for goto return if int long float register short signed sizeof static struct switch typedef union unsigned void volatile while __multiple_inheritance __single_inheritance __virtual_inheritance catch class const_cast delete dynamic_cast explicit export false friend inline __inline__ __inline __auto_type auto char8_t char16_t char32_t wchar_t nullptr_t nothrow_t _Bool complex _Complex _Imaginary imaginary __w64 __wchar_t __int8 __int16 __int32 __int64 __m64 __m128 __m128d __m128i __m256 __m256d __m256i __m512 __m512d __m512i __mmask8 __mmask16 __mmask32 __mmask64 __int3264 __ptr32 __ptr64 __sptr __uptr __int128 __float80 __float128 __fp16 __complex__ __real__ __imag__ __complex128 _Decimal32 _Decimal64 _Decimal128 decimal32 decimal64 decimal128 int128 qfloat errno_t fenv_t femode_t fexcept_t imaxdiv_t float_t double_t jmp_buf sigjmp_buf sig_atomic_t sigset_t pid_t va_list atomic_flag atomic_bool atomic_char atomic_schar atomic_uchar atomic_short atomic_ushort atomic_int atomic_uint atomic_long atomic_ulong atomic_llong atomic_ullong atomic_char16_t atomic_char32_t atomic_wchar_t atomic_intptr_t atomic_uintptr_t atomic_size_t atomic_ptrdiff_t atomic_intmax_t atomic_uintmax_t size_t rsize_t ptrdiff_t max_align_t int8_t int16_t int32_t int64_t uint8_t uint16_t uint32_t uint64_t intptr_t uintptr_t intmax_t uintmax_t ssize_t locale_t FILE fpos_t off_t div_t ldiv_t lldiv_t cnd_t thrd_t tss_t mtx_t tss_dtor_t thrd_start_t once_flag clock_t time_t wint_t mbstate_t wctrans_t wctype_t byte sptr_t _T TEXT TCHAR mutable namespace new operator private protected public reinterpret_cast static_cast template this throw true try typeid typename using virtual wchar_t dllexport dllimport naked thread uuid a64l abort abs asprintf __asprintf atexit atof atoi atol atoll at_quick_exit available basename bcmp bcopy bsearch __builtin_alloca __builtin_index __builtin_memchr __builtin_rindex __builtin_strchr __builtin_strpbrk __builtin_strrchr __builtin_strstr bzero __bzero calloc canonicalize_file_name cfree clearenv clearerr clearerr_unlocked Copyright ctermid __ctype_get_mb_cur_max cuserid DEST div dprintf drand48 drand48_r ecvt ecvt_r EOF erand48 erand48_r exit _Exit __extension__ fclose fcloseall fcvt fcvt_r fdopen feof feof_unlocked ferror ferror_unlocked fflush fflush_unlocked ffs ffsl ffsll fgetc fgetc_unlocked fgetpos fgetpos64 fgets fgets_unlocked fileno fileno_unlocked flockfile fmemopen fopen fopen64 fopencookie __format__ fprintf fputc fputc_unlocked fputs fputs_unlocked fread fread_unlocked free freopen freopen64 fscanf fseek _fseeki64 fseeko fseeko64 fsetpos fsetpos64 ftell ftello ftello64 ftrylockfile funlockfile fwrite fwrite_unlocked gcvt getc getchar getchar_unlocked getc_unlocked getdelim __getdelim getenv getline getloadavg getpt gets getsubopt getw __GNUC_PREREQ grantpt if index initstate initstate_r _IO_getc _IO_putc __isoc99_fscanf __isoc99_scanf __isoc99_sscanf __isoc99_vfscanf __isoc99_vscanf __isoc99_vsscanf jrand48 jrand48_r l64a labs lcong48 lcong48_r ldiv llabs lldiv lrand48 lrand48_r malloc mblen mbstowcs mbtowc memccpy memchr memcmp memcpy memfrob memmem memmove mempcpy __mempcpy memrchr memset mkdtemp mkostemp mkostemp64 mkostemps mkostemps64 mkstemp mkstemp64 mkstemps mkstemps64 mktemp mrand48 mrand48_r nrand48 nrand48_r __NTH obstack_printf obstack_vprintf on_exit open_memstream optimizations or pclose perror popen posix_memalign posix_openpt printf ptsname ptsname_r putc putchar putchar_unlocked putc_unlocked putenv puts putw qecvt qecvt_r qfcvt qfcvt_r qgcvt qsort qsort_r quick_exit rand random random_r rand_r rawmemchr read realloc realpath remove rename renameat return rewind rindex rpmatch S S2 scanf __secure_getenv seed48 seed48_r setbuf setbuffer setenv setkey setlinebuf setstate setstate_r setvbuf snprintf sprintf srand srand48 srand48_r srandom srandom_r sscanf standard stpcpy __stpcpy stpncpy __stpncpy strcasecmp strcasecmp_l strcasestr strcat strchr strchrnul strcmp strcoll strcoll_l strcpy strcspn strdup strdupa strerror strerror_l strerror_r strfry strlen strncasecmp strncasecmp_l strncat strncmp strncpy strndup strndupa strnlen strpbrk strrchr strsep strsignal strspn strstr strtod strtod_l strtof strtof_l strtok __strtok_r strtok_r strtol strtold strtold_l strtoll strtol_l strtoll_l strtoq strtoul strtoull strtoul_l strtoull_l strtouq strverscmp strxfrm strxfrm_l system tempnam tmpfile tmpfile64 tmpnam tmpnam_r to __typeof ungetc unlockpt unsetenv __USING_NAMESPACE_STD valloc vasprintf vdprintf vfprintf vfscanf void vprintf vscanf vsnprintf vsprintf vsscanf __WAIT_INT wcstombs wctomb WEXITSTATUS __WEXITSTATUS WIFCONTINUED __WIFCONTINUED WIFEXITED __WIFEXITED WIFSIGNALED __WIFSIGNALED WIFSTOPPED __WIFSTOPPED word written WSTOPSIG __WSTOPSIG WTERMSIG __WTERMSIG __xpg_strerror_r _hread _hwrite _lclose _lcreat _llseek _lopen _lread _lwrite AbnormalTermination AbortDoc AbortPath AbortPrinter AbortProc AbortSystemShutdown AccessCheck AccessCheckAndAuditAlarm AcsLan ActivateKeyboardLayout AddAccessAllowedAce AddAccessDeniedAce AddAce AddAtom AddAuditAccessAce AddFontResource AddForm AddJob AddMonitor AddPort AddPrinter AddPrinterConnection AddPrinterDriver AddPrintProcessor AddPrintProvidor AddPropSheetPageProc AdjustTokenGroups AdjustTokenPrivileges AdjustWindowRect AdjustWindowRectEx AdvancedDocumentProperties AllocateAndInitializeSid AllocateLocallyUniqueId AllocConsole AngleArc AnimatePalette AnsiLower AnsiLowerBuff AnsiNext AnsiPrev AnsiToOem AnsiToOemBuff AnsiUpper AnsiUpperBuff AnyPopup AppendMenu Arc ArcTo AreAllAccessesGranted AreAnyAccessesGranted AreFileApisANSI ArrangeIconicWindows AttachThreadInput BackupEventLog BackupRead BackupSeek BackupWrite Beep BeginDeferWindowPos BeginPaint BeginPath BeginUpdateResource BitBlt BringWindowToTop BroadcastSystemMessage BrowseCallbackProc BuildCommDCB BuildCommDCBAndTimeouts BuildExplicitAccessWithName BuildImpersonateExplicitAccessWithName BuildImpersonateTrustee BuildSecurityDescriptor BuildTrusteeWithName BuildTrusteeWithSid CallMsgFilter CallNamedPipe CallNextHookEx CallWindowProc CallWndProc CallWndRetProc CancelDC CancelIO CancelWaitableTimer CascadeWindows CBTProc CCHookProc CFHookProc ChangeClipboardChain ChangeDisplaySettings ChangeMenu ChangeServiceConfig CharLower CharLowerBuff CharNext CharNextExA CharPrev CharPrevExA CharToOem CharToOemBuff CharUpper CharUpperBuff CheckColorsInGamut CheckDlgButton CheckMenuItem CheckMenuRadioItem CheckRadioButton ChildWindowFromPoint ChildWindowFromPointEx ChooseColor ChooseFont ClearCommBreak ClearCommError ClearEventLog ClientToScreen ClipCursor CloseClipboard CloseDesktop CloseEnhMetaFile CloseEventLog CloseFigure CloseHandle CloseMetaFile ClosePrinter CloseServiceHandle CloseWindow CloseWindowStation ColorMatchToTarget CombineRgn CombineTransform CommandLineToArgvW CommConfigDialog CommDlgExtendedError CompareFileTime CompareString ConfigurePort ConnectNamedPipe ConnectToPrinterDlg ContinueDebugEvent ControlService ConvertDefaultLocale ConvertThreadToFiber CopyAcceleratorTable CopyCursor CopyEnhMetaFile CopyFile CopyFileEx CopyIcon CopyImage CopyLZFile CopyMemory CopyMetaFile CopyProgressRoutine CopyRect CopySid CountClipboardFormats CPlApplet CreateAcceleratorTable CreateBitmap CreateBitmapIndirect CreateBrushIndirect CreateCaret CreateColorSpace CreateCompatibleBitmap CreateCompatibleDC CreateConsoleScreenBuffer CreateCursor CreateDC CreateDesktop CreateDialog CreateDialogIndirect CreateDialogIndirectParam CreateDialogParam CreateDIBitmap CreateDIBPatternBrush CreateDIBPatternBrushPt CreateDIBSection CreateDirectory CreateDirectoryEx CreateDiscardableBitmap CreateEllipticRgn CreateEllipticRgnIndirect CreateEnhMetaFile CreateEvent CreateFiber CreateFile CreateFileMapping CreateFont CreateFontIndirect CreateHalftonePalette CreateHatchBrush CreateIC CreateIcon CreateIconFromResource CreateIconFromResourceEx CreateIconIndirect CreateIoCompletionPort CreateMailslot CreateMappedBitmap CreateMenu CreateMetaFile CreateMutex CreateNamedPipe CreatePalette CreatePatternBrush CreatePen CreatePenIndirect CreatePipe CreatePolygonRgn CreatePolyPolygonRgn CreatePopupMenu CreatePrivateObjectSecurity CreateProcess CreateProcessAsUser CreatePropertySheetPage CreateRectRgn CreateRectRgnIndirect CreateRemoteThread CreateRoundRectRgn CreateScalableFontResource CreateSemaphore CreateService CreateSolidBrush CreateTapePartition CreateToolbarEx CreateThread CreateUpDownControl CreateWaitableTimer CreateWindow CreateWindowEx CreateWindowStation CryptAcquireContext CryptCreateHash CryptDecryp CryptDeriveKey CryptDestroyHash CryptDestroyKey CryptEncrypt CryptExportKey CryptGenKey CryptGenRandom CryptGetHashParam CryptGetKeyParam CryptGetProvParam CryptGetUserKey CryptHashData CryptHashSessionKey CryptImportKey CryptReleaseContext CryptSetHashParam CryptSetKeyParam CryptSetProvider CryptSetProvParam CryptSignHash CryptVerifySignature DdeAbandonTransaction DdeAccessData DdeAddData DdeCallback DdeClientTransaction DdeCmpStringHandles DdeConnect DdeConnectList DdeCreateDataHandle DdeCreateStringHandle DdeDisconnect DdeDisconnectList DdeEnableCallback DdeFreeDataHandle DdeFreeStringHandle DdeGetData DdeGetLastError DdeImpersonateClient DdeInitialize DdeKeepStringHandle DdeNameService DdePostAdvise DdeQueryConvInfo DdeQueryNextServer DdeQueryString DdeReconnect DdeSetQualityOfService DdeSetUserHandle DdeUnaccessData DdeUninitialize DebugActiveProcess DebugBreak DebugProc DefDlgProc DeferWindowPos DefFrameProc DefHookProc DefineDosDevice DefineHandleTable DefMDIChildProc DefScreenSaverProc DefWindowProc DeleteAce DeleteAtom DeleteColorSpace DeleteCriticalSection DeleteDC DeleteEnhMetaFile DeleteFiber DeleteFile DeleteForm DeleteMenu DeleteMetaFile DeleteMonitor DeleteObject DeletePort DeletePrinter DeletePrinterConnection DeletePrinterData DeletePrinterDriver DeletePrintProcessor DeletePrintProvidor DeleteService DeregisterEventSource DestroyAcceleratorTable DestroyCaret DestroyCursor DestroyIcon DestroyMenu DestroyPrivateObjectSecurity DestroyPropertySheetPage DestroyWindow DeviceCapabilities DeviceIoControl DialogBox DialogBoxIndirect DialogBoxIndirectParam DialogBoxParam DialogProc DisableThreadLibraryCalls DisconnectNamedPipe DispatchMessage DlgDirList DlgDirListComboBox DlgDirSelectComboBoxEx DllEntryPoint DocumentProperties DosDateTimeToFileTime DPtoLP DragAcceptFiles DragDetect DragFinish DragQueryFile DragQueryPoint DrawAnimatedRects DrawCaption DrawEdge DrawEscape DrawFocusRect DrawFrameControl DrawIcon DrawIconEx DrawInsert DrawMenuBar DrawState DrawStateProc DrawStatusText DrawText DrawTextEx DuplicateHandle DuplicateToken DuplicateTokenEx EditWordBreakProc EditWordBreakProcEx Ellipse EmptyClipboard EnableEUDC EnableMenuItem EnableScrollBar EnableWindow EndDeferWindowPos EndDialog EndDoc EndDocPrinter EndPage EndPagePrinter EndPaint EndPath EndUpdateResource EnhMetaFileProc EnumCalendarInfo EnumChildProc EnumChildWindows EnumClipboardFormats EnumCodePagesProc EnumDateFormats EnumDateFormatsProc EnumDependentServices EnumDesktopProc EnumDesktops EnumDesktopWindows EnumDisplaySettings EnumEnhMetaFile EnumFontFamExProc EnumFontFamilies EnumFontFamiliesEx EnumFontFamProc EnumFonts EnumFontsProc EnumForms EnumICMProfiles EnumICMProfilesProc EnumJobs EnumLocalesProc EnumMetaFile EnumMetaFileProc EnumMonitors EnumObjects EnumObjectsProc EnumPorts EnumPrinterData EnumPrinterDrivers EnumPrinters EnumPrintProcessorDatatypes EnumPrintProcessors EnumProps EnumPropsEx EnumRegisterWordProc EnumResLangProc EnumResNameProc EnumResourceLanguages EnumResourceNames EnumResourceTypes EnumResTypeProc EnumServicesStatus EnumSystemCodePages EnumSystemLocales EnumTaskWindows EnumThreadWindows EnumThreadWndProc EnumTimeFormats EnumTimeFormatsProc EnumWindows EnumWindowsProc EnumWindowStationProc EnumWindowStations EqualPrefixSid EqualRect EqualRgn EqualSid EraseTape Escape EscapeCommFunction ExcludeClipRect ExcludeUpdateRgn ExitProcess ExitThread ExitWindows ExitWindowsEx ExpandEnvironmentStrings ExtCreatePen ExtensionPropSheetPageProc ExtEscape ExtFloodFill ExtractAssociatedIcon ExtractIcon ExtractIconEx ExtSelectClipRgn ExtTextOut FatalAppExit FatalExit FileIOCompletionRoutine FileTimeToDosDateTime FileTimeToLocalFileTime FileTimeToSystemTime FillConsoleOutputAttribute FillConsoleOutputCharacter FillMemory FillPath FillRect FillRgn FindAtom FindClose FindCloseChangeNotification FindClosePrinterChangeNotification FindExecutable FindFirstChangeNotification FindFirstFile FindFirstFileEx FindFirstFreeAce FindFirstPrinterChangeNotification FindNextChangeNotification FindNextFile FindNextPrinterChangeNotification FindResource FindResourceEx FindText FindWindow FindWindowEx FixBrushOrgEx FlashWindow FlattenPath FloodFill FlushConsoleInputBuffer FlushFileBuffers FlushInstructionCache FlushViewOfFile FMExtensionProc FoldString ForegroundIdleProc FormatMessage FrameRect FrameRgn FreeConsole FreeDDElParam FreeEnvironmentStrings FreeLibrary FreeLibraryAndExitThread FreeModule FreePrinterNotifyInfo FreeProcInstance FreeResource FreeSid FRHookProc FSCTL_DISMOUNT_VOLUME FSCTL_GET_COMPRESSION FSCTL_LOCK_VOLUME FSCTL_SET_COMPRESSION FSCTL_UNLOCK_VOLUME GdiComment GdiFlush GdiGetBatchLimit GdiSetBatchLimit GenerateConsoleCtrlEvent GetAce GetAclInformation GetACP GetActiveWindow GetArcDirection GetAspectRatioFilterEx GetAsyncKeyState GetAtomName GetAuditedPermissionsFromAcl GetBinaryType GetBitmapBits GetBitmapDimensionEx GetBkColor GetBkMode GetBoundsRect GetBrushOrgEx GetCapture GetCaretBlinkTime GetCaretPos GetCharABCWidths GetCharABCWidthsFloat GetCharacterPlacement GetCharWidth GetCharWidth32 GetCharWidthFloat GetClassInfo GetClassInfoEx GetClassLong GetClassName GetClassWord GetClientRect GetClipboardData GetClipboardFormatName GetClipboardOwner GetClipboardViewer GetClipBox GetClipCursor GetClipRgn GetColorAdjustment GetColorSpace GetCommandLine GetCommConfig GetCommMask GetCommModemStatus GetCommProperties GetCommState GetCommTimeouts GetCompressedFileSize GetComputerName GetConsoleCP GetConsoleCursorInfo GetConsoleMode GetConsoleOutputCP GetConsoleScreenBufferInfo GetConsoleTitle GetCPInfo GetCurrencyFormat GetCurrentDirectory GetCurrentFiber GetCurrentHwProfile GetCurrentObject GetCurrentPositionEx GetCurrentProcess GetCurrentProcessId GetCurrentThread GetCurrentThreadId GetCurrentTime GetCursor GetCursorPos GetDateFormat GetDC GetDCEx GetDCOrgEx GetDefaultCommConfig GetDesktopWindow GetDeviceCaps GetDeviceGammaRamp GetDialogBaseUnits GetDIBits GetDiskFreeSpace GetDiskFreeSpaceEx GetDlgCtrlID GetDlgItem GetDlgItemInt GetDlgItemText GetDoubleClickTime GetDriveType GetEffectiveClientRect GetEffectiveRightsFromAcl GetEnhMetaFile GetEnhMetaFileBits GetEnhMetaFileDescription GetEnhMetaFileHeader GetEnhMetaFilePaletteEntries GetEnvironmentStrings GetEnvironmentVariable GetExceptionCode GetExceptionInformation GetExitCodeProcess GetExitCodeThread GetExpandedName GetExplicitEntriesFromAcl GetFiberData GetFileAttributes GetFileAttributesEx GetFileInformationByHandle GetFileSecurity GetFileSize GetFileTime GetFileTitle GetFileType GetFileVersionInfo GetFileVersionInfoSize GetFocus GetFontData GetFontLanguageInfo GetForegroundWindow GetForm GetFreeSpace GetFullPathName GetGlyphOutline GetGraphicsMode GetHandleInformation GetICMProfile GetIconInfo GetInputState GetJob GetKBCodePage GetKernelObjectSecurity GetKerningPairs GetKeyboardLayout GetKeyboardLayoutList GetKeyboardLayoutName GetKeyboardState GetKeyboardType GetKeyNameText GetKeyState GetLargestConsoleWindowSize GetLastActivePopup GetLastError GetLengthSid GetLocaleInfo GetLocalTime GetLogColorSpace GetLogicalDrives GetLogicalDriveStrings GetMailslotInfo GetMapMode GetMenu GetMenuCheckMarkDimensions GetMenuContextHelpId GetMenuDefaultItem GetMenuItemCount GetMenuItemID GetMenuItemInfo GetMenuItemRect GetMenuState GetMenuString GetMessage GetMessageExtraInfo GetMessagePos GetMessageTime GetMetaFile GetMetaFileBitsEx GetMetaRgn GetMiterLimit GetModuleFileName GetModuleHandle GetMsgProc GetMultipleTrustee GetMultipleTrusteeOperation GetNamedPipeHandleState GetNamedPipeInfo GetNamedSecurityInfo GetNearestColor GetNearestPaletteIndex GetNextDlgGroupItem GetNextDlgTabItem GetNextWindow GetNumberFormat GetNumberOfConsoleInputEvents GetNumberOfConsoleMouseButtons GetNumberOfEventLogRecords GetObject GetObjectType GetOEMCP GetOldestEventLogRecord GetOpenClipboardWindow GetOpenFileName GetOutlineTextMetrics GetOverlappedResult GetPaletteEntries GetParent GetPath GetPixel GetPolyFillMode GetPrinter GetPrinterData GetPrinterDriver GetPrinterDriverDirectory GetPrintProcessorDirectory GetPriorityClass GetPriorityClipboardFormat GetPrivateObjectSecurity GetPrivateProfileInt GetPrivateProfileSection GetPrivateProfileSectionNames GetPrivateProfileString GetPrivateProfileStruct GetProcAddress GetProcessAffinityMask GetProcessHeap GetProcessHeaps GetProcessPriorityBoost GetProcessShutdownParameters GetProcessTimes GetProcessVersion GetProcessWindowStation GetProcessWorkingSetSize GetProfileInt GetProfileSection GetProfileString GetProp GetQueuedCompletionStatus GetQueueStatus GetRasterizerCaps GetRegionData GetRgnBox GetROP2 GetSaveFileName GetScrollInfo GetScrollPos GetScrollRange GetSecurityDescriptorControl GetSecurityDescriptorDacl GetSecurityDescriptorGroup GetSecurityDescriptorLength GetSecurityDescriptorOwner GetSecurityDescriptorSacl GetSecurityInfo GetServiceDisplayName GetServiceKeyName GetShortPathName GetSidIdentifierAuthority GetSidLengthRequired GetSidSubAuthority GetSidSubAuthorityCount GetStartupInfo GetStdHandle GetStockObject GetStretchBltMode GetStringTypeA GetStringTypeEx GetStringTypeW GetSubMenu GetSysColor GetSysColorBrush GetSysModalWindow GetSystemDefaultLangID GetSystemDefaultLCID GetSystemDirectory GetSystemInfo GetSystemMenu GetSystemMetrics GetSystemPaletteEntries GetSystemPaletteUse GetSystemTime GetSystemTimeAdjustment GetSystemTimeAsFileTime GetTabbedTextExtent GetTapeParameters GetTapePosition GetTapeStatus GetTempFileName GetTempPath GetTextAlign GetTextCharacterExtra GetTextCharset GetTextCharsetInfo GetTextColor GetTextExtentExPoint GetTextExtentPoint GetTextExtentPoint32 GetTextFace GetTextMetrics GetThreadContext GetThreadDesktop GetThreadLocale GetThreadPriority GetThreadPriorityBoost GetThreadSelectorEntry GetThreadTimes GetTickCount GetTimeFormat GetTimeZoneInformation GetTokenInformation GetTopWindow GetTrusteeForm GetTrusteeName GetTrusteeType GetUpdateRect GetUpdateRgn GetUserDefaultLangID GetUserDefaultLCID GetUserName GetUserObjectInformation GetUserObjectSecurity GetVersion GetVersionEx GetViewportExtEx GetViewportOrgEx GetVolumeInformation GetWindow GetWindowContextHelpId GetWindowDC GetWindowExtEx GetWindowLong GetWindowOrgEx GetWindowPlacement GetWindowRect GetWindowRgn GetWindowsDirectory GetWindowTask GetWindowText GetWindowTextLength GetWindowThreadProcessId GetWindowWord GetWinMetaFileBits GetWorldTransform GlobalAddAtom GlobalAlloc GlobalCompact GlobalDeleteAtom GlobalDiscard GlobalFindAtom GlobalFix GlobalFlags GlobalFree GlobalGetAtomName GlobalHandle GlobalLock GlobalLRUNewest GlobalLRUOldest GlobalMemoryStatus GlobalReAlloc GlobalSize GlobalUnfix GlobalUnlock GlobalUnWire GlobalWire GrayString HandlerRoutine HeapAlloc HeapCompact HeapCreate HeapDestroy HeapLock HeapReAlloc HeapSize HeapUnlock HeapValidate HeapWalk HideCaret HiliteMenuItem ImageList_Add ImageList_AddMasked ImageList_BeginDrag ImageList_Create ImageList_Destroy ImageList_DragEnter ImageList_DragLeave ImageList_DragMove ImageList_DragShowNolock ImageList_Draw ImageList_DrawEx ImageList_EndDrag ImageList_ExtractIcon ImageList_GetBkColor ImageList_GetDragImage ImageList_GetIcon ImageList_GetIconSize ImageList_GetImageCount ImageList_GetImageInfo ImageList_LoadBitmap ImageList_LoadImage ImageList_Merge ImageList_Read ImageList_Remove ImageList_Replace ImageList_ReplaceIcon ImageList_SetBkColor ImageList_SetDragCursorImage ImageList_SetIconSize ImageList_SetOverlayImage ImageList_Write ImmAssociateContext ImmConfigureIME ImmCreateContext ImmDestroyContext ImmEnumRegisterWord ImmEscape ImmGetCandidateList ImmGetCandidateListCount ImmGetCandidateWindow ImmGetCompositionFont ImmGetCompositionString ImmGetCompositionWindow ImmGetContext ImmGetConversionList ImmGetConversionStatus ImmGetDefaultIMEWnd ImmGetDescription ImmGetGuideLine ImmGetIMEFileName ImmGetOpenStatus ImmGetProperty ImmGetRegisterWordStyle ImmGetStatusWindowPos ImmGetVirtualKey ImmInstallIME ImmIsIME ImmIsUIMessage ImmNotifyIME ImmRegisterWord ImmReleaseContext ImmSetCandidateWindow ImmSetCompositionFont ImmSetCompositionString ImmSetCompositionWindow ImmSetConversionStatus ImmSetOpenStatus ImmSetStatusWindowPos ImmSimulateHotKey ImmUnregisterWord ImpersonateDdeClientWindow ImpersonateLoggedOnUser ImpersonateNamedPipeClient ImpersonateSelf InflateRect InitAtomTable InitCommonControls InitializeAcl InitializeCriticalSection InitializeSecurityDescriptor InitializeSid InitiateSystemShutdown InSendMessage InsertMenu InsertMenuItem Int32x32To64 Int64ShllMod32 Int64ShraMod32 Int64ShrlMod32 InterlockedCompareExchange InterlockedDecrement InterlockedExchange InterlockedExchangeAdd InterlockedIncrement IntersectClipRect IntersectRect InvalidateRect InvalidateRgn InvertRect InvertRgn IOCTL_DISK_CHECK_VERIFY IOCTL_DISK_EJECT_MEDIA IOCTL_DISK_FORMAT_TRACKS IOCTL_DISK_GET_DRIVE_GEOMETRY IOCTL_DISK_GET_DRIVE_LAYOUT IOCTL_DISK_GET_MEDIA_TYPES IOCTL_DISK_GET_PARTITION_INFO IOCTL_DISK_LOAD_MEDIA IOCTL_DISK_MEDIA_REMOVAL IOCTL_DISK_PERFORMANCE IOCTL_DISK_REASSIGN_BLOCKS IOCTL_DISK_SET_DRIVE_LAYOUT IOCTL_DISK_SET_PARTITION_INFO IOCTL_DISK_VERIFY IOCTL_SERIAL_LSRMST_INSERT IOCTL_STORAGE_CHECK_VERIFY IOCTL_STORAGE_EJECT_MEDIA IOCTL_STORAGE_GET_MEDIA_TYPES IOCTL_STORAGE_LOAD_MEDIA IOCTL_STORAGE_MEDIA_REMOVAL IsBadCodePtr IsBadHugeReadPtr IsBadHugeWritePtr IsBadReadPtr IsBadStringPtr IsBadWritePtr IsCharAlpha IsCharAlphaNumeric IsCharLower IsCharUpper IsChild IsClipboardFormatAvailable IsDBCSLeadByte IsDBCSLeadByteEx IsDebuggerPresent IsDialogMessage IsDlgButtonChecked IsIconic IsMenu IsProcessorFeaturePresent IsRectEmpty IsTextUnicode IsValidAcl IsValidCodePage IsValidLocale IsValidSecurityDescriptor IsValidSid IsWindow IsWindowEnabled IsWindowUnicode IsWindowVisible IsZoomed JournalPlaybackProc JournalRecordProc keybd_event KeyboardProc KillTimer LBItemFromPt LCMapString LeaveCriticalSection LimitEmsPages LineDDA LineDDAProc LineTo LoadAccelerators LoadBitmap LoadCursor LoadCursorFromFile LoadIcon LoadImage LoadKeyboardLayout LoadLibrary LoadLibraryEx LoadMenu LoadMenuIndirect LoadModule LoadResource LoadString LocalAlloc LocalCompact LocalDiscard LocalFileTimeToFileTime LocalFlags LocalFree LocalHandle LocalLock LocalReAlloc LocalShrink LocalSize LocalUnlock LockFile LockFileEx LockResource LockSegment LockServiceDatabase LockWindowUpdate LogonUser LookupAccountName LookupAccountSid LookupIconIdFromDirectory LookupIconIdFromDirectoryEx LookupPrivilegeDisplayName LookupPrivilegeName LookupPrivilegeValue LookupSecurityDescriptorParts LPtoDP LSEnumProviders LSFreeHandle LSGetMessage LSQuery LSRelease LSRequest LSUpdate lstrcat LSTRCMP LSTRCMPI lstrcpy lstrcpyn lstrlen LZClose LZCopy LZDone LZInit LZOpenFile LZRead LZSeek LZStart MakeAbsoluteSD MakeDragList MakeProcInstance MakeSelfRelativeSD MapDialogRect MapGenericMask MapViewOfFile MapViewOfFileEx MapVirtualKey MapVirtualKeyEx MapWindowPoints MenuHelp MenuItemFromPoint MessageBeep MessageBox MessageBoxEx MessageBoxIndirect MessageProc ModifyMenu ModifyWorldTransform mouse_event MouseProc MoveFile MoveFileEx MoveMemory MoveToEx MoveWindow MsgWaitForMultipleObjects MsgWaitForMultipleObjectsEx MulDiv MultiByteToWideChar MultinetGetConnectionPerformance NDdeGetErrorString NDdeGetShareSecurity NDdeGetTrustedShare NDdeIsValidAppTopicList NDdeIsValidShareName NDdeSetShareSecurity NDdeSetTrustedShare NDdeShareAdd NDdeShareDel NDdeShareEnum NDdeShareGetInfo NDdeShareSetInfo NDdeTrustedShareEnum NetAccessAdd NetAccessCheck NetAccessDel NetAccessEnum NetAccessGetInfo NetAccessGetUserPerms NetAccessSetInfo NetAlertRaise NetAlertRaiseEx NetApiBufferAllocate NetApiBufferFree NetApiBufferReallocate NetApiBufferSize NetAuditClear NetAuditRead Netbios NetConfigGet NetConfigGetAll NetConfigSet NetConnectionEnum NetErrorLogClear NetErrorLogRead NetFileClose NetFileEnum NetFileGetInfo NetGetAnyDCName NetGetDCName NetGetDisplayInformationIndex NetGroupAdd NetGroupAddUser NetGroupDel NetGroupDelUser NetGroupEnum NetGroupGetInfo NetGroupGetUsers NetGroupSetInfo NetGroupSetUsers NetHandleGetInfo NetHandleSetInfo NetLocalGroupAdd NetLocalGroupAddMember NetLocalGroupAddMembers NetLocalGroupDel NetLocalGroupDelMember NetLocalGroupDelMembers NetLocalGroupEnum NetLocalGroupGetInfo NetLocalGroupGetMembers NetLocalGroupSetInfo NetLocalGroupSetMembers NetMessageBufferSend NetMessageNameAdd NetMessageNameDel NetMessageNameEnum NetMessageNameGetInfo NetQueryDisplayInformation NetRemoteTOD NetReplExportDirAdd NetReplExportDirDel NetReplExportDirEnum NetReplExportDirGetInfo NetReplExportDirLock NetReplExportDirSetInfo NetReplExportDirUnlock NetReplGetInfo NetReplImportDirAdd NetReplImportDirDel NetReplImportDirEnum NetReplImportDirGetInfo NetReplImportDirLock NetReplImportDirUnlock NetReplSetInfo NetScheduleJobAdd NetScheduleJobDel NetScheduleJobEnum NetScheduleJobGetInfo NetServerDiskEnum NetServerEnum NetServerGetInfo NetServerSetInfo NetServerTransportAdd NetServerTransportDel NetServerTransportEnum NetServiceControl NetServiceEnum NetServiceGetInfo NetServiceInstall NetSessionDel NetSessionEnum NetSessionGetInfo NetShareAdd NetShareCheck NetShareDel NetShareEnum NetShareGetInfo NetShareSetInfo NetStatisticsGet NetStatisticsGet2 NetUseAdd NetUseDel NetUseEnum NetUseGetInfo NetUserAdd NetUserChangePassword NetUserDel NetUserEnum NetUserGetGroups NetUserGetInfo NetUserGetLocalGroups NetUserModalsGet NetUserModalsSet NetUserSetGroups NetUserSetInfo NetWkstaGetInfo NetWkstaSetInfo NetWkstaTransportAdd NetWkstaTransportDel NetWkstaTransportEnum NetWkstaUserEnum NetWkstaUserGetInfo NetWkstaUserSetInfo NotifyBootConfigStatus NotifyChangeEventLog ObjectCloseAuditAlarm ObjectDeleteAuditAlarm ObjectOpenAuditAlarm ObjectPrivilegeAuditAlarm OemKeyScan OemToAnsi OemToAnsiBuff OemToChar OemToCharBuff OffsetClipRgn OffsetRect OffsetRgn OffsetViewportOrgEx OffsetWindowOrgEx OFNHookProc OFNHookProcOldStyle OpenBackupEventLog OpenClipboard OpenDesktop OpenEvent OpenEventLog OpenFile OpenFileMapping OpenIcon OpenInputDesktop OpenMutex OpenPrinter OpenProcess OpenProcessToken OpenSCManager OpenSemaphore OpenService OpenThreadToken OpenWaitableTimer OpenWindowStation ORASADFunc OutputDebugString OutputProc PackDDElParam PagePaintHook PageSetupDlg PageSetupHook PaintDesktop PaintRgn PatBlt PathToRegion PeekConsoleInput PeekMessage PeekNamedPipe PlayEnhMetaFile PlayEnhMetaFileRecord PlayMetaFile PlayMetaFileRecord PlgBlt PolyBezier PolyBezierTo PolyDraw PolylineTo PolyPolygon PolyPolyline PolyTextOut PostAppMessage PostMessage PostQueuedCompletionStatus PostQuitMessage PostThreadMessage PrepareTape PrintDlg PrinterMessageBox PrinterProperties PrintHookProc PrivilegeCheck PrivilegedServiceAuditAlarm PropEnumProc PropEnumProcEx PropertySheet PropSheetPageProc PropSheetProc PtInRect PtInRegion PtVisible PulseEvent PurgeComm QueryDosDevice QueryPerformanceCounter QueryPerformanceFrequency QueryServiceConfig QueryServiceLockStatus QueryServiceObjectSecurity QueryServiceStatus QueueUserAPC RaiseException RASADFunc RasAdminAcceptNewConnection RasAdminConnectionHangupNotification RasAdminFreeBuffer RasAdminGetErrorString RasAdminGetIpAddressForUser RasAdminGetUserAccountServer RasAdminPortClearStatistics RasAdminPortDisconnect RasAdminPortEnum RasAdminPortGetInfo RasAdminReleaseIpAddress RasAdminServerGetInfo RasAdminUserGetInfo RasAdminUserSetInfo RasConnectionNotification RasCreatePhonebookEntry RasDeleteEntry RasDial RasDialDlg RasDialFunc RasDialFunc1 RasDialFunc2 RasEditPhonebookEntry RasEntryDlg RasEnumAutodialAddresses RasEnumConnections RasEnumDevices RasEnumEntries RasGetAutodialAddress RasGetAutodialEnable RasGetAutodialParam RasGetConnectStatus RasGetCountryInfo RasGetCredentials RasGetEntryDialParams RasGetEntryProperties RasGetErrorString RasGetProjectionInfo RasGetSubEntryHandle RasGetSubEntryProperties RasHangUp Rsmonitordlg RasPBDlgFunc RasPhonebookDlg RasRenameEntry RasSecurityDialogBegin RasSecurityDialogComplete RasSecurityDialogEnd RasSecurityDialogGetInfo RasSecurityDialogReceive RasSecurityDialogSend RasSetAutodialAddress RasSetAutodialEnable RasSetAutodialParam RasSetCredentials RasSetEntryDialParams RasSetEntryProperties RasSetSubEntryProperties RasValidateEntryName ReadConsole ReadConsoleInput ReadConsoleOutput ReadConsoleOutputAttribute ReadConsoleOutputCharacter ReadDirectoryChangesW ReadEventLog ReadFile ReadFileEx ReadPrinter ReadProcessMemory RealizePalette RectInRegion RectVisible RedrawWindow RegCloseKey RegConnectRegistry RegCreateKey RegCreateKeyEx RegDeleteKey RegDeleteValue RegEnumKey RegEnumKeyEx RegEnumValue RegFlushKey RegGetKeySecurity RegisterClass RegisterClassEx RegisterClipboardFormat RegisterDialogClasses RegisterEventSource RegisterHotKey RegisterServiceCtrlHandler RegisterWindowMessage RegLoadKey RegNotifyChangeKeyValue RegOpenKey RegOpenKeyEx RegQueryInfoKey RegQueryMultipleValues RegQueryValue RegQueryValueEx RegReplaceKey RegRestoreKey RegSaveKey RegSetKeySecurity RegSetValue RegSetValueEx RegUnLoadKey ReleaseCapture ReleaseDC ReleaseMutex ReleaseSemaphore RemoveDirectory RemoveFontResource RemoveMenu RemoveProp ReplaceText ReplyMessage ReportEvent ResetDC ResetEvent ResetPrinter ResizePalette RestoreDC ResumeThread ReuseDDElParam RevertToSelf RoundRect SaveDC ScaleViewportExtEx ScaleWindowExtEx ScheduleJob ScreenSaverConfigureDialog ScreenSaverProc ScreenToClient ScrollConsoleScreenBuffer ScrollDC ScrollWindow ScrollWindowEx SearchPath SelectClipPath SelectClipRgn SelectObject SelectPalette SendAsyncProc SendDlgItemMessage SendMessage SendMessageCallback SendMessageTimeout SendNotifyMessage ServiceMain SetAbortProc SetAclInformation SetActiveWindow SetArcDirection SetBitmapBits SetBitmapDimensionEx SetBkColor SetBkMode SetBoundsRect SetBrushOrgEx SetCapture SetCaretBlinkTime SetCaretPos SetClassLong SetClassWord SetClipboardData SetClipboardViewer SetColorAdjustment SetColorSpace SetCommBreak SetCommConfig SetCommMask SetCommState SetCommTimeouts SetComputerName SetConsoleActiveScreenBuffer SetConsoleCP SetConsoleCtrlHandler SetConsoleCursorInfo SetConsoleCursorPosition SetConsoleMode SetConsoleOutputCP SetConsoleScreenBufferSize SetConsoleTextAttribute SetConsoleTitle SetConsoleWindowInfo SetCurrentDirectory SetCursor SetCursorPos SetDebugErrorLevel SetDefaultCommConfig SetDeviceGammaRamp SetDIBColorTable SetDIBits SetDIBitsToDevice SetDlgItemInt SetDlgItemText SetDoubleClickTime SetEndOfFile SetEnhMetaFileBits SetEntriesInAcl SetEnvironmentVariable SetErrorMode SetEvent SetFileApisToANSI SetFileApisToOEM SetFileAttributes SetFilePointer SetFileSecurity SetFileTime SetFocus SetForegroundWindow SetForm SetGraphicsMode SetHandleCount SetHandleInformation SetICMMode SetICMProfile SetJob SetKernelObjectSecurity SetKeyboardState SetLastError SetLastErrorEx SetLocaleInfo SetLocalTime SetMailslotInfo SetMapMode SetMapperFlags SetMenu SetMenuContextHelpId SetMenuDefaultItem SetMenuItemBitmaps SetMenuItemInfo SetMessageExtraInfo SetMessageQueue SetMetaFileBitsEx SetMetaRgn SetMiterLimit SetNamedPipeHandleState SetPaletteEntries SetParent SetPixel SetPixelV SetPolyFillMode SetPort SetPrinter SetPrinterData SetPriorityClass SetPrivateObjectSecurity SetProcessAffinityMask SetProcessPriorityBoost SetProcessShutdownParameters SetProcessWindowStation SetProcessWorkingSetSize SetProp SetRect SetRectEmpty SetRectRgn SetROP2 SetScrollInfo SetScrollPos SetScrollRange SetSecurityDescriptorDacl SetSecurityDescriptorGroup SetSecurityDescriptorOwner SetSecurityDescriptorSacl SetSecurityInfo SetServiceBits SetServiceObjectSecurity SetServiceStatus SetStdHandle SetStretchBltMode SetSwapAreaSize SetSysColors SetSysModalWindow SetSystemCursor SetSystemPaletteUse SetSystemPowerState SetSystemTime SetSystemTimeAdjustment SetTapeParameters SetTapePosition SetTextAlign SetTextCharacterExtra SetTextColor SetTextJustification SetThreadAffinityMask SetThreadContext SetThreadDesktop SetThreadIdealProcessor SetThreadLocale SetThreadPriority SetThreadPriorityBoost SetThreadToken SetTimer SetTimeZoneInformation SetTokenInformation SetUnhandledExceptionFilter SetupComm SetupHookProc SetUserObjectInformation SetUserObjectSecurity SetViewportExtEx SetViewportOrgEx SetVolumeLabel SetWaitableTimer SetWindowContextHelpId SetWindowExtEx SetWindowLong SetWindowOrgEx SetWindowPlacement SetWindowPos SetWindowRgn SetWindowsHook SetWindowsHookEx SetWindowText SetWindowWord SetWinMetaFileBits SetWorldTransform SHAddToRecentDocs SHAppBarMessage SHBrowseForFolder SHChangeNotify Shell_NotifyIcon ShellAbout ShellExecute ShellExecuteEx ShellProc SHFileOperation SHFreeNameMappings SHGetDataFromIDList SHGetDesktopFolder SHGetFileInfo SHGetInstanceExplorer SHGetMalloc SHGetPathFromIDList SHGetSpecialFolderLocation SHLoadInProc ShowCaret ShowCursor ShowHideMenuCtl ShowOwnedPopups ShowScrollBar ShowWindow ShowWindowAsync SignalObjectAndWait SizeofResource SleepEx SnmpExtensionInit SnmpExtensionInitEx SnmpExtensionQuery SnmpExtensionTrap SnmpMgrClose SnmpMgrGetTrap SnmpMgrOidToStr SnmpMgrOpen SnmpMgrRequest SnmpMgrStrToOid SnmpMgrTrapListen SnmpUtilMemAlloc SnmpUtilMemFree SnmpUtilMemReAlloc SnmpUtilOidAppend SnmpUtilOidCmp SnmpUtilOidCpy SnmpUtilOidFree SnmpUtilOidNCmp SnmpUtilVarBindCpy SnmpUtilVarBindListCpy SnmpUtilVarBindFree SnmpUtilVarBindListFree SOBailOut SOBeginTable SOEndColumnInfo SOEndFieldInfo SOEndFontTable SOEndPalette SOEndTable SOEndTabStops SOGetInfo SOGetScanLineBuffer SOPutBitmapHeader SOPutBreak SOPutChar SOPutCharAttr SOPutCharFontById SOPutCharFontByName SOPutCharHeight SOPutCharX SOPutColumnInfo SOPutDataCell SOPutEmbeddedObject SOPutField SOPutFieldInfo SOPutFontTableEntry SOPutHdrEntry SOPutMoreText SOPutMoreVarField SOPutPaletteEntry SOPutParaAlign SOPutParaIndents SOPutParaMargins SOPutParaSpacing SOPutScanLineData SOPutSectionName SOPutSectionType SOPutSpecialCharX SOPutSubdocInfo SOPutTableCellInfo SOPutTableRowFormat SOPutTabStop SOPutTextCell SOPutVarField SOPutVectorHeader SOSetDateBase SOStartColumnInfo SOStartFieldInfo SOStartFontTable SOStartPalette SOStartTabStops SoundSentryProc SOVectorAttr SOVectorObject SUUserPopData SUUserPushData SUUserRetrieveData SUUserSaveData StartDoc StartDocPrinter StartPage StartPagePrinter StartService StartServiceCtrlDispatcher StretchBlt StretchDIBits StrokeAndFillPath StrokePath SubtractRect SuspendThread SwapMouseButton SwitchDesktop SwitchToFiber SwitchToThread SysMsgProc SystemParametersInfo SystemTimeToFileTime SystemTimeToTzSpecificLocalTime TabbedTextOut TerminateProcess TerminateThread TextOut TileWindows TimerProc TlsAlloc TlsFree TlsGetValue TlsSetValue ToAscii ToAsciiEx ToUnicode ToUnicodeEx TrackMouseEvent TrackPopupMenu TrackPopupMenuEx TransactNamedPipe TranslateAccelerator TranslateCharsetInfo TranslateMDISysAccel TranslateMessage TransmitCommChar TryEnterCriticalSection UInt32x32To64 UndeleteFile UnhandledExceptionFilter UnhookWindowsHook UnhookWindowsHookEx UnionRect UnloadKeyboardLayout UnlockFile UnlockFileEx UnlockResource UnlockSegment UnlockServiceDatabase UnmapViewOfFile UnpackDDElParam UnrealizeObject UnregisterClass UnregisterHotKey UpdateColors UpdateICMRegKey UpdateResource UpdateWindow ValidateRect ValidateRgn VerFindFile VerInstallFile VerLanguageName VerQueryValue VirtualAlloc VirtualAllocEx VirtualFree VirtualFreeEx VirtualLock VirtualProtect VirtualProtectEx VirtualQuery VirtualQueryEx VirtualUnlock VkKeyScan VkKeyScanEx VwStreamCloseFunc VwStreamOpenFunc VwStreamReadFunc VwStreamReadRecordFunc VwStreamSectionFunc VwStreamSeekFunc VwStreamTellFunc WaitCommEvent WaitForDebugEvent WaitForInputIdle WaitForMultipleObjects WaitForMultipleObjectsEx WaitForPrinterChange WaitForSingleObject WaitForSingleObjectEx WaitMessage WaitNamedPipe WideCharToMultiByte WidenPath WindowFromDC WindowFromPoint WindowProc WinExec WinHelp WinLoadTrustProvider WinMain WinSubmitCertificate WinTrustProviderClientInitialize WinTrustProviderClientUnload WinTrustProviderPing WinTrustProviderServerInitialize WinTrustProviderServerUnload WinTrustProviderSubmitCertificate WinTrustProviderVerifyTrust WinTrustSipInitialize WinTrustSubjectCheckContentInfo WinTrustSubjectEnumCertificates WinTrustSubjectGetCertHeader WinTrustSubjectGetCertificate WinTrustSubjectGetName WinVerifyTrust WNetAddConnection WNetAddConnection2 WNetAddConnection3 WNetCancelConnection WNetCancelConnection2 WNetCloseEnum WNetConnectionDialog WNetDisconnectDialog WNetEnumResource WNetGetConnection WNetGetLastError WNetGetUniversalName WNetGetUser WNetOpenEnum WriteConsole WriteConsoleInput WriteConsoleOutput WriteConsoleOutputAttribute WriteConsoleOutputCharacter WriteFile WriteFileEx WritePrinter WritePrivateProfileSection WritePrivateProfileString WritePrivateProfileStruct WriteProcessMemory WriteProfileSection WriteProfileString WriteTapemark wsprintf wvsprintf Yield ZeroMemory ABM_ACTIVATE ABM_GETAUTOHIDEBAR ABM_GETSTATE ABM_GETTASKBARPOS ABM_NEW ABM_QUERYPOS ABM_REMOVE ABM_SETAUTOHIDEBAR ABM_SETPOS ABM_WINDOWPOSCHANGED ABN_FULLSCREENAPP ABN_POSCHANGED ABN_STATECHANGE ABN_WINDOWARRANGE ACM_OPEN ACM_PLAY ACM_STOP ACN_START ACN_STOP BM_CLICK BM_GETCHECK BM_GETIMAGE BM_GETSTATE BM_SETCHECK BM_SETIMAGE BM_SETSTATE BM_SETSTYLE BN_CLICKED BN_DBLCLK BN_DISABLE BN_DOUBLECLICKED BN_HILITE BN_KILLFOCUS BN_PAINT BN_PUSHED BN_SETFOCUS BN_UNHILITE BN_UNPUSHED CB_ADDSTRING CB_DELETESTRING CB_DIR CB_FINDSTRING CB_FINDSTRINGEXACT CB_GETCOUNT CB_GETCURSEL CB_GETDROPPEDCONTROLRECT CB_GETDROPPEDSTATE CB_GETDROPPEDWIDTH CB_GETEDITSEL CB_GETEXTENDEDUI CB_GETHORIZONTALEXTENT CB_GETITEMDATA CB_GETITEMHEIGHT CB_GETLBTEXT CB_GETLBTEXTLEN CB_GETLOCALE CB_GETTOPINDEX CB_INITSTORAGE CB_INSERTSTRING CB_LIMITTEXT CB_RESETCONTENT CB_SELECTSTRING CB_SETCURSEL CB_SETDROPPEDWIDTH CB_SETEDITSEL CB_SETEXTENDEDUI CB_SETHORIZONTALEXTENT CB_SETITEMDATA CB_SETITEMHEIGHT CB_SETLOCALE CB_SETTOPINDEX CB_SHOWDROPDOWN CBN_CLOSEUP CBN_DBLCLK CBN_DROPDOWN CBN_EDITCHANGE CBN_EDITUPDATE CBN_ERRSPACE CBN_KILLFOCUS CBN_SELCHANGE CBN_SELENDCANCEL CBN_SELENDOK CBN_SETFOCUS CDM_GETFILEPATH CDM_GETFOLDERIDLIST CDM_GETFOLDERPATH CDM_GETSPEC CDM_HIDECONTROL CDM_SETCONTROLTEXT CDM_SETDEFEXT CDN_FILEOK CDN_FOLDERCHANGE CDN_HELP CDN_INITDONE CDN_SELCHANGE CDN_SHAREVIOLATION CDN_TYPECHANGE COLOROKSTRING CPL_DBLCLK CPL_EXIT CPL_GETCOUNT CPL_INIT CPL_INQUIRE CPL_NEWINQUIRE CPL_SELECT CPL_STOP DBT_CONFIGCHANGECANCELED DBT_CONFIGCHANGED DBT_DEVICEARRIVAL DBT_DEVICEQUERYREMOVE DBT_DEVICEQUERYREMOVEFAILED DBT_DEVICEREMOVECOMPLETE DBT_DEVICEREMOVEPENDING DBT_DEVICETYPESPECIFIC DBT_QUERYCHANGECONFIG DBT_USERDEFINED DL_BEGINDRAG DL_CANCELDRAG DL_DRAGGING DL_DROPPED DM_GETDEFID DM_REPOSITION DM_SETDEFID EM_CANPASTE EM_CANUNDO EM_CHARFROMPOS EM_DISPLAYBAND EM_EMPTYUNDOBUFFER EM_EXGETSEL EM_EXLIMITTEXT EM_EXLINEFROMCHAR EM_EXSETSEL EM_FINDTEXT EM_FINDWORDBREAK EM_FMTLINES EM_FORMATRANGE EM_GETCHARFORMAT EM_GETEVENTMASK EM_GETFIRSTVISIBLELINE EM_GETHANDLE EM_GETIMECOLOR EM_GETIMEOPTIONS EM_GETLIMITTEXT EM_GETLINE EM_GETLINECOUNT EM_GETMARGINS EM_GETMODIFY EM_GETOLEINTERFACE EM_GETOPTIONS EM_GETPARAFORMAT EM_GETPASSWORDCHAR EM_GETPUNCTUATION EM_GETRECT EM_GETSEL EM_GETSELTEXT EM_GETTEXTRANGE EM_GETTHUMB EM_GETWORDBREAKPROC EM_GETWORDBREAKPROCEX EM_GETWORDWRAPMODE EM_HIDESELECTION EM_LIMITTEXT EM_LINEFROMCHAR EM_LINEINDEX EM_LINELENGTH EM_LINESCROLL EM_PASTESPECIAL EM_POSFROMCHAR EM_REPLACESEL EM_REQUESTRESIZE EM_SCROLL EM_SCROLLCARET EM_SELECTIONTYPE EM_SETBKGNDCOLOR EM_SETCHARFORMAT EM_SETEVENTMASK EM_SETHANDLE EM_SETIMECOLOR EM_SETIMEOPTIONS EM_SETLIMITTEXT EM_SETMARGINS EM_SETMODIFY EM_SETOLEINTERFACE EM_SETOPTIONS EM_SETPARAFORMAT EM_SETPASSWORDCHAR EM_SETPUNCTUATION EM_SETREADONLY EM_SETRECT EM_SETRECTNP EM_SETSEL EM_SETTABSTOPS EM_SETTARGETDEVICE EM_SETWORDBREAK EM_SETWORDBREAKPROC EM_SETWORDBREAKPROCEX EM_SETWORDWRAPMODE EM_STREAMIN EM_STREAMOUT EM_UNDO EN_CHANGE EN_CORRECTTEXT EN_DROPFILES EN_ERRSPACE EN_HSCROLL EN_IMECHANGE EN_KILLFOCUS EN_MAXTEXT EN_MSGFILTER EN_OLEOPFAILED EN_PROTECTED EN_REQUESTRESIZE EN_SAVECLIPBOARD EN_SELCHANGE EN_SETFOCUS EN_STOPNOUNDO EN_UPDATE EN_VSCROLL FILEOKSTRING FINDMSGSTRING FM_GETDRIVEINFO FM_GETFILESEL FM_GETFILESELLFN FM_GETFOCUS FM_GETSELCOUNT FM_GETSELCOUNTLFN FM_REFRESH_WINDOWS FM_RELOAD_EXTENSIONS FMEVENT_HELPMENUITEM FMEVENT_HELPSTRING FMEVENT_INITMENU FMEVENT_LOAD FMEVENT_SELCHANGE FMEVENT_TOOLBARLOAD FMEVENT_UNLOAD FMEVENT_USER_REFRESH HDM_DELETEITEM HDM_GETITEM HDM_GETITEMCOUNT HDM_HITTEST HDM_INSERTITEM HDM_LAYOUT HDM_SETITEM HDN_BEGINTRACK HDN_DIVIDERDBLCLICK HDN_ENDTRACK HDN_ITEMCHANGED HDN_ITEMCHANGING HDN_ITEMCLICK HDN_ITEMDBLCLICK HDN_TRACK HELPMSGSTRING HKM_GETHOTKEY HKM_SETHOTKEY HKM_SETRULES IMC_CLOSESTATUSWINDOW IMC_GETCANDIDATEPOS IMC_GETCOMPOSITIONFONT IMC_GETCOMPOSITIONWINDOW IMC_GETCONVERSIONMODE IMC_GETOPENSTATUS IMC_GETSENTENCEMODE IMC_GETSTATUSWINDOWPOS IMC_OPENSTATUSWINDOW IMC_SETCANDIDATEPOS IMC_SETCOMPOSITIONFONT IMC_SETCOMPOSITIONWINDOW IMC_SETCONVERSIONMODE IMC_SETOPENSTATUS IMC_SETSENTENCEMODE IMC_SETSTATUSWINDOWPOS IMN_CHANGECANDIDATE IMN_CLOSECANDIDATE IMN_CLOSESTATUSWINDOW IMN_GUIDELINE IMN_OPENCANDIDATE IMN_OPENSTATUSWINDOW IMN_SETCANDIDATEPOS IMN_SETCOMPOSITIONFONT IMN_SETCOMPOSITIONWINDOW IMN_SETCONVERSIONMODE IMN_SETOPENSTATUS IMN_SETSENTENCEMODE IMN_SETSTATUSWINDOWPOS LB_ADDFILE LB_ADDSTRING LB_DELETESTRING LB_DIR LB_FINDSTRING LB_FINDSTRINGEXACT LB_GETANCHORINDEX LB_GETCARETINDEX LB_GETCOUNT LB_GETCURSEL LB_GETHORIZONTALEXTENT LB_GETITEMDATA LB_GETITEMHEIGHT LB_GETITEMRECT LB_GETLOCALE LB_GETSEL LB_GETSELCOUNT LB_GETSELITEMS LB_GETTEXT LB_GETTEXTLEN LB_GETTOPINDEX LB_INITSTORAGE LB_INSERTSTRING LB_ITEMFROMPOINT LB_RESETCONTENT LB_SELECTSTRING LB_SELITEMRANGE LB_SELITEMRANGEEX LB_SETANCHORINDEX LB_SETCARETINDEX LB_SETCOLUMNWIDTH LB_SETCOUNT LB_SETCURSEL LB_SETHORIZONTALEXTENT LB_SETITEMDATA LB_SETITEMHEIGHT LB_SETLOCALE LB_SETSEL LB_SETTABSTOPS LB_SETTOPINDEX LBN_DBLCLK LBN_ERRSPACE LBN_KILLFOCUS LBN_SELCANCEL LBN_SELCHANGE LBN_SETFOCUS LBSELCHSTRING LVM_ARRANGE LVM_CREATEDRAGIMAGE LVM_DELETEALLITEMS LVM_DELETECOLUMN LVM_DELETEITEM LVM_EDITLABEL LVM_ENSUREVISIBLE LVM_FINDITEM LVM_GETBKCOLOR LVM_GETCALLBACKMASK LVM_GETCOLUMN LVM_GETCOLUMNWIDTH LVM_GETCOUNTPERPAGE LVM_GETEDITCONTROL LVM_GETIMAGELIST LVM_GETISEARCHSTRING LVM_GETITEM LVM_GETITEMCOUNT LVM_GETITEMPOSITION LVM_GETITEMRECT LVM_GETITEMSPACING LVM_GETITEMSTATE LVM_GETITEMTEXT LVM_GETNEXTITEM LVM_GETORIGIN LVM_GETSELECTEDCOUNT LVM_GETSTRINGWIDTH LVM_GETTEXTBKCOLOR LVM_GETTEXTCOLOR LVM_GETTOPINDEX LVM_GETVIEWRECT LVM_HITTEST LVM_INSERTCOLUMN LVM_INSERTITEM LVM_REDRAWITEMS LVM_SCROLL LVM_SETBKCOLOR LVM_SETCALLBACKMASK LVM_SETCOLUMN LVM_SETCOLUMNWIDTH LVM_SETIMAGELIST LVM_SETITEM LVM_SETITEMCOUNT LVM_SETITEMPOSITION LVM_SETITEMPOSITION32 LVM_SETITEMSTATE LVM_SETITEMTEXT LVM_SETTEXTBKCOLOR LVM_SETTEXTCOLOR LVM_SORTITEMS LVM_UPDATE LVN_BEGINDRAG LVN_BEGINLABELEDIT LVN_BEGINRDRAG LVN_COLUMNCLICK LVN_DELETEALLITEMS LVN_DELETEITEM LVN_ENDLABELEDIT LVN_GETDISPINFO LVN_INSERTITEM LVN_ITEMCHANGED LVN_ITEMCHANGING LVN_KEYDOWN LVN_SETDISPINFO NIM_ADD NIM_DELETE NIM_MODIFY NM_CLICK NM_DBLCLK NM_KILLFOCUS NM_OUTOFMEMORY NM_RCLICK NM_RDBLCLK NM_RETURN NM_SETFOCUS PBM_DELTAPOS PBM_SETPOS PBM_SETRANGE PBM_SETSTEP PBM_STEPIT PBT_APMBATTERYLOW PBT_APMOEMEVENT PBT_APMPOWERSTATUSCHANGE PBT_APMQUERYSUSPEND PBT_APMQUERYSUSPENDFAILED PBT_APMRESUMECRITICAL PBT_APMRESUMESUSPEND PBT_APMSUSPEND PSM_ADDPAGE PSM_APPLY PSM_CANCELTOCLOSE PSM_CHANGED PSM_GETCURRENTPAGEHWND PSM_GETTABCONTROL PSM_ISDIALOGMESSAGE PSM_PRESSBUTTON PSM_QUERYSIBLINGS PSM_REBOOTSYSTEM PSM_REMOVEPAGE PSM_RESTARTWINDOWS PSM_SETCURSEL PSM_SETCURSELID PSM_SETFINISHTEXT PSM_SETTITLE PSM_SETWIZBUTTONS PSM_UNCHANGED PSN_APPLY PSN_HELP PSN_KILLACTIVE PSN_QUERYCANCEL PSN_RESET PSN_SETACTIVE PSN_WIZBACK PSN_WIZFINISH PSN_WIZNEXT SB_GETBORDERS SB_GETPARTS SB_GETRECT SB_GETTEXT SB_GETTEXTLENGTH SB_SETMINHEIGHT SB_SETPARTS SB_SETTEXT SB_SIMPLE SBM_ENABLE_ARROWS SBM_GETPOS SBM_GETRANGE SBM_GETSCROLLINFO SBM_SETPOS SBM_SETRANGE SBM_SETRANGEREDRAW SBM_SETSCROLLINFO SETRGBSTRING SHAREVISTRING STM_GETICON STM_GETIMAGE STM_SETICON STM_SETIMAGE STN_CLICKED STN_DBLCLK STN_DISABLE STN_ENABLE TB_ADDBITMAP TB_ADDBUTTONS TB_ADDSTRING TB_AUTOSIZE TB_BUTTONCOUNT TB_BUTTONSTRUCTSIZE TB_CHANGEBITMAP TB_CHECKBUTTON TB_COMMANDTOINDEX TB_CUSTOMIZE TB_DELETEBUTTON TB_ENABLEBUTTON TB_GETBITMAP TB_GETBITMAPFLAGS TB_GETBUTTON TB_GETBUTTONTEXT TB_GETITEMRECT TB_GETROWS TB_GETSTATE TB_GETTOOLTIPS TB_HIDEBUTTON TB_INDETERMINATE TB_INSERTBUTTON TB_ISBUTTONCHECKED TB_ISBUTTONENABLED TB_ISBUTTONHIDDEN TB_ISBUTTONINDETERMINATE TB_ISBUTTONPRESSED TB_PRESSBUTTON TB_SAVERESTORE TB_SETBITMAPSIZE TB_SETBUTTONSIZE TB_SETCMDID TB_SETPARENT TB_SETROWS TB_SETSTATE TB_SETTOOLTIPS TBM_CLEARSEL TBM_CLEARTICS TBM_GETCHANNELRECT TBM_GETLINESIZE TBM_GETNUMTICS TBM_GETPAGESIZE TBM_GETPOS TBM_GETPTICS TBM_GETRANGEMAX TBM_GETRANGEMIN TBM_GETSELEND TBM_GETSELSTART TBM_GETTHUMBLENGTH TBM_GETTHUMBRECT TBM_GETTIC TBM_GETTICPOS TBM_SETLINESIZE TBM_SETPAGESIZE TBM_SETPOS TBM_SETRANGE TBM_SETRANGEMAX TBM_SETRANGEMIN TBM_SETSEL TBM_SETSELEND TBM_SETSELSTART TBM_SETTHUMBLENGTH TBM_SETTIC TBM_SETTICFREQ TBN_BEGINADJUST TBN_BEGINDRAG TBN_CUSTHELP TBN_ENDADJUST TBN_ENDDRAG TBN_GETBUTTONINFO TBN_QUERYDELETE TBN_QUERYINSERT TBN_RESET TBN_TOOLBARCHANGE TCM_ADJUSTRECT TCM_DELETEALLITEMS TCM_DELETEITEM TCM_GETCURFOCUS TCM_GETCURSEL TCM_GETIMAGELIST TCM_GETITEM TCM_GETITEMCOUNT TCM_GETITEMRECT TCM_GETROWCOUNT TCM_GETTOOLTIPS TCM_HITTEST TCM_INSERTITEM TCM_REMOVEIMAGE TCM_SETCURFOCUS TCM_SETCURSEL TCM_SETIMAGELIST TCM_SETITEM TCM_SETITEMEXTRA TCM_SETITEMSIZE TCM_SETPADDING TCM_SETTOOLTIPS TCN_KEYDOWN TCN_SELCHANGE TCN_SELCHANGING TTM_ACTIVATE TTM_DELTOOL TTM_ENUMTOOLS TTM_GETCURRENTTOOL TTM_GETTEXT TTM_GETTOOLCOUNT TTM_GETTOOLINFO TTM_HITTEST TTM_NEWTOOLRECT TTM_RELAYEVENT TTM_SETDELAYTIME TTM_SETTOOLINFO TTM_UPDATETIPTEXT TTM_WINDOWFROMPOINT TTN_NEEDTEXT TTN_POP TTN_SHOW TVM_CREATEDRAGIMAGE TVM_DELETEITEM TVM_EDITLABEL TVM_ENDEDITLABELNOW TVM_ENSUREVISIBLE TVM_EXPAND TVM_GETCOUNT TVM_GETEDITCONTROL TVM_GETIMAGELIST TVM_GETINDENT TVM_GETISEARCHSTRING TVM_GETITEM TVM_GETITEMRECT TVM_GETNEXTITEM TVM_GETVISIBLECOUNT TVM_HITTEST TVM_INSERTITEM TVM_SELECTITEM TVM_SETIMAGELIST TVM_SETINDENT TVM_SETITEM TVM_SORTCHILDREN TVM_SORTCHILDRENCB TVN_BEGINDRAG TVN_BEGINLABELEDIT TVN_BEGINRDRAG TVN_DELETEITEM TVN_ENDLABELEDIT TVN_GETDISPINFO TVN_ITEMEXPANDED TVN_ITEMEXPANDING TVN_KEYDOWN TVN_SELCHANGED TVN_SELCHANGING TVN_SETDISPINFO UDM_GETACCEL UDM_GETBASE UDM_GETBUDDY UDM_GETPOS UDM_GETRANGE UDM_SETACCEL UDM_SETBASE UDM_SETBUDDY UDM_SETPOS UDM_SETRANGE UDN_DELTAPOS WM_ACTIVATE WM_ACTIVATEAPP WM_ASKCBFORMATNAME WM_CANCELJOURNAL WM_CANCELMODE WM_CAPTURECHANGED WM_CHANGECBCHAIN WM_CHAR WM_CHARTOITEM WM_CHILDACTIVATE WM_CHOOSEFONT_GETLOGFONT WM_CHOOSEFONT_SETFLAGS WM_CHOOSEFONT_SETLOGFONT WM_CLEAR WM_CLOSE WM_COMMAND WM_COMPACTING WM_COMPAREITEM WM_CONTEXTMENU WM_COPY WM_COPYDATA WM_CPL_LAUNCH WM_CPL_LAUNCHED WM_CREATE WM_CTLCOLORBTN WM_CTLCOLORDLG WM_CTLCOLOREDIT WM_CTLCOLORLISTBOX WM_CTLCOLORMSGBOX WM_CTLCOLORSCROLLBAR WM_CTLCOLORSTATIC WM_CUT WM_DDE_ACK WM_DDE_ADVISE WM_DDE_DATA WM_DDE_EXECUTE WM_DDE_INITIATE WM_DDE_POKE WM_DDE_REQUEST WM_DDE_TERMINATE WM_DDE_UNADVISE WM_DEADCHAR WM_DELETEITEM WM_DESTROY WM_DESTROYCLIPBOARD WM_DEVICECHANGE WM_DEVMODECHANGE WM_DISPLAYCHANGE WM_DRAWCLIPBOARD WM_DRAWITEM WM_DROPFILES WM_ENABLE WM_ENDSESSION WM_ENTERIDLE WM_ENTERMENULOOP WM_ENTERSIZEMOVE WM_ERASEBKGND WM_EXITMENULOOP WM_EXITSIZEMOVE WM_FONTCHANGE WM_GETDLGCODE WM_GETFONT WM_GETHOTKEY WM_GETICON WM_GETMINMAXINFO WM_GETTEXT WM_GETTEXTLENGTH WM_HELP WM_HOTKEY WM_HSCROLL WM_HSCROLLCLIPBOARD WM_ICONERASEBKGND WM_IME_CHAR WM_IME_COMPOSITION WM_IME_COMPOSITIONFULL WM_IME_CONTROL WM_IME_ENDCOMPOSITION WM_IME_KEYDOWN WM_IME_KEYUP WM_IME_NOTIFY WM_IME_SELECT WM_IME_SETCONTEXT WM_IME_STARTCOMPOSITION WM_INITDIALOG WM_INITMENU WM_INITMENUPOPUP WM_INPUTLANGCHANGE WM_INPUTLANGCHANGEREQUEST WM_KEYDOWN WM_KEYUP WM_KILLFOCUS WM_LBUTTONDBLCLK WM_LBUTTONDOWN WM_LBUTTONUP WM_MBUTTONDBLCLK WM_MBUTTONDOWN WM_MBUTTONUP WM_MDIACTIVATE WM_MDICASCADE WM_MDICREATE WM_MDIDESTROY WM_MDIGETACTIVE WM_MDIICONARRANGE WM_MDIMAXIMIZE WM_MDINEXT WM_MDIREFRESHMENU WM_MDIRESTORE WM_MDISETMENU WM_MDITILE WM_MEASUREITEM WM_MENUCHAR WM_MENUSELECT WM_MOUSEACTIVATE WM_MOUSEMOVE WM_MOUSEWHEEL WM_MOVE WM_MOVING WM_NCACTIVATE WM_NCCALCSIZE WM_NCCREATE WM_NCDESTROY WM_NCHITTEST WM_NCLBUTTONDBLCLK WM_NCLBUTTONDOWN WM_NCLBUTTONUP WM_NCMBUTTONDBLCLK WM_NCMBUTTONDOWN WM_NCMBUTTONUP WM_NCMOUSEMOVE WM_NCPAINT WM_NCRBUTTONDBLCLK WM_NCRBUTTONDOWN WM_NCRBUTTONUP WM_NEXTDLGCTL WM_NOTIFY WM_NOTIFYFORMAT WM_PAINT WM_PAINTCLIPBOARD WM_PAINTICON WM_PALETTECHANGED WM_PALETTEISCHANGING WM_PARENTNOTIFY WM_PASTE WM_POWER WM_POWERBROADCAST WM_PRINT WM_PRINTCLIENT WM_PSD_ENVSTAMPRECT WM_PSD_FULLPAGERECT WM_PSD_GREEKTEXTRECT WM_PSD_MARGINRECT WM_PSD_MINMARGINRECT WM_PSD_PAGESETUPDLG WM_PSD_YAFULLPAGERECT WM_QUERYDRAGICON WM_QUERYENDSESSION WM_QUERYNEWPALETTE WM_QUERYOPEN WM_QUEUESYNC WM_QUIT WM_RASDIALEVENT WM_RBUTTONDBLCLK WM_RBUTTONDOWN WM_RBUTTONUP WM_RENDERALLFORMATS WM_RENDERFORMAT WM_SETCURSOR WM_SETFOCUS WM_SETFONT WM_SETHOTKEY WM_SETICON WM_SETREDRAW WM_SETTEXT WM_SETTINGCHANGE WM_SHOWWINDOW WM_SIZE WM_SIZECLIPBOARD WM_SIZING WM_SPOOLERSTATUS WM_STYLECHANGED WM_STYLECHANGING WM_SYSCHAR WM_SYSCOLORCHANGE WM_SYSCOMMAND WM_SYSDEADCHAR WM_SYSKEYDOWN WM_SYSKEYUP WM_TCARD WM_TIMECHANGE WM_TIMER WM_UNDO WM_USER WM_USERCHANGED WM_VKEYTOITEM WM_VSCROLL WM_VSCROLLCLIPBOARD WM_WINDOWPOSCHANGED WM_WINDOWPOSCHANGING WM_WININICHANGE ABC ABCFLOAT ACCEL AccelTableEntry ACCESS_ALLOWED_ACE ACCESS_DENIED_ACE ACCESS_MASK ACCESSTIMEOUT ACE ACE_HEADER ACL ACL_REVISION_INFORMATION ACL_SIZE_INFORMATION ACTION_HEADER ADAPTER_STATUS ADDJOB_INFO_1 ADMIN_OTHER_INFO ANIMATIONINFO APPBARDATA AsnAny AsnObjectIdentifier AsnOctetString AT_ENUM AT_INFO AUDIT_ENTRY BITMAP BITMAPCOREHEADER BITMAPCOREINFO BITMAPFILEHEADER BITMAPINFO BITMAPINFOHEADER BITMAPV4HEADER BLOB BROWSEINFO BY_HANDLE_FILE_INFORMATION CANDIDATEFORM CANDIDATELIST CBT_CREATEWND CBTACTIVATESTRUCT CHAR_INFO CHARFORMAT CHARRANGE CHARSET CHARSETINFO CHOOSECOLOR CHOOSEFONT CIDA CIEXYZ CIEXYZTRIPLE CLIENTCREATESTRUCT CMINVOKECOMMANDINFO COLORADJUSTMENT COLORMAP COLORREF COMMCONFIG COMMPROP COMMTIMEOUTS COMPAREITEMSTRUCT COMPCOLOR COMPOSITIONFORM COMSTAT CONFIG_INFO_0 CONNECTION_INFO_0 CONNECTION_INFO_1 CONSOLE_CURSOR_INFO CONSOLE_SCREEN_BUFFER_INFO CONTEXT CONVCONTEXT CONVINFO COORD COPYDATASTRUCT CPINFO CPLINFO CREATE_PROCESS_DEBUG_INFO CREATE_THREAD_DEBUG_INFO CREATESTRUCT CSADDR_INFO CURRENCYFMT CURSORDIR CURSORSHAPE CWPRETSTRUCT CWPSTRUCT DATATYPES_INFO_1 DCB DDEACK DDEADVISE DDEDATA DDELN DDEML_MSG_HOOK_DATA DDEPOKE DDEUP DEBUG_EVENT DEBUGHOOKINFO DELETEITEMSTRUCT DEV_BROADCAST_HDR DEV_BROADCAST_OEM DEV_BROADCAST_PORT _DEV_BROADCAST_USERDEFINED DEV_BROADCAST_VOLUME DEVMODE DEVNAMES DIBSECTION DirEntry DISK_GEOMETRY DISK_PERFORMANCE DLGITEMTEMPLATE DLGITEMTEMPLATEEX DLGTEMPLATE DLGTEMPLATEEX DOC_INFO_1 DOC_INFO_2 DOCINFO DRAGLISTINFO DRAWITEMSTRUCT DRAWTEXTPARAMS DRIVE_LAYOUT_INFORMATION DRIVER_INFO_1 DRIVER_INFO_2 DRIVER_INFO_3 DROPFILES EDITSTREAM EMR EMRANGLEARC EMRARC EMRARCTO EMRCHORD EMRPIE EMRBITBLT EMRCREATEBRUSHINDIRECT EMRCREATECOLORSPACE EMRCREATEDIBPATTERNBRUSHPT EMRCREATEMONOBRUSH EMRCREATEPALETTE EMRCREATEPEN EMRELLIPSE EMRRECTANGLE EMREOF EMREXCLUDECLIPRECT EMRINTERSECTCLIPRECT EMREXTCREATEFONTINDIRECTW EMREXTCREATEPEN EMREXTFLOODFILL EMREXTSELECTCLIPRGN EMREXTTEXTOUTA EMREXTTEXTOUTW EMRFILLPATH EMRSTROKEANDFILLPATH EMRSTROKEPATH EMRFILLRGN EMRFORMAT EMRFRAMERGN EMRGDICOMMENT EMRINVERTRGN EMRPAINTRGN EMRLINETO EMRMOVETOEX EMRMASKBLT EMRMODIFYWORLDTRANSFORM EMROFFSETCLIPRGN EMRPLGBLT EMRPOLYDRAW EMRPOLYDRAW16 EMRPOLYLINE EMRPOLYBEZIER EMRPOLYGON EMRPOLYBEZIERTO EMRPOLYLINETO EMRPOLYLINE16 EMRPOLYBEZIER16 EMRPOLYGON16 EMRPOLYBEZIERTO16 EMRPOLYLINETO16 EMRPOLYPOLYLINE EMRPOLYPOLYGON EMRPOLYPOLYLINE16 EMRPOLYPOLYGON16 EMRPOLYTEXTOUTA EMRPOLYTEXTOUTW EMRRESIZEPALETTE EMRRESTOREDC EMRROUNDRECT EMRSCALEVIEWPORTEXTEX EMRSCALEWINDOWEXTEX EMRSELECTCOLORSPACE EMRDELETECOLORSPACE EMRSELECTOBJECT EMRDELETEOBJECT EMRSELECTPALETTE EMRSETARCDIRECTION EMRSETBKCOLOR EMRSETTEXTCOLOR EMRSETCOLORADJUSTMENT EMRSETDIBITSTODEVICE EMRSETMAPPERFLAGS EMRSETMITERLIMIT EMRSETPALETTEENTRIES EMRSETPIXELV EMRSETVIEWPORTEXTEX EMRSETWINDOWEXTEX EMRSETVIEWPORTORGEX EMRSETWINDOWORGEX EMRSETBRUSHORGEX EMRSETWORLDTRANSFORM EMRSTRETCHBLT EMRSTRETCHDIBITS EMRTEXT ENCORRECTTEXT ENDROPFILES ENHMETAHEADER ENHMETARECORD ENOLEOPFAILED ENPROTECTED ENSAVECLIPBOARD ENUM_SERVICE_STATUS ENUMLOGFONT ENUMLOGFONTEX ERRLOG_OTHER_INFO EVENTLOGRECORD EVENTMSG EXCEPTION_DEBUG_INFO EXCEPTION_POINTERS EXCEPTION_RECORD EXPLICIT_ACCESS EXIT_PROCESS_DEBUG_INFO EXIT_THREAD_DEBUG_INFO EXT_BUTTON EXTLOGFONT EXTLOGPEN FILE_INFO_2 FILE_INFO_3 FILE_NOTIFY_INFORMATION FILEDESCRIPTOR FILEGROUPDESCRIPTOR FILETIME FILTERKEYS FIND_NAME_BUFFER FIND_NAME_HEADER FINDREPLACE FINDTEXT FINDTEXTEX FIXED FMS_GETDRIVEINFO FMS_GETFILESEL FMS_LOAD FMS_TOOLBARLOAD FOCUS_EVENT_RECORD FOLDERSETTINGS FontDirEntry FontGroupHdr FONTSIGNATURE FORM_INFO_1 FORMAT_PARAMETERS FORMATRANGE FVSHOWINFO GCP_RESULTS GENERIC_MAPPING GLYPHMETRICS GROUP_INFO_0 GROUP_INFO_1 GROUP_INFO_2 GROUP_INFO_1002 GROUP_INFO_1005 GROUP_USERS_INFO_0 GROUP_USERS_INFO_1 HANDLE HANDLE_INFO_1 HANDLETABLE HD_HITTESTINFO HD_ITEM HD_LAYOUT HD_NOTIFY HELPINFO HELPWININFO HIGHCONTRAST HSZPAIR HW_PROFILE_INFO ICONINFO ICONMETRICS ICONRESDIR IMAGEINFO INPUT_RECORD ITEMIDLIST JOB_INFO_1 JOB_INFO_2 JOB_INFO_3 KERNINGPAIR KEY_EVENT_RECORD LANA_ENUM LARGE_INTEGER LDT_ENTRY LIST_ENTRY LOAD_DLL_DEBUG_INFO LOCALESIGNATURE LOCALGROUP_INFO_0 LOCALGROUP_INFO_1 LOCALGROUP_INFO_1002 LOCALGROUP_MEMBERS_INFO_0 LOCALGROUP_MEMBERS_INFO_1 LOCALGROUP_MEMBERS_INFO_2 LOCALGROUP_MEMBERS_INFO_3 LOCALGROUP_USERS_INFO_0 LOCALHEADER LOGBRUSH LOGCOLORSPACE LOGFONT LOGPALETTE LOGPEN LS_CHALLDATA LS_CHALLENGE LS_MSG_DIGEST LUID LUID_AND_ATTRIBUTES LV_COLUMN LV_DISPINFO LV_FINDINFO LV_HITTESTINFO LV_ITEM LV_KEYDOWN MAT2 MDICREATESTRUCT MEASUREITEMSTRUCT MEMORY_BASIC_INFORMATION MEMORYSTATUS MENU_EVENT_RECORD MENUEX_TEMPLATE_HEADER MENUEX_TEMPLATE_ITEM MenuHeader MENUHELPID MENUITEMINFO MENUITEMTEMPLATE MENUITEMTEMPLATEHEADER MESSAGE_RESOURCE_DATA MESSAGE_RESOURCE_ENTRY METAFILEPICT METAHEADER METARECORD MINIMIZEDMETRICS MINMAXINFO MODEMDEVCAPS MODEMSETTINGS MONCBSTRUCT MONCONVSTRUCT MONERRSTRUCT MONHSZSTRUCT MONITOR_INFO_1 MONITOR_INFO_2 MONLINKSTRUCT MONMSGSTRUCT MOUSE_EVENT_RECORD MOUSEHOOKSTRUCT MOUSEKEYS MSG MSG_INFO_0 MSG_INFO_1 MSGBOXPARAMS MSGFILTER MULTIKEYHELP NAME_BUFFER NCB NCCALCSIZE_PARAMS NDDESHAREINFO NETCONNECTINFOSTRUCT NET_DISPLAY_GROUP NET_DISPLAY_MACHINE NET_DISPLAY_USER NETRESOURCE NEWCPLINFO NEWHEADER NEWTEXTMETRIC NEWTEXTMETRICEX NM_LISTVIEW NM_TREEVIEW NM_UPDOWN NMHDR NONCLIENTMETRICS NormalMenuItem NOTIFYICONDATA NRESARRAY NS_SERVICE_INFO NUMBERFMT OFNOTIFY OFSTRUCT OPENFILENAME OSVERSIONINFO OUTLINETEXTMETRIC OUTPUT_DEBUG_STRING_INFO OVERLAPPED PAGESETUPDLG PAINTSTRUCT PALETTEENTRY PANOSE PARAFORMAT PARTITION_INFORMATION POINT POINTFX POINTL POINTS POLYTEXT PopupMenuItem PORT_INFO_1 PORT_INFO_2 PORT_INFO_3 PREVENT_MEDIA_REMOVAL PRINTDLG PRINTER_DEFAULTS PRINTER_INFO_2 PRINTER_INFO_3 PRINTER_INFO_4 PRINTER_INFO_5 PRINTER_INFO_6 PRINTER_NOTIFY_INFO PRINTER_NOTIFY_INFO_DATA PRINTER_NOTIFY_OPTIONS PRINTER_NOTIFY_OPTIONS_TYPE PRINTPROCESSOR_INFO_1 PRIVILEGE_SET PROCESS_HEAP_ENTRY PROCESS_INFORMATION PROPSHEETHEADER PROPSHEETPAGE PROTOCOL_INFO PROVIDOR_INFO_1 PSHNOTIFY PUNCTUATION QUERY_SERVICE_CONFIG QUERY_SERVICE_LOCK_STATUS RAS_PARAMETERS RAS_PARAMS_VALUE RAS_PORT_0 RAS_PORT_1 RAS_PORT_STATISTICS RAS_PPP_ATCP_RESULT RAS_PPP_IPCP_RESULT RAS_PPP_IPXCP_RESULT RAS_PPP_NBFCP_RESULT RAS_PPP_PROJECTION_RESULT RAS_SECURITY_INFO RAS_SERVER_0 RAS_USER_0 RASADPARAMS RASAMB RASAUTODIALENTRY RASCONN RASCONNSTATUS RASCREDENTIALS RASCTRYINFO RASDEVINFO RASDIALDLG RASDIALEXTENSIONS RASDIALPARAMS RASENTRY RASENTRYDLG RASENTRYNAME RASIPADDR Rsmonitordlg RASNOUSER RASPBDLG RASPPPIP RASPPPIPX RASPPPNBF RASSLIP RASTERIZER_STATUS REASSIGN_BLOCKS RASSUBENTRY RECT RECTL REGISTERWORD REMOTE_NAME_INFO REOBJECT REPASTESPECIAL REPL_EDIR_INFO_0 REPL_EDIR_INFO_1 REPL_EDIR_INFO_2 REPL_EDIR_INFO_1000 REPL_EDIR_INFO_1001 REPL_IDIR_INFO_0 REPL_IDIR_INFO_1 REPL_INFO_0 REPL_INFO_1000 REPL_INFO_1002 REPL_INFO_1003 REQRESIZE RESDIR RESOURCEHEADER RFC1157VarBind RFC1157VarBindList RGBQUAD RGBTRIPLE RGNDATA RGNDATAHEADER RIP_INFO SCROLLINFO SECURITY_ATTRIBUTES SECURITY_DESCRIPTOR SECURITY_DESCRIPTOR_CONTROL SECURITY_MESSAGE SECURITY_QUALITY_OF_SERVICE SELCHANGE SERIALKEYS SERVER_INFO_100 SERVER_INFO_101 SERVER_INFO_102 SERVER_INFO_402 SERVER_INFO_403 SERVER_INFO_502 SERVER_INFO_503 SERVER_INFO_1005 SERVER_INFO_1107 SERVER_INFO_1010 SERVER_INFO_1016 SERVER_INFO_1017 SERVER_INFO_1018 SERVER_INFO_1501 SERVER_INFO_1502 SERVER_INFO_1503 SERVER_INFO_1506 SERVER_INFO_1509 SERVER_INFO_1510 SERVER_INFO_1511 SERVER_INFO_1512 SERVER_INFO_1513 SERVER_INFO_1515 SERVER_INFO_1516 SERVER_INFO_1518 SERVER_INFO_1523 SERVER_INFO_1528 SERVER_INFO_1529 SERVER_INFO_1530 SERVER_INFO_1533 SERVER_INFO_1534 SERVER_INFO_1535 SERVER_INFO_1538 SERVER_INFO_1539 SERVER_INFO_1540 SERVER_INFO_1541 SERVER_INFO_1542 SERVER_INFO_1544 SERVER_INFO_1550 SERVER_INFO_1552 SERVER_TRANSPORT_INFO_0 SERVICE_ADDRESS SERVICE_ADDRESSES SERVICE_INFO SERVICE_INFO_0 SERVICE_INFO_1 SERVICE_INFO_2 SERVICE_STATUS SERVICE_TABLE_ENTRY SERVICE_TYPE_INFO_ABS SERVICE_TYPE_VALUE_ABS SESSION_BUFFER SESSION_HEADER SESSION_INFO_0 SESSION_INFO_1 SESSION_INFO_2 SESSION_INFO_10 SESSION_INFO_502 SET_PARTITION_INFORMATION SHARE_INFO_0 SHARE_INFO_1 SHARE_INFO_2 SHARE_INFO_502 SHARE_INFO_1004 SHARE_INFO_1006 SHARE_INFO_1501 SHELLEXECUTEINFO SHFILEINFO SHFILEOPSTRUCT SHITEMID SHNAMEMAPPING SID SID_AND_ATTRIBUTES SID_IDENTIFIER_AUTHORITY SINGLE_LIST_ENTRY SIZE SMALL_RECT SOARCINFO SOBITMAPHEADER SOBORDER SOCOLUMN SOCPARCANGLE SOCPPIEANGLE SOCPTEXTATPOINT SODATACELL SOEMBEDDEDGRAPHIC SOEMBEDDEDOBJECT SOEMBEDINFO SOFIELD SOFILTERINFO SOGROUPINFO SOLOGBRUSH SOLOGFONT SOLOGPEN SOPARAINDENTS SOPATHINFO SOPOINT SOPOLYINFO SORECT SOTAB SOTABLECELLINFO SOTEXTATARCANGLE SOTEXTATPOINT SOTEXTCELL SOTEXTINRECT SOTRANSFORM SOVECTORHEADER SOUNDSENTRY STARTUPINFO STAT_SERVER_0 STAT_WORKSTATION_0 STD_ALERT STICKYKEYS STRRET StringFileInfo StringTable STYLEBUF STYLESTRUCT SYSTEM_ALARM_ACE SYSTEM_AUDIT_ACE SYSTEM_INFO SYSTEM_POWER_STATUS SYSTEMTIME TAPE_ERASE TAPE_GET_DRIVE_PARAMETERS TAPE_GET_MEDIA_PARAMETERS TAPE_GET_POSITION TAPE_PREPARE TAPE_SET_DRIVE_PARAMETERS TAPE_SET_MEDIA_PARAMETERS TAPE_WRITE_MARKS TBADDBITMAP TBBUTTON TBNOTIFY TBSAVEPARAMS TC_HITTESTINFO TC_ITEM TC_ITEMHEADER TC_KEYDOWN TEXTMETRIC TEXTRANGE TIME_OF_DAY_INFO TIME_ZONE_INFORMATION TOGGLEKEYS TOKEN_CONTROL TOKEN_DEFAULT_DACL TOKEN_GROUPS TOKEN_OWNER TOKEN_PRIMARY_GROUP TOKEN_PRIVILEGES TOKEN_SOURCE TOKEN_STATISTICS TOKEN_USER TOOLINFO TOOLTIPTEXT TPMPARAMS TRACKMOUSEEVENT TRANSMIT_FILE_BUFFERS TRUSTEE TTHITTESTINFO TTPOLYCURVE TTPOLYGONHEADER TV_DISPINFO TV_HITTESTINFO TV_INSERTSTRUCT TV_ITEM TV_KEYDOWN TV_SORTCB UDACCEL ULARGE_INTEGER UNIVERSAL_NAME_INFO UNLOAD_DLL_DEBUG_INFO USE_INFO_0 USE_INFO_1 USE_INFO_2 USER_INFO_0 USER_INFO_1 USER_INFO_2 USER_INFO_3 USER_INFO_10 USER_INFO_11 USER_INFO_20 USER_INFO_21 USER_INFO_22 USER_INFO_1003 USER_INFO_1005 USER_INFO_1006 USER_INFO_1007 USER_INFO_1008 USER_INFO_1009 USER_INFO_1010 USER_INFO_1011 USER_INFO_1012 USER_INFO_1013 USER_INFO_1014 USER_INFO_1017 USER_INFO_1018 USER_INFO_1020 USER_INFO_1023 USER_INFO_1024 USER_INFO_1025 USER_INFO_1051 USER_INFO_1052 USER_INFO_1053 USER_MODALS_INFO_0 USER_MODALS_INFO_1 USER_MODALS_INFO_2 USER_MODALS_INFO_3 USER_MODALS_INFO_1001 USER_MODALS_INFO_1002 USER_MODALS_INFO_1003 USER_MODALS_INFO_1004 USER_MODALS_INFO_1005 USER_MODALS_INFO_1006 USER_MODALS_INFO_1007 USEROBJECTFLAGS USER_OTHER_INFO VALENT VarFileInfo VERIFY_INFORMATION VS_FIXEDFILEINFO VS_VERSION_INFO WIN32_FILE_ATTRIBUTE_DATA WIN32_FIND_DATA WIN32_STREAM_ID WIN_CERTIFICATE WIN_TRUST_ACTDATA_CONTEXT_WITH_SUBJECT WIN_TRUST_ACTDATA_SUBJECT_ONLY WIN_TRUST_SUBJECT_FILE WIN_TRUST_SIP_SUBJECT WINDOW_BUFFER_SIZE_RECORD WINDOWPLACEMENT WINDOWPOS WINTRUST_CLIENT_TP_DISPATCH_TABLE WINTRUST_CLIENT_TP_INFO WINTRUST_PROVIDER_CLIENT_INFO WINTRUST_PROVIDER_CLIENT_SERVICES WINTRUST_PROVIDER_SERVER_INFO WINTRUST_PROVIDER_SERVER_SERVICES WINTRUST_SERVER_TP_DISPATCH_TABLE WINTRUST_SERVER_TP_INFO WINTRUST_SIP_DISPATCH_TABLE WINTRUST_SIP_INFO WKSTA_INFO_100 WKSTA_INFO_101 WKSTA_INFO_102 WKSTA_INFO_302 WKSTA_INFO_402 WKSTA_TRANSPORT_INFO_0 WKSTA_USER_INFO_0 WKSTA_USER_INFO_1 WKSTA_USER_INFO_1101 WNDCLASS WNDCLASSEX XFORM ACCESS_MODE ACL_INFORMATION_CLASS FD_FLAGS GET_FILEEX_INFO_LEVELS MEDIA_TYPE MULTIPLE_TRUSTEE_OPERATION RASCONNSTATE RASPROJECTION SE_OBJECT_TYPE SECURITY_IMPERSONATION_LEVEL SHCONTF SHGNO SID_NAME_USE TOKEN_INFORMATION_CLASS TOKEN_TYPE TRUSTEE_FORM TRUSTEE_TYPE Animate_Close Animate_Create Animate_Open Animate_Play Animate_Seek Animate_Stop CMYK FORWARD_WM_NOTIFY GetBValue GetCValue GetGValue GetKValue GetMValue GetRValue GetYValue HANDLE_WM_NOTIFY hasOverlappedIoCompleted Header_DeleteItem Header_GetItem Header_GetItemCount Header_InsertItem Header_Layout Header_SetItem HIBYTE HIWORD ImageList_AddIcon INDEXTOOVERLAYMASK INDEXTOSTATEIMAGEMASK LANGIDFROMLCID ListView_Arrange ListView_CreateDragImage ListView_DeleteAllItems ListView_DeleteColumn ListView_DeleteItem ListView_EditLabel ListView_EnsureVisible ListView_FindItem ListView_GetBkColor ListView_GetCallbackMask ListView_GetColumn ListView_GetColumnWidth ListView_GetCountPerPage ListView_GetEditControl ListView_GetImageList ListView_GetISearchString ListView_GetItem ListView_GetItemCount ListView_GetItemPosition ListView_GetItemRect ListView_GetItemSpacing ListView_GetItemState ListView_GetItemText ListView_GetNextItem ListView_GetOrigin ListView_GetSelectedCount ListView_GetStringWidth ListView_GetTextBkColor ListView_GetTextColor ListView_GetTopIndex ListView_GetViewRect ListView_HitTest ListView_InsertColumn ListView_InsertItem ListView_Scroll ListView_SetBkColor ListView_SetCallbackMask ListView_SetColumn ListView_SetColumnWidth ListView_SetImageList ListView_SetItem ListView_SetItemCount ListView_SetItemPosition ListView_SetItemPosition32 ListView_SetItemState ListView_SetItemText ListView_SetTextBkColor ListView_SetTextColor ListView_SortItems ListView_Update LOBYTE LOWORD MAKEINTATOM MAKEINTRESOURCE MAKELANGID MAKELCID MAKELONG MAKELPARAM MAKELRESULT MAKEPOINTS MAKEROP4 MAKEWORD PALETTEINDEX PALETTERGB POINTSTOPOINT POINTTOPOINTS PRIMARYLANGID PropSheet_AddPage PropSheet_Apply PropSheet_CancelToClose PropSheet_Changed PropSheet_GetCurrentPageHwnd PropSheet_GetTabControl PropSheet_IsDialogMessage PropSheet_PressButton PropSheet_QuerySiblings PropSheet_RebootSystem PropSheet_RemovePage PropSheet_RestartWindows PropSheet_SetCurSel PropSheet_SetCurSelByID PropSheet_SetFinishText PropSheet_SetTitle PropSheet_SetWizButtons PropSheet_UnChanged RGB SOANGLETENTHS SOPALETTEINDEX SOPALETTERGB SORGB SOSETRATIO SORTIDFROMLCID SUBLANGID TabCtrl_AdjustRect TabCtrl_DeleteAllItems TabCtrl_DeleteItem TabCtrl_GetCurFocus TabCtrl_GetCurSel TabCtrl_GetImageList TabCtrl_GetItem TabCtrl_GetItemCount TabCtrl_GetItemRect TabCtrl_GetRowCount TabCtrl_GetToolTips TabCtrl_HitTest TabCtrl_InsertItem TabCtrl_RemoveImage TabCtrl_SetCurFocus TabCtrl_SetCurSel TabCtrl_SetImageList TabCtrl_SetItem TabCtrl_SetItemExtra TabCtrl_SetItemSize TabCtrl_SetPadding TabCtrl_SetToolTips TreeView_CreateDragImage TreeView_DeleteAllItems TreeView_DeleteItem TreeView_EditLabel TreeView_EndEditLabelNow TreeView_EnsureVisible TreeView_Expand TreeView_GetChild TreeView_GetCount TreeView_GetDropHilite TreeView_GetEditControl TreeView_GetFirstVisible TreeView_GetImageList TreeView_GetIndent TreeView_GetISearchString TreeView_GetItem TreeView_GetItemRect TreeView_GetNextItem TreeView_GetNextSibling TreeView_GetNextVisible TreeView_GetParent TreeView_GetPrevSibling TreeView_GetPrevVisible TreeView_GetRoot TreeView_GetSelection TreeView_GetVisibleCount TreeView_HitTest TreeView_InsertItem TreeView_Select TreeView_SelectItem TreeView_SelectDropTarget TreeView_SelectSetFirstVisible TreeView_SetImageList TreeView_SetIndent TreeView_SetItem TreeView_SortChildren TreeView_SortChildrenCB XTYP_ADVDATA XTYP_ADVREQ XTYP_ADVSTART XTYP_ADVSTOP XTYP_CONNECT XTYP_CONNECT_CONFIRM XTYP_DISCONNECT XTYP_ERROR XTYP_EXECUTE XTYP_MONITOR XTYP_POKE XTYP_REGISTER XTYP_REQUEST XTYP_UNREGISTER XTYP_WILDCONNECT XTYP_XACT_COMPLETE STRICT ULONG PULONG USHORT PUSHORT UCHAR PUCHAR PSZ NULL FALSE TRUE IN OUT OPTIONAL pascal CDECL CALLBACK WINAPI WINAPIV APIENTRY APIPRIVATE PASCAL FAR NEAR CONST DWORD BOOL BYTE WORD FLOAT PFLOAT PBOOL LPBOOL PBYTE LPBYTE PINT LPINT PWORD LPWORD LPLONG PDWORD LPDWORD LPVOID LPCVOID INT UINT PUINT WPARAM LPARAM LRESULT SPHANDLE LPHANDLE HGLOBAL HLOCAL GLOBALHANDLE LOCALHANDLE FARPROC NEARPROC PROC HKEY PHKEY HMETAFILE HINSTANCE HMODULE HRGN HRSRC HSPRITE HLSURF HSTR HTASK HWINSTA HKL HFILE MAKEWORD MAKELONG LOWORD HIWORD LOBYTE HIBYTE FILETIME PFILETIME LPFILETIME HWND HMENU HFONT HBRUSH WCHAR POINT ATOM INT_PTR _In_ _Out_ LPWSTR HACCEL MSG ACCELERATORS ALT AUTO3STATE AUTOCHECKBOX AUTORADIOBUTTON BEGIN BITMAP BLOCK BUTTON CAPTION CHARACTERISTICS CHECKBOX CLASS COMBOBOX CONTROL CTEXT CURSOR DEFPUSHBUTTON DIALOG DIALOGEX DISCARDABLE EDITTEXT END EXSTYLE FONT GROUPBOX ICON LANGUAGE LISTBOX LTEXT MENU MENUEX MENUITEM MESSAGETABLE POPUP PUSHBUTTON RADIOBUTTON RCDATA RTEXT SCROLLBAR SEPARATOR SHIFT STATE3 STRINGTABLE STYLE TEXTINCLUDE VALUE VERSION VERSIONINFO VIRTKEY\"\n",
    "  return autocomplete_set\n",
    "end\n",
    "\n",
    "function user_cpp.get_calltip()\n",
    "  local calltip_add =\n",
    "  {\n",
    "    \"__acrt_iob_func|__cdecl __acrt_iob_func(unsigned index);\",\n",
    "    \"__iob_func|__cdecl __iob_func(void);\",\n",
    "    \"__ms_sscanf|__cdecl __ms_sscanf(const char*  __restrict__ _Src,const char*  __restrict__ _Format,...);\",\n",
    "    \"__ms_scanf|__cdecl __ms_scanf(const char*  __restrict__ _Format,...);\",\n",
    "    \"__ms_fscanf|__cdecl __ms_fscanf(FILE*  __restrict__ _File,const char*  __restrict__ _Format,...);\",\n",
    "    \"__ms_printf|__cdecl __ms_printf(const char*  __restrict__ , ... );\",\n",
    "    \"__ms_vprintf|__cdecl __ms_vprintf (const char*  __restrict__ , va_list);\",\n",
    "    \"__ms_fprintf|__cdecl __ms_fprintf (FILE*  __restrict__ , const char*  __restrict__ , ...);\",\n",
    "    \"__ms_vfprintf|__cdecl __ms_vfprintf (FILE*  __restrict__ , const char*  __restrict__ , va_list);\",\n",
    "    \"__ms_sprintf|__cdecl __ms_sprintf (char*  __restrict__ , const char*  __restrict__ , ...);\",\n",
    "    \"__ms_vsprintf|__cdecl __ms_vsprintf (char*  __restrict__ , const char*  __restrict__ , va_list);\",\n",
    "    \"__stdio_common_vsprintf|__cdecl __stdio_common_vsprintf(unsigned __int64 options, char* str, size_t len, const char* format, _locale_t locale, va_list valist);\",\n",
    "    \"__stdio_common_vfprintf|__cdecl __stdio_common_vfprintf(unsigned __int64 options, FILE* file, const char* format, _locale_t locale, va_list valist);\",\n",
    "    \"__stdio_common_vsscanf|__cdecl __stdio_common_vsscanf(unsigned __int64 options, const char* input, size_t length, const char* format, _locale_t locale, va_list valist);\",\n",
    "    \"__stdio_common_vfscanf|__cdecl __stdio_common_vfscanf(unsigned __int64 options, FILE* file, const char* format, _locale_t locale, va_list valist);\",\n",
    "    \"fprintf|__cdecl fprintf(FILE*  __restrict__ _File,const char*  __restrict__ _Format,...);\",\n",
    "    \"printf|__cdecl printf(const char*  __restrict__ _Format,...);\",\n",
    "    \"sprintf|__cdecl sprintf(char*  __restrict__ _Dest,const char*  __restrict__ _Format,...);\",\n",
    "    \"vfprintf|__cdecl vfprintf(FILE*  __restrict__ _File,const char*  __restrict__ _Format,va_list _ArgList);\",\n",
    "    \"vprintf|__cdecl vprintf(const char*  __restrict__ _Format,va_list _ArgList);\",\n",
    "    \"vsprintf|__cdecl vsprintf(char*  __restrict__ _Dest,const char*  __restrict__ _Format,va_list _Args);\",\n",
    "    \"fscanf|__cdecl fscanf(FILE*  __restrict__ _File,const char*  __restrict__ _Format,...);\",\n",
    "    \"scanf|__cdecl scanf(const char*  __restrict__ _Format,...);\",\n",
    "    \"sscanf|__cdecl sscanf(const char*  __restrict__ _Src,const char*  __restrict__ _Format,...);\",\n",
    "    \"vasprintf|__cdecl vasprintf(char**  __restrict__ _Ret,const char*  __restrict__ _Format,va_list _Args);\",\n",
    "    \"asprintf|__cdecl asprintf(char**  __restrict__ _Ret,const char*  __restrict__ _Format,...);\",\n",
    "    \"vfscanf|int vfscanf (FILE* __stream,  const char* __format, __builtin_va_list __local_argv);\",\n",
    "    \"vsscanf|int vsscanf (const char*  __restrict__ __source, const char*  __restrict__ __format, __builtin_va_list __local_argv);\",\n",
    "    \"vscanf|int vscanf(const char* __format,  __builtin_va_list __local_argv);\",\n",
    "    \"__ms_vscanf|__cdecl __ms_vscanf(const char*  __restrict__ Format, va_list argp);\",\n",
    "    \"__ms_vfscanf|__cdecl __ms_vfscanf (FILE*  __restrict__ fp, const char*  __restrict__ Format,va_list argp);\",\n",
    "    \"__ms_vsscanf|__cdecl __ms_vsscanf (const char*  __restrict__ _Str,const char*  __restrict__ Format,va_list argp);\",\n",
    "    \"_filbuf|__cdecl _filbuf(FILE* _File);\",\n",
    "    \"_flsbuf|__cdecl _flsbuf(int _Ch,FILE* _File);\",\n",
    "    \"_fsopen|__cdecl _fsopen(const char* _Filename,const char* _Mode);\",\n",
    "    \"_fsopen|__cdecl _fsopen(const char* _Filename,const char* _Mode,int _ShFlag);\",\n",
    "    \"clearerr|__cdecl clearerr(FILE* _File);\",\n",
    "    \"fclose|__cdecl fclose(FILE* _File);\",\n",
    "    \"_fcloseall|__cdecl _fcloseall(void);\",\n",
    "    \"fdopen|__cdecl fdopen(int _FileHandle,const char* _Mode);\",\n",
    "    \"_fdopen|__cdecl _fdopen(int _FileHandle,const char* _Mode);\",\n",
    "    \"feof|__cdecl feof(FILE* _File);\",\n",
    "    \"ferror|__cdecl ferror(FILE* _File);\",\n",
    "    \"fflush|__cdecl fflush(FILE* _File);\",\n",
    "    \"fgetc|__cdecl fgetc(FILE* _File);\",\n",
    "    \"_fgetchar|__cdecl _fgetchar(void);\",\n",
    "    \"fgets|__cdecl fgets(char*  __restrict__ _Buf,int _MaxCount,FILE*  __restrict__ _File);\",\n",
    "    \"_fileno|__cdecl _fileno(FILE* _File);\",\n",
    "    \"fileno|__cdecl fileno(FILE* _File);\",\n",
    "    \"_tempnam|__cdecl _tempnam(const char* _DirName,const char* _FilePrefix);\",\n",
    "    \"_flushall|__cdecl _flushall(void);\",\n",
    "    \"fopen|__cdecl fopen(const char*  __restrict__ _Filename,const char*  __restrict__ _Mode);\",\n",
    "    \"fopen64|FILE* fopen64(const char*  __restrict__ filename,const char*  __restrict__  mode);\",\n",
    "    \"fputc|__cdecl fputc(int _Ch,FILE* _File);\",\n",
    "    \"_fputchar|__cdecl _fputchar(int _Ch);\",\n",
    "    \"fputs|__cdecl fputs(const char*  __restrict__ _Str,FILE*  __restrict__ _File);\",\n",
    "    \"fread|__cdecl fread(void*  __restrict__ _DstBuf,size_t _ElementSize,size_t _Count,FILE*  __restrict__ _File);\",\n",
    "    \"freopen|__cdecl freopen(const char*  __restrict__ _Filename,const char*  __restrict__ _Mode,FILE*  __restrict__ _File);\",\n",
    "    \"fsetpos|__cdecl fsetpos(FILE* _File,const fpos_t* _Pos);\",\n",
    "    \"fseek|__cdecl fseek(FILE* _File,long _Offset,int _Origin);\",\n",
    "    \"ftell|__cdecl ftell(FILE* _File);\",\n",
    "    \"_fseeki64|__cdecl _fseeki64(FILE* _File,__int64 _Offset,int _Origin);\",\n",
    "    \"_ftelli64|__cdecl _ftelli64(FILE* _File);\",\n",
    "    \"fseeko64|int fseeko64(FILE*  stream, _off64_t offset, int whence);\",\n",
    "    \"fseeko|int fseeko(FILE*  stream, _off_t offset, int whence);\",\n",
    "    \"ftello|_off_t ftello(FILE*  stream);\",\n",
    "    \"ftello64|_off64_t ftello64(FILE*  stream);\",\n",
    "    \"fwrite|__cdecl fwrite(const void*  __restrict__ _Str,size_t _Size,size_t _Count,FILE*  __restrict__ _File);\",\n",
    "    \"getc|__cdecl getc(FILE* _File);\",\n",
    "    \"getchar|__cdecl getchar(void);\",\n",
    "    \"_getmaxstdio|__cdecl _getmaxstdio(void);\",\n",
    "    \"gets|__cdecl gets(char* _Buffer);\",\n",
    "    \"_getw|__cdecl _getw(FILE* _File);\",\n",
    "    \"perror|__cdecl perror(const char* _ErrMsg);\",\n",
    "    \"_pclose|__cdecl _pclose(FILE* _File);\",\n",
    "    \"_popen|__cdecl _popen(const char* _Command,const char* _Mode);\",\n",
    "    \"putc|__cdecl putc(int _Ch,FILE* _File);\",\n",
    "    \"putchar|__cdecl putchar(int _Ch);\",\n",
    "    \"puts|__cdecl puts(const char* _Str);\",\n",
    "    \"_putw|__cdecl _putw(int _Word,FILE* _File);\",\n",
    "    \"remove|__cdecl remove(const char* _Filename);\",\n",
    "    \"rename|__cdecl rename(const char* _OldFilename,const char* _NewFilename);\",\n",
    "    \"_unlink|__cdecl _unlink(const char* _Filename);\",\n",
    "    \"unlink|__cdecl unlink(const char* _Filename);\",\n",
    "    \"rewind|__cdecl rewind(FILE* _File);\",\n",
    "    \"_rmtmp|__cdecl _rmtmp(void);\",\n",
    "    \"setbuf|__cdecl setbuf(FILE*  __restrict__ _File,char*  __restrict__ _Buffer);\",\n",
    "    \"_setmaxstdio|__cdecl _setmaxstdio(int _Max);\",\n",
    "    \"_set_output_format|__cdecl _set_output_format(unsigned int _Format);\",\n",
    "    \"_get_output_format|__cdecl _get_output_format(void);\",\n",
    "    \"setvbuf|__cdecl setvbuf(FILE*  __restrict__ _File,char*  __restrict__ _Buf,int _Mode,size_t _Size);\",\n",
    "    \"_scprintf|__cdecl _scprintf(const char*  __restrict__ _Format,...);\",\n",
    "    \"_snscanf|__cdecl _snscanf(const char*  __restrict__ _Src,size_t _MaxCount,const char*  __restrict__ _Format,...);\",\n",
    "    \"tmpfile|__cdecl tmpfile(void);\",\n",
    "    \"tmpnam|__cdecl tmpnam(char* _Buffer);\",\n",
    "    \"ungetc|__cdecl ungetc(int _Ch,FILE* _File);\",\n",
    "    \"_vsnprintf|__cdecl _vsnprintf(char*  __restrict__ _Dest,size_t _Count,const char*  __restrict__ _Format,va_list _Args);\",\n",
    "    \"_snprintf|__cdecl _snprintf(char*  __restrict__ _Dest,size_t _Count,const char*  __restrict__ _Format,...);\",\n",
    "    \"__gets_chk|__cdecl __gets_chk(char* , size_t);\",\n",
    "    \"vsnprintf|int vsnprintf (char*  __restrict__ __stream, size_t __n, const char*  __restrict__ __format, va_list __local_argv);\",\n",
    "    \"snprintf|int snprintf (char*  __restrict__ __stream, size_t __n, const char*  __restrict__ __format, ...);\",\n",
    "    \"__ms_snprintf|__cdecl __ms_snprintf(char*  __restrict__ s, size_t n, const char*  __restrict__  format, ...);\",\n",
    "    \"_vscprintf|__cdecl _vscprintf(const char*  __restrict__ _Format,va_list _ArgList);\",\n",
    "    \"_set_printf_count_output|__cdecl _set_printf_count_output(int _Value);\",\n",
    "    \"_get_printf_count_output|__cdecl _get_printf_count_output(void);\",\n",
    "    \"__ms_swscanf|__cdecl __ms_swscanf(const wchar_t*  __restrict__ _Src,const wchar_t*  __restrict__ _Format,...);\",\n",
    "    \"__ms_wscanf|__cdecl __ms_wscanf(const wchar_t*  __restrict__ _Format,...);\",\n",
    "    \"__ms_fwscanf|__cdecl __ms_fwscanf(FILE*  __restrict__ _File,const wchar_t*  __restrict__ _Format,...);\",\n",
    "    \"__ms_fwprintf|__cdecl __ms_fwprintf(FILE*  __restrict__ _File,const wchar_t*  __restrict__ _Format,...);\",\n",
    "    \"__ms_wprintf|__cdecl __ms_wprintf(const wchar_t*  __restrict__ _Format,...);\",\n",
    "    \"__ms_vfwprintf|__cdecl __ms_vfwprintf(FILE*  __restrict__ _File,const wchar_t*  __restrict__ _Format,va_list _ArgList);\",\n",
    "    \"__ms_vwprintf|__cdecl __ms_vwprintf(const wchar_t*  __restrict__ _Format,va_list _ArgList);\",\n",
    "    \"__ms_swprintf|__cdecl __ms_swprintf(wchar_t*  __restrict__ , const wchar_t*  __restrict__ , ...);\",\n",
    "    \"__ms_vswprintf|__cdecl __ms_vswprintf(wchar_t*  __restrict__ , const wchar_t*  __restrict__ ,va_list);\",\n",
    "    \"__stdio_common_vswprintf|__cdecl __stdio_common_vswprintf(unsigned __int64 options, wchar_t* str, size_t len, const wchar_t* format, _locale_t locale, va_list valist);\",\n",
    "    \"__stdio_common_vfwprintf|__cdecl __stdio_common_vfwprintf(unsigned __int64 options, FILE* file, const wchar_t* format, _locale_t locale, va_list valist);\",\n",
    "    \"__stdio_common_vswscanf|__cdecl __stdio_common_vswscanf(unsigned __int64 options, const wchar_t* input, size_t length, const wchar_t* format, _locale_t locale, va_list valist);\",\n",
    "    \"__stdio_common_vfwscanf|__cdecl __stdio_common_vfwscanf(unsigned __int64 options, FILE* file, const wchar_t* format, _locale_t locale, va_list valist);\",\n",
    "    \"fwscanf|__cdecl fwscanf(FILE*  __restrict__ _File,const wchar_t*  __restrict__ _Format,...);\",\n",
    "    \"swscanf|__cdecl swscanf(const wchar_t*  __restrict__ _Src,const wchar_t*  __restrict__ _Format,...);\",\n",
    "    \"wscanf|__cdecl wscanf(const wchar_t*  __restrict__ _Format,...);\",\n",
    "    \"__ms_vwscanf|__cdecl __ms_vwscanf (const wchar_t*  __restrict__ , va_list);\",\n",
    "    \"__ms_vfwscanf|__cdecl __ms_vfwscanf (FILE*  __restrict__ ,const wchar_t*  __restrict__ ,va_list);\",\n",
    "    \"__ms_vswscanf|__cdecl __ms_vswscanf (const wchar_t*  __restrict__ ,const wchar_t*  __restrict__ ,va_list);\",\n",
    "    \"fwprintf|__cdecl fwprintf(FILE*  __restrict__ _File,const wchar_t*  __restrict__ _Format,...);\",\n",
    "    \"wprintf|__cdecl wprintf(const wchar_t*  __restrict__ _Format,...);\",\n",
    "    \"vfwprintf|__cdecl vfwprintf(FILE*  __restrict__ _File,const wchar_t*  __restrict__ _Format,va_list _ArgList);\",\n",
    "    \"vwprintf|__cdecl vwprintf(const wchar_t*  __restrict__ _Format,va_list _ArgList);\",\n",
    "    \"_wfsopen|__cdecl _wfsopen(const wchar_t* _Filename,const wchar_t* _Mode);\",\n",
    "    \"_wfsopen|__cdecl _wfsopen(const wchar_t* _Filename,const wchar_t* _Mode,int _ShFlag);\",\n",
    "    \"fgetwc|__cdecl fgetwc(FILE* _File);\",\n",
    "    \"_fgetwchar|__cdecl _fgetwchar(void);\",\n",
    "    \"fputwc|__cdecl fputwc(wchar_t _Ch,FILE* _File);\",\n",
    "    \"_fputwchar|__cdecl _fputwchar(wchar_t _Ch);\",\n",
    "    \"getwc|__cdecl getwc(FILE* _File);\",\n",
    "    \"getwchar|__cdecl getwchar(void);\",\n",
    "    \"putwc|__cdecl putwc(wchar_t _Ch,FILE* _File);\",\n",
    "    \"putwchar|__cdecl putwchar(wchar_t _Ch);\",\n",
    "    \"ungetwc|__cdecl ungetwc(wint_t _Ch,FILE* _File);\",\n",
    "    \"fgetws|__cdecl fgetws(wchar_t*  __restrict__ _Dst,int _SizeInWords,FILE*  __restrict__ _File);\",\n",
    "    \"fputws|__cdecl fputws(const wchar_t*  __restrict__ _Str,FILE*  __restrict__ _File);\",\n",
    "    \"_getws|__cdecl _getws(wchar_t* _String);\",\n",
    "    \"_putws|__cdecl _putws(const wchar_t* _Str);\",\n",
    "    \"_vsnwprintf|__cdecl _vsnwprintf(wchar_t*  __restrict__ _Dest,size_t _Count,const wchar_t*  __restrict__ _Format,va_list _Args);\",\n",
    "    \"_scwprintf|__cdecl _scwprintf(const wchar_t*  __restrict__ _Format,...);\",\n",
    "    \"_swprintf_c|__cdecl _swprintf_c(wchar_t*  __restrict__ _DstBuf,size_t _SizeInWords,const wchar_t*  __restrict__ _Format,...);\",\n",
    "    \"_vswprintf_c|__cdecl _vswprintf_c(wchar_t*  __restrict__ _DstBuf,size_t _SizeInWords,const wchar_t*  __restrict__ _Format,va_list _ArgList);\",\n",
    "    \"_snwprintf|__cdecl _snwprintf(wchar_t*  __restrict__ _Dest,size_t _Count,const wchar_t*  __restrict__ _Format,...);\",\n",
    "    \"_vscwprintf|__cdecl _vscwprintf(const wchar_t*  __restrict__ _Format,va_list _ArgList);\",\n",
    "    \"__ms_snwprintf|__cdecl __ms_snwprintf (wchar_t*  __restrict__ s, size_t n, const wchar_t*  __restrict__ format, ...);\",\n",
    "    \"__ms_vsnwprintf|__cdecl __ms_vsnwprintf (wchar_t*  __restrict__ , size_t, const wchar_t*  __restrict__ , va_list);\",\n",
    "    \"_swprintf|__cdecl _swprintf(wchar_t*  __restrict__ _Dest,const wchar_t*  __restrict__ _Format,...);\",\n",
    "    \"_vswprintf|__cdecl _vswprintf(wchar_t*  __restrict__ _Dest,const wchar_t*  __restrict__ _Format,va_list _Args);\",\n",
    "    \"_wtempnam|__cdecl _wtempnam(const wchar_t* _Directory,const wchar_t* _FilePrefix);\",\n",
    "    \"_snwscanf|__cdecl _snwscanf(const wchar_t*  __restrict__ _Src,size_t _MaxCount,const wchar_t*  __restrict__ _Format,...);\",\n",
    "    \"_wfdopen|__cdecl _wfdopen(int _FileHandle ,const wchar_t* _Mode);\",\n",
    "    \"_wfopen|__cdecl _wfopen(const wchar_t*  __restrict__ _Filename,const wchar_t* __restrict__  _Mode);\",\n",
    "    \"_wfreopen|__cdecl _wfreopen(const wchar_t*  __restrict__ _Filename,const wchar_t*  __restrict__ _Mode,FILE*  __restrict__ _OldFile);\",\n",
    "    \"_wperror|__cdecl _wperror(const wchar_t* _ErrMsg);\",\n",
    "    \"_wpopen|__cdecl _wpopen(const wchar_t* _Command,const wchar_t* _Mode);\",\n",
    "    \"_wremove|__cdecl _wremove(const wchar_t* _Filename);\",\n",
    "    \"_wtmpnam|__cdecl _wtmpnam(wchar_t* _Buffer);\",\n",
    "    \"_fgetwc_nolock|__cdecl _fgetwc_nolock(FILE* _File);\",\n",
    "    \"_fputwc_nolock|__cdecl _fputwc_nolock(wchar_t _Ch,FILE* _File);\",\n",
    "    \"_ungetwc_nolock|__cdecl _ungetwc_nolock(wint_t _Ch,FILE* _File);\",\n",
    "    \"_fgetc_nolock|__cdecl _fgetc_nolock(FILE* _File);\",\n",
    "    \"_fputc_nolock|__cdecl _fputc_nolock(int _Char, FILE* _File);\",\n",
    "    \"_getc_nolock|__cdecl _getc_nolock(FILE* _File);\",\n",
    "    \"_putc_nolock|__cdecl _putc_nolock(int _Char, FILE* _File);\",\n",
    "    \"_lock_file|__cdecl _lock_file(FILE* _File);\",\n",
    "    \"_unlock_file|__cdecl _unlock_file(FILE* _File);\",\n",
    "    \"_fclose_nolock|__cdecl _fclose_nolock(FILE* _File);\",\n",
    "    \"_fflush_nolock|__cdecl _fflush_nolock(FILE* _File);\",\n",
    "    \"_fread_nolock|__cdecl _fread_nolock(void*  __restrict__ _DstBuf,size_t _ElementSize,size_t _Count,FILE*  __restrict__ _File);\",\n",
    "    \"_fseek_nolock|__cdecl _fseek_nolock(FILE* _File,long _Offset,int _Origin);\",\n",
    "    \"_ftell_nolock|__cdecl _ftell_nolock(FILE* _File);\",\n",
    "    \"_fseeki64_nolock|__cdecl _fseeki64_nolock(FILE* _File,__int64 _Offset,int _Origin);\",\n",
    "    \"_ftelli64_nolock|__cdecl _ftelli64_nolock(FILE* _File);\",\n",
    "    \"_fwrite_nolock|__cdecl _fwrite_nolock(const void*  __restrict__ _DstBuf,size_t _Size,size_t _Count,FILE*  __restrict__ _File);\",\n",
    "    \"_ungetc_nolock|__cdecl _ungetc_nolock(int _Ch,FILE* _File);\",\n",
    "    \"tempnam|__cdecl tempnam(const char* _Directory,const char* _FilePrefix);\",\n",
    "    \"fcloseall|__cdecl fcloseall(void);\",\n",
    "    \"fdopen|__cdecl fdopen(int _FileHandle,const char* _Format);\",\n",
    "    \"fgetchar|__cdecl fgetchar(void);\",\n",
    "    \"flushall|__cdecl flushall(void);\",\n",
    "    \"fputchar|__cdecl fputchar(int _Ch);\",\n",
    "    \"getw|__cdecl getw(FILE* _File);\",\n",
    "    \"putw|__cdecl putw(int _Ch,FILE* _File);\",\n",
    "    \"rmtmp|__cdecl rmtmp(void);\",\n",
    "    \"_wspawnl|__cdecl _wspawnl(int _Mode,const wchar_t* _Filename,const wchar_t* _ArgList,...);\",\n",
    "    \"_wspawnle|__cdecl _wspawnle(int _Mode,const wchar_t* _Filename,const wchar_t* _ArgList,...);\",\n",
    "    \"_wspawnlp|__cdecl _wspawnlp(int _Mode,const wchar_t* _Filename,const wchar_t* _ArgList,...);\",\n",
    "    \"_wspawnlpe|__cdecl _wspawnlpe(int _Mode,const wchar_t* _Filename,const wchar_t* _ArgList,...);\",\n",
    "    \"_wspawnv|__cdecl _wspawnv(int _Mode,const wchar_t* _Filename,const wchar_t* const* _ArgList);\",\n",
    "    \"_wspawnve|__cdecl _wspawnve(int _Mode,const wchar_t* _Filename,const wchar_t* const* _ArgList,const wchar_t* const* _Env);\",\n",
    "    \"_wspawnvp|__cdecl _wspawnvp(int _Mode,const wchar_t* _Filename,const wchar_t* const* _ArgList);\",\n",
    "    \"_wspawnvpe|__cdecl _wspawnvpe(int _Mode,const wchar_t* _Filename,const wchar_t* const* _ArgList,const wchar_t* const* _Env);\",\n",
    "    \"_spawnv|__cdecl _spawnv(int _Mode,const char* _Filename,const char* const* _ArgList);\",\n",
    "    \"_spawnve|__cdecl _spawnve(int _Mode,const char* _Filename,const char* const* _ArgList,const char* const* _Env);\",\n",
    "    \"_spawnvp|__cdecl _spawnvp(int _Mode,const char* _Filename,const char* const* _ArgList);\",\n",
    "    \"_spawnvpe|__cdecl _spawnvpe(int _Mode,const char* _Filename,const char* const* _ArgList,const char* const* _Env);\",\n",
    "    \"_memccpy|__cdecl _memccpy(void* _Dst,const void* _Src,int _Val,size_t _MaxCount);\",\n",
    "    \"memchr|__cdecl memchr(const void* _Buf ,int _Val,size_t _MaxCount);\",\n",
    "    \"_memicmp|__cdecl _memicmp(const void* _Buf1,const void* _Buf2,size_t _Size);\",\n",
    "    \"_memicmp_l|__cdecl _memicmp_l(const void* _Buf1,const void* _Buf2,size_t _Size,_locale_t _Locale);\",\n",
    "    \"memcmp|__cdecl memcmp(const void* _Buf1,const void* _Buf2,size_t _Size);\",\n",
    "    \"memcpy|__cdecl memcpy(void*  __restrict__ _Dst,const void*  __restrict__ _Src,size_t _Size);\",\n",
    "    \"memcpy_s|__cdecl memcpy_s (void* _dest,size_t _numberOfElements,const void* _src,size_t _count);\",\n",
    "    \"mempcpy|__cdecl mempcpy (void* _Dst, const void* _Src, size_t _Size);\",\n",
    "    \"memset|__cdecl memset(void* _Dst,int _Val,size_t _Size);\",\n",
    "    \"memccpy|__cdecl memccpy(void* _Dst,const void* _Src,int _Val,size_t _Size);\",\n",
    "    \"memicmp|__cdecl memicmp(const void* _Buf1,const void* _Buf2,size_t _Size);\",\n",
    "    \"_strset|__cdecl _strset(char* _Str,int _Val);\",\n",
    "    \"_strset_l|__cdecl _strset_l(char* _Str,int _Val,_locale_t _Locale);\",\n",
    "    \"strcpy|__cdecl strcpy(char*  __restrict__ _Dest,const char*  __restrict__ _Source);\",\n",
    "    \"strcat|__cdecl strcat(char*  __restrict__ _Dest,const char*  __restrict__ _Source);\",\n",
    "    \"strcmp|__cdecl strcmp(const char* _Str1,const char* _Str2);\",\n",
    "    \"strlen|__cdecl strlen(const char* _Str);\",\n",
    "    \"strnlen|__cdecl strnlen(const char* _Str,size_t _MaxCount);\",\n",
    "    \"memmove|__cdecl memmove(void* _Dst,const void* _Src,size_t _Size);\",\n",
    "    \"_strdup|__cdecl _strdup(const char* _Src);\",\n",
    "    \"strchr|__cdecl strchr(const char* _Str,int _Val);\",\n",
    "    \"_stricmp|__cdecl _stricmp(const char* _Str1,const char* _Str2);\",\n",
    "    \"_strcmpi|__cdecl _strcmpi(const char* _Str1,const char* _Str2);\",\n",
    "    \"_stricmp_l|__cdecl _stricmp_l(const char* _Str1,const char* _Str2,_locale_t _Locale);\",\n",
    "    \"strcoll|__cdecl strcoll(const char* _Str1,const char* _Str2);\",\n",
    "    \"_strcoll_l|__cdecl _strcoll_l(const char* _Str1,const char* _Str2,_locale_t _Locale);\",\n",
    "    \"_stricoll|__cdecl _stricoll(const char* _Str1,const char* _Str2);\",\n",
    "    \"_stricoll_l|__cdecl _stricoll_l(const char* _Str1,const char* _Str2,_locale_t _Locale);\",\n",
    "    \"_strncoll|__cdecl _strncoll (const char* _Str1,const char* _Str2,size_t _MaxCount);\",\n",
    "    \"_strncoll_l|__cdecl _strncoll_l(const char* _Str1,const char* _Str2,size_t _MaxCount,_locale_t _Locale);\",\n",
    "    \"_strnicoll|__cdecl _strnicoll (const char* _Str1,const char* _Str2,size_t _MaxCount);\",\n",
    "    \"_strnicoll_l|__cdecl _strnicoll_l(const char* _Str1,const char* _Str2,size_t _MaxCount,_locale_t _Locale);\",\n",
    "    \"strcspn|__cdecl strcspn(const char* _Str,const char* _Control);\",\n",
    "    \"_strerror|__cdecl _strerror(const char* _ErrMsg);\",\n",
    "    \"strerror|__cdecl strerror(int);\",\n",
    "    \"_strlwr|__cdecl _strlwr(char* _String);\",\n",
    "    \"strlwr_l|char* strlwr_l(char* _String,_locale_t _Locale);\",\n",
    "    \"strncat|__cdecl strncat(char*  __restrict__ _Dest,const char*  __restrict__ _Source,size_t _Count);\",\n",
    "    \"strncmp|__cdecl strncmp(const char* _Str1,const char* _Str2,size_t _MaxCount);\",\n",
    "    \"_strnicmp|__cdecl _strnicmp(const char* _Str1,const char* _Str2,size_t _MaxCount);\",\n",
    "    \"_strnicmp_l|__cdecl _strnicmp_l(const char* _Str1,const char* _Str2,size_t _MaxCount,_locale_t _Locale);\",\n",
    "    \"strncpy|char* strncpy(char*  __restrict__ _Dest,const char*  __restrict__ _Source,size_t _Count);\",\n",
    "    \"_strnset|__cdecl _strnset(char* _Str,int _Val,size_t _MaxCount);\",\n",
    "    \"_strnset_l|__cdecl _strnset_l(char* str,int c,size_t count,_locale_t _Locale);\",\n",
    "    \"strpbrk|__cdecl strpbrk(const char* _Str,const char* _Control);\",\n",
    "    \"strrchr|__cdecl strrchr(const char* _Str,int _Ch);\",\n",
    "    \"_strrev|__cdecl _strrev(char* _Str);\",\n",
    "    \"strspn|__cdecl strspn(const char* _Str,const char* _Control);\",\n",
    "    \"strstr|__cdecl strstr(const char* _Str,const char* _SubStr);\",\n",
    "    \"strtok|__cdecl strtok(char*  __restrict__ _Str,const char*  __restrict__ _Delim);\",\n",
    "    \"strtok_r|char* strtok_r(char*  __restrict__ _Str, const char*  __restrict__ _Delim, char**  __restrict__ __last);\",\n",
    "    \"_strupr|__cdecl _strupr(char* _String);\",\n",
    "    \"_strupr_l|char* _strupr_l(char* _String,_locale_t _Locale);\",\n",
    "    \"strxfrm|__cdecl strxfrm(char*  __restrict__ _Dst,const char*  __restrict__ _Src,size_t _MaxCount);\",\n",
    "    \"_strxfrm_l|__cdecl _strxfrm_l(char*  __restrict__ _Dst,const char*  __restrict__ _Src,size_t _MaxCount,_locale_t _Locale);\",\n",
    "    \"strdup|__cdecl strdup(const char* _Src);\",\n",
    "    \"strcmpi|__cdecl strcmpi(const char* _Str1,const char* _Str2);\",\n",
    "    \"stricmp|__cdecl stricmp(const char* _Str1,const char* _Str2);\",\n",
    "    \"strlwr|__cdecl strlwr(char* _Str);\",\n",
    "    \"strnicmp|__cdecl strnicmp(const char* _Str1,const char* _Str,size_t _MaxCount);\",\n",
    "    \"strncasecmp|__cdecl strncasecmp (const char* , const char* , size_t);\",\n",
    "    \"strcasecmp|__cdecl strcasecmp (const char* , const char* );\",\n",
    "    \"strnset|__cdecl strnset(char* _Str,int _Val,size_t _MaxCount);\",\n",
    "    \"strrev|__cdecl strrev(char* _Str);\",\n",
    "    \"strset|__cdecl strset(char* _Str,int _Val);\",\n",
    "    \"strupr|__cdecl strupr(char* _Str);\",\n",
    "    \"_wcsdup|__cdecl _wcsdup(const wchar_t* _Str);\",\n",
    "    \"wcscat|__cdecl wcscat(wchar_t*  __restrict__ _Dest,const wchar_t*  __restrict__ _Source);\",\n",
    "    \"wcschr|__cdecl wcschr(const wchar_t* _Str,wchar_t _Ch);\",\n",
    "    \"wcscmp|__cdecl wcscmp(const wchar_t* _Str1,const wchar_t* _Str2);\",\n",
    "    \"wcscpy|__cdecl wcscpy(wchar_t*  __restrict__ _Dest,const wchar_t*  __restrict__ _Source);\",\n",
    "    \"wcscspn|__cdecl wcscspn(const wchar_t* _Str,const wchar_t* _Control);\",\n",
    "    \"wcslen|__cdecl wcslen(const wchar_t* _Str);\",\n",
    "    \"wcsnlen|__cdecl wcsnlen(const wchar_t* _Src,size_t _MaxCount);\",\n",
    "    \"wcsncat|wchar_t* wcsncat(wchar_t*  __restrict__ _Dest,const wchar_t*  __restrict__ _Source,size_t _Count);\",\n",
    "    \"wcsncmp|__cdecl wcsncmp(const wchar_t* _Str1,const wchar_t* _Str2,size_t _MaxCount);\",\n",
    "    \"wcsncpy|wchar_t* wcsncpy(wchar_t*  __restrict__ _Dest,const wchar_t*  __restrict__ _Source,size_t _Count);\",\n",
    "    \"_wcsncpy_l|__cdecl _wcsncpy_l(wchar_t*  __restrict__ _Dest,const wchar_t*  __restrict__ _Source,size_t _Count,_locale_t _Locale);\",\n",
    "    \"wcspbrk|__cdecl wcspbrk(const wchar_t* _Str,const wchar_t* _Control);\",\n",
    "    \"wcsrchr|__cdecl wcsrchr(const wchar_t* _Str,wchar_t _Ch);\",\n",
    "    \"wcsspn|__cdecl wcsspn(const wchar_t* _Str,const wchar_t* _Control);\",\n",
    "    \"wcsstr|__cdecl wcsstr(const wchar_t* _Str,const wchar_t* _SubStr);\",\n",
    "    \"wcstok|__cdecl wcstok(wchar_t*  __restrict__ _Str,const wchar_t*  __restrict__ _Delim);\",\n",
    "    \"_wcserror|__cdecl _wcserror(int _ErrNum);\",\n",
    "    \"__wcserror|__cdecl __wcserror(const wchar_t* _Str);\",\n",
    "    \"_wcsicmp|__cdecl _wcsicmp(const wchar_t* _Str1,const wchar_t* _Str2);\",\n",
    "    \"_wcsicmp_l|__cdecl _wcsicmp_l(const wchar_t* _Str1,const wchar_t* _Str2,_locale_t _Locale);\",\n",
    "    \"_wcsnicmp|__cdecl _wcsnicmp(const wchar_t* _Str1,const wchar_t* _Str2,size_t _MaxCount);\",\n",
    "    \"_wcsnicmp_l|__cdecl _wcsnicmp_l(const wchar_t* _Str1,const wchar_t* _Str2,size_t _MaxCount,_locale_t _Locale);\",\n",
    "    \"_wcsnset|__cdecl _wcsnset(wchar_t* _Str,wchar_t _Val,size_t _MaxCount);\",\n",
    "    \"_wcsrev|__cdecl _wcsrev(wchar_t* _Str);\",\n",
    "    \"_wcsset|__cdecl _wcsset(wchar_t* _Str,wchar_t _Val);\",\n",
    "    \"_wcslwr|__cdecl _wcslwr(wchar_t* _String);\",\n",
    "    \"_wcslwr_l|wchar_t* _wcslwr_l(wchar_t* _String,_locale_t _Locale);\",\n",
    "    \"_wcsupr|__cdecl _wcsupr(wchar_t* _String);\",\n",
    "    \"_wcsupr_l|wchar_t* _wcsupr_l(wchar_t* _String,_locale_t _Locale);\",\n",
    "    \"wcsxfrm|__cdecl wcsxfrm(wchar_t*  __restrict__ _Dst,const wchar_t*  __restrict__ _Src,size_t _MaxCount);\",\n",
    "    \"_wcsxfrm_l|__cdecl _wcsxfrm_l(wchar_t*  __restrict__ _Dst,const wchar_t*  __restrict__ _Src,size_t _MaxCount,_locale_t _Locale);\",\n",
    "    \"wcscoll|__cdecl wcscoll(const wchar_t* _Str1,const wchar_t* _Str2);\",\n",
    "    \"_wcscoll_l|__cdecl _wcscoll_l(const wchar_t* _Str1,const wchar_t* _Str2,_locale_t _Locale);\",\n",
    "    \"_wcsicoll|__cdecl _wcsicoll(const wchar_t* _Str1,const wchar_t* _Str2);\",\n",
    "    \"_wcsicoll_l|__cdecl _wcsicoll_l(const wchar_t* _Str1,const wchar_t* _Str2,_locale_t _Locale);\",\n",
    "    \"_wcsncoll|__cdecl _wcsncoll(const wchar_t* _Str1,const wchar_t* _Str2,size_t _MaxCount);\",\n",
    "    \"_wcsncoll_l|__cdecl _wcsncoll_l(const wchar_t* _Str1,const wchar_t* _Str2,size_t _MaxCount,_locale_t _Locale);\",\n",
    "    \"_wcsnicoll|__cdecl _wcsnicoll(const wchar_t* _Str1,const wchar_t* _Str2,size_t _MaxCount);\",\n",
    "    \"_wcsnicoll_l|__cdecl _wcsnicoll_l(const wchar_t* _Str1,const wchar_t* _Str2,size_t _MaxCount,_locale_t _Locale);\",\n",
    "    \"wcsdup|__cdecl wcsdup(const wchar_t* _Str);\",\n",
    "    \"wcsicmp|__cdecl wcsicmp(const wchar_t* _Str1,const wchar_t* _Str2);\",\n",
    "    \"wcsnicmp|__cdecl wcsnicmp(const wchar_t* _Str1,const wchar_t* _Str2,size_t _MaxCount);\",\n",
    "    \"wcsnset|__cdecl wcsnset(wchar_t* _Str,wchar_t _Val,size_t _MaxCount);\",\n",
    "    \"wcsrev|__cdecl wcsrev(wchar_t* _Str);\",\n",
    "    \"wcsset|__cdecl wcsset(wchar_t* _Str,wchar_t _Val);\",\n",
    "    \"wcslwr|__cdecl wcslwr(wchar_t* _Str);\",\n",
    "    \"wcsupr|__cdecl wcsupr(wchar_t* _Str);\",\n",
    "    \"wcsicoll|__cdecl wcsicoll(const wchar_t* _Str1,const wchar_t* _Str2);\",\n",
    "    \"___mb_cur_max_func|__cdecl ___mb_cur_max_func(void);\",\n",
    "    \"_set_purecall_handler|__cdecl _set_purecall_handler(_purecall_handler _Handler);\",\n",
    "    \"_get_purecall_handler|__cdecl _get_purecall_handler(void);\",\n",
    "    \"_set_invalid_parameter_handler|__cdecl _set_invalid_parameter_handler(_invalid_parameter_handler _Handler);\",\n",
    "    \"_get_invalid_parameter_handler|__cdecl _get_invalid_parameter_handler(void);\",\n",
    "    \"_errno|__cdecl _errno(void);\",\n",
    "    \"_set_errno|__cdecl _set_errno(int _Value);\",\n",
    "    \"_get_errno|__cdecl _get_errno(int* _Value);\",\n",
    "    \"__doserrno|__cdecl __doserrno(void);\",\n",
    "    \"_set_doserrno|__cdecl _set_doserrno(unsigned long _Value);\",\n",
    "    \"_get_doserrno|__cdecl _get_doserrno(unsigned long* _Value);\",\n",
    "    \"__sys_errlist|__cdecl __sys_errlist(void);\",\n",
    "    \"__sys_nerr|__cdecl __sys_nerr(void);\",\n",
    "    \"__declspec|extern __declspec(dllimport) char* _sys_errlist[1];\",\n",
    "    \"__declspec|extern __declspec(dllimport) int _sys_nerr;\",\n",
    "    \"__p___argv|__cdecl __p___argv(void);\",\n",
    "    \"__p__fmode|__cdecl __p__fmode(void);\",\n",
    "    \"__p___argc|__cdecl __p___argc(void);\",\n",
    "    \"__p___wargv|__cdecl __p___wargv(void);\",\n",
    "    \"__p__environ|__cdecl __p__environ(void);\",\n",
    "    \"__p__wenviron|__cdecl __p__wenviron(void);\",\n",
    "    \"__p__pgmptr|__cdecl __p__pgmptr(void);\",\n",
    "    \"__p__wpgmptr|__cdecl __p__wpgmptr(void);\",\n",
    "    \"_get_pgmptr|__cdecl _get_pgmptr(char** _Value);\",\n",
    "    \"_get_wpgmptr|__cdecl _get_wpgmptr(wchar_t** _Value);\",\n",
    "    \"_set_fmode|__cdecl _set_fmode(int _Mode);\",\n",
    "    \"_get_fmode|__cdecl _get_fmode(int* _PMode);\",\n",
    "    \"_get_environ|__cdecl _get_environ(char*** );\",\n",
    "    \"_get_wenviron|__cdecl _get_wenviron(wchar_t*** );\",\n",
    "    \"_get_osplatform|__cdecl _get_osplatform(unsigned int* _Value);\",\n",
    "    \"_get_osver|__cdecl _get_osver(unsigned int* _Value);\",\n",
    "    \"_get_winver|__cdecl _get_winver(unsigned int* _Value);\",\n",
    "    \"_get_winmajor|__cdecl _get_winmajor(unsigned int* _Value);\",\n",
    "    \"_get_winminor|__cdecl _get_winminor(unsigned int* _Value);\",\n",
    "    \"_CountofType|UNALIGNED _CountofType (&_Array)[_SizeOfArray]))[_SizeOfArray];\",\n",
    "    \"exit|__MINGW_NOTHROW exit(int _Code);\",\n",
    "    \"_exit|__MINGW_NOTHROW _exit(int _Code);\",\n",
    "    \"quick_exit|__MINGW_NOTHROW quick_exit(int _Code);\",\n",
    "    \"_Exit|__cdecl _Exit(int);\",\n",
    "    \"_set_abort_behavior|__cdecl _set_abort_behavior(unsigned int _Flags,unsigned int _Mask);\",\n",
    "    \"abs|__cdecl abs(int _X);\",\n",
    "    \"labs|__cdecl labs(long _X);\",\n",
    "    \"_abs64|__cdecl _abs64(__int64);\",\n",
    "    \"atexit|__cdecl atexit(void (__cdecl* )(void));\",\n",
    "    \"at_quick_exit|__cdecl at_quick_exit(void (__cdecl* )(void));\",\n",
    "    \"atof|__cdecl atof(const char* _String);\",\n",
    "    \"_atof_l|__cdecl _atof_l(const char* _String,_locale_t _Locale);\",\n",
    "    \"atoi|__cdecl atoi(const char* _Str);\",\n",
    "    \"_atoi_l|__cdecl _atoi_l(const char* _Str,_locale_t _Locale);\",\n",
    "    \"atol|__cdecl atol(const char* _Str);\",\n",
    "    \"_atol_l|__cdecl _atol_l(const char* _Str,_locale_t _Locale);\",\n",
    "    \"bsearch|__cdecl bsearch(const void* _Key,const void* _Base,size_t _NumOfElements,size_t _SizeOfElements,int (__cdecl* _PtFuncCompare)(const void* ,const void* ));\",\n",
    "    \"qsort|__cdecl qsort(void* _Base,size_t _NumOfElements,size_t _SizeOfElements,int (__cdecl* _PtFuncCompare)(const void* ,const void* ));\",\n",
    "    \"_byteswap_ushort|__cdecl _byteswap_ushort(unsigned short _Short);\",\n",
    "    \"_byteswap_ulong|__cdecl _byteswap_ulong (unsigned long _Long);\",\n",
    "    \"_byteswap_uint64|__cdecl _byteswap_uint64(unsigned __int64 _Int64);\",\n",
    "    \"div|__cdecl div(int _Numerator,int _Denominator);\",\n",
    "    \"getenv|__cdecl getenv(const char* _VarName);\",\n",
    "    \"_itoa|__cdecl _itoa(int _Value,char* _Dest,int _Radix);\",\n",
    "    \"_i64toa|__cdecl _i64toa(__int64 _Val,char* _DstBuf,int _Radix);\",\n",
    "    \"_ui64toa|__cdecl _ui64toa(unsigned __int64 _Val,char* _DstBuf,int _Radix);\",\n",
    "    \"_atoi64|__cdecl _atoi64(const char* _String);\",\n",
    "    \"_atoi64_l|__cdecl _atoi64_l(const char* _String,_locale_t _Locale);\",\n",
    "    \"_strtoi64|__cdecl _strtoi64(const char* _String,char** _EndPtr,int _Radix);\",\n",
    "    \"_strtoi64_l|__cdecl _strtoi64_l(const char* _String,char** _EndPtr,int _Radix,_locale_t _Locale);\",\n",
    "    \"_strtoui64|__cdecl _strtoui64(const char* _String,char** _EndPtr,int _Radix);\",\n",
    "    \"_strtoui64_l|__cdecl _strtoui64_l(const char* _String,char** _EndPtr,int _Radix,_locale_t _Locale);\",\n",
    "    \"ldiv|__cdecl ldiv(long _Numerator,long _Denominator);\",\n",
    "    \"_ltoa|__cdecl _ltoa(long _Value,char* _Dest,int _Radix);\",\n",
    "    \"mblen|__cdecl mblen(const char* _Ch,size_t _MaxCount);\",\n",
    "    \"_mblen_l|__cdecl _mblen_l(const char* _Ch,size_t _MaxCount,_locale_t _Locale);\",\n",
    "    \"_mbstrlen|__cdecl _mbstrlen(const char* _Str);\",\n",
    "    \"_mbstrlen_l|__cdecl _mbstrlen_l(const char* _Str,_locale_t _Locale);\",\n",
    "    \"_mbstrnlen|__cdecl _mbstrnlen(const char* _Str,size_t _MaxCount);\",\n",
    "    \"_mbstrnlen_l|__cdecl _mbstrnlen_l(const char* _Str,size_t _MaxCount,_locale_t _Locale);\",\n",
    "    \"mbtowc|__cdecl mbtowc(wchar_t*  __restrict__ _DstCh,const char*  __restrict__ _SrcCh,size_t _SrcSizeInBytes);\",\n",
    "    \"_mbtowc_l|__cdecl _mbtowc_l(wchar_t*  __restrict__ _DstCh,const char*  __restrict__ _SrcCh,size_t _SrcSizeInBytes,_locale_t _Locale);\",\n",
    "    \"mbstowcs|__cdecl mbstowcs(wchar_t*  __restrict__ _Dest,const char*  __restrict__ _Source,size_t _MaxCount);\",\n",
    "    \"_mbstowcs_l|__cdecl _mbstowcs_l(wchar_t*  __restrict__ _Dest,const char*  __restrict__ _Source,size_t _MaxCount,_locale_t _Locale);\",\n",
    "    \"mkstemp|__cdecl mkstemp(char* template_name);\",\n",
    "    \"rand|__cdecl rand(void);\",\n",
    "    \"_set_error_mode|__cdecl _set_error_mode(int _Mode);\",\n",
    "    \"srand|__cdecl srand(unsigned int _Seed);\",\n",
    "    \"rand_s|__cdecl rand_s(unsigned int* randomValue);\",\n",
    "    \"strtod|__MINGW_NOTHROW strtod(const char*  __restrict__ _Str,char**  __restrict__ _EndPtr);\",\n",
    "    \"strtof|__MINGW_NOTHROW strtof(const char*  __restrict__ nptr, char**  __restrict__ endptr);\",\n",
    "    \"strtold|__MINGW_NOTHROW strtold(const char*  __restrict__ , char**  __restrict__ );\",\n",
    "    \"_strtod_l|__cdecl _strtod_l(const char*  __restrict__ _Str,char**  __restrict__ _EndPtr,_locale_t _Locale);\",\n",
    "    \"strtol|__cdecl strtol(const char*  __restrict__ _Str,char**  __restrict__ _EndPtr,int _Radix);\",\n",
    "    \"_strtol_l|__cdecl _strtol_l(const char*  __restrict__ _Str,char**  __restrict__ _EndPtr,int _Radix,_locale_t _Locale);\",\n",
    "    \"strtoul|__cdecl strtoul(const char*  __restrict__ _Str,char**  __restrict__ _EndPtr,int _Radix);\",\n",
    "    \"_strtoul_l|__cdecl _strtoul_l(const char*  __restrict__ _Str,char**  __restrict__ _EndPtr,int _Radix,_locale_t _Locale);\",\n",
    "    \"system|__cdecl system(const char* _Command);\",\n",
    "    \"_ultoa|__cdecl _ultoa(unsigned long _Value,char* _Dest,int _Radix);\",\n",
    "    \"wctomb|__cdecl wctomb(char* _MbCh,wchar_t _WCh);\",\n",
    "    \"_wctomb_l|__cdecl _wctomb_l(char* _MbCh,wchar_t _WCh,_locale_t _Locale);\",\n",
    "    \"wcstombs|__cdecl wcstombs(char*  __restrict__ _Dest,const wchar_t*  __restrict__ _Source,size_t _MaxCount);\",\n",
    "    \"_wcstombs_l|__cdecl _wcstombs_l(char*  __restrict__ _Dest,const wchar_t*  __restrict__ _Source,size_t _MaxCount,_locale_t _Locale);\",\n",
    "    \"calloc|__cdecl calloc(size_t _NumOfElements,size_t _SizeOfElements);\",\n",
    "    \"free|__cdecl free(void* _Memory);\",\n",
    "    \"malloc|__cdecl malloc(size_t _Size);\",\n",
    "    \"realloc|__cdecl realloc(void* _Memory,size_t _NewSize);\",\n",
    "    \"_recalloc|__cdecl _recalloc(void* _Memory,size_t _Count,size_t _Size);\",\n",
    "    \"_aligned_free|__cdecl _aligned_free(void* _Memory);\",\n",
    "    \"_aligned_malloc|__cdecl _aligned_malloc(size_t _Size,size_t _Alignment);\",\n",
    "    \"_aligned_offset_malloc|__cdecl _aligned_offset_malloc(size_t _Size,size_t _Alignment,size_t _Offset);\",\n",
    "    \"_aligned_realloc|__cdecl _aligned_realloc(void* _Memory,size_t _Size,size_t _Alignment);\",\n",
    "    \"_aligned_recalloc|__cdecl _aligned_recalloc(void* _Memory,size_t _Count,size_t _Size,size_t _Alignment);\",\n",
    "    \"_aligned_offset_realloc|__cdecl _aligned_offset_realloc(void* _Memory,size_t _Size,size_t _Alignment,size_t _Offset);\",\n",
    "    \"_aligned_offset_recalloc|__cdecl _aligned_offset_recalloc(void* _Memory,size_t _Count,size_t _Size,size_t _Alignment,size_t _Offset);\",\n",
    "    \"_itow|__cdecl _itow(int _Value,wchar_t* _Dest,int _Radix);\",\n",
    "    \"_ltow|__cdecl _ltow(long _Value,wchar_t* _Dest,int _Radix);\",\n",
    "    \"_ultow|__cdecl _ultow(unsigned long _Value,wchar_t* _Dest,int _Radix);\",\n",
    "    \"wcstod|__cdecl wcstod(const wchar_t*  __restrict__ _Str,wchar_t**  __restrict__ _EndPtr);\",\n",
    "    \"wcstof|__cdecl wcstof(const wchar_t*  __restrict__ nptr, wchar_t**  __restrict__ endptr);\",\n",
    "    \"wcstold|__cdecl wcstold(const wchar_t*  __restrict__, wchar_t**  __restrict__);\",\n",
    "    \"_wcstod_l|__cdecl _wcstod_l(const wchar_t*  __restrict__ _Str,wchar_t**  __restrict__ _EndPtr,_locale_t _Locale);\",\n",
    "    \"wcstol|__cdecl wcstol(const wchar_t*  __restrict__ _Str,wchar_t**  __restrict__ _EndPtr,int _Radix);\",\n",
    "    \"_wcstol_l|__cdecl _wcstol_l(const wchar_t*  __restrict__ _Str,wchar_t**  __restrict__ _EndPtr,int _Radix,_locale_t _Locale);\",\n",
    "    \"wcstoul|__cdecl wcstoul(const wchar_t*  __restrict__ _Str,wchar_t**  __restrict__ _EndPtr,int _Radix);\",\n",
    "    \"_wcstoul_l|__cdecl _wcstoul_l(const wchar_t*  __restrict__ _Str,wchar_t**  __restrict__ _EndPtr,int _Radix,_locale_t _Locale);\",\n",
    "    \"_wgetenv|__cdecl _wgetenv(const wchar_t* _VarName);\",\n",
    "    \"_wsystem|__cdecl _wsystem(const wchar_t* _Command);\",\n",
    "    \"_wtof|__cdecl _wtof(const wchar_t* _Str);\",\n",
    "    \"_wtof_l|__cdecl _wtof_l(const wchar_t* _Str,_locale_t _Locale);\",\n",
    "    \"_wtoi|__cdecl _wtoi(const wchar_t* _Str);\",\n",
    "    \"_wtoi_l|__cdecl _wtoi_l(const wchar_t* _Str,_locale_t _Locale);\",\n",
    "    \"_wtol|__cdecl _wtol(const wchar_t* _Str);\",\n",
    "    \"_wtol_l|__cdecl _wtol_l(const wchar_t* _Str,_locale_t _Locale);\",\n",
    "    \"_i64tow|__cdecl _i64tow(__int64 _Val,wchar_t* _DstBuf,int _Radix);\",\n",
    "    \"_ui64tow|__cdecl _ui64tow(unsigned __int64 _Val,wchar_t* _DstBuf,int _Radix);\",\n",
    "    \"_wtoi64|__cdecl _wtoi64(const wchar_t* _Str);\",\n",
    "    \"_wtoi64_l|__cdecl _wtoi64_l(const wchar_t* _Str,_locale_t _Locale);\",\n",
    "    \"_wcstoi64|__cdecl _wcstoi64(const wchar_t* _Str,wchar_t** _EndPtr,int _Radix);\",\n",
    "    \"_wcstoi64_l|__cdecl _wcstoi64_l(const wchar_t* _Str,wchar_t** _EndPtr,int _Radix,_locale_t _Locale);\",\n",
    "    \"_wcstoui64|__cdecl _wcstoui64(const wchar_t* _Str,wchar_t** _EndPtr,int _Radix);\",\n",
    "    \"_wcstoui64_l|__cdecl _wcstoui64_l(const wchar_t* _Str ,wchar_t** _EndPtr,int _Radix,_locale_t _Locale);\",\n",
    "    \"_putenv|__cdecl _putenv(const char* _EnvString);\",\n",
    "    \"_wputenv|__cdecl _wputenv(const wchar_t* _EnvString);\",\n",
    "    \"_fullpath|__cdecl _fullpath(char* _FullPath,const char* _Path,size_t _SizeInBytes);\",\n",
    "    \"_ecvt|__cdecl _ecvt(double _Val,int _NumOfDigits,int* _PtDec,int* _PtSign);\",\n",
    "    \"_fcvt|__cdecl _fcvt(double _Val,int _NumOfDec,int* _PtDec,int* _PtSign);\",\n",
    "    \"_gcvt|__cdecl _gcvt(double _Val,int _NumOfDigits,char* _DstBuf);\",\n",
    "    \"_atodbl|__cdecl _atodbl(_CRT_DOUBLE* _Result,char* _Str);\",\n",
    "    \"_atoldbl|__cdecl _atoldbl(_LDOUBLE* _Result,char* _Str);\",\n",
    "    \"_atoflt|__cdecl _atoflt(_CRT_FLOAT* _Result,char* _Str);\",\n",
    "    \"_atodbl_l|__cdecl _atodbl_l(_CRT_DOUBLE* _Result,char* _Str,_locale_t _Locale);\",\n",
    "    \"_atoldbl_l|__cdecl _atoldbl_l(_LDOUBLE* _Result,char* _Str,_locale_t _Locale);\",\n",
    "    \"_atoflt_l|__cdecl _atoflt_l(_CRT_FLOAT* _Result,char* _Str,_locale_t _Locale);\",\n",
    "    \"_lrotl|__cdecl _lrotl(unsigned long,int);\",\n",
    "    \"_lrotr|__cdecl _lrotr(unsigned long,int);\",\n",
    "    \"_makepath|__cdecl _makepath(char* _Path,const char* _Drive,const char* _Dir,const char* _Filename,const char* _Ext);\",\n",
    "    \"_onexit|__cdecl _onexit(_onexit_t _Func);\",\n",
    "    \"_rotl64|__cdecl _rotl64(unsigned __int64 _Val,int _Shift);\",\n",
    "    \"_rotr64|__cdecl _rotr64(unsigned __int64 Value,int Shift);\",\n",
    "    \"_rotr|__cdecl _rotr(unsigned int _Val,int _Shift);\",\n",
    "    \"_rotl|__cdecl _rotl(unsigned int _Val,int _Shift);\",\n",
    "    \"_rotr64|__cdecl _rotr64(unsigned __int64 _Val,int _Shift);\",\n",
    "    \"_searchenv|__cdecl _searchenv(const char* _Filename,const char* _EnvVar,char* _ResultPath);\",\n",
    "    \"_splitpath|__cdecl _splitpath(const char* _FullPath,char* _Drive,char* _Dir,char* _Filename,char* _Ext);\",\n",
    "    \"_swab|__cdecl _swab(char* _Buf1,char* _Buf2,int _SizeInBytes);\",\n",
    "    \"_wfullpath|__cdecl _wfullpath(wchar_t* _FullPath,const wchar_t* _Path,size_t _SizeInWords);\",\n",
    "    \"_wmakepath|__cdecl _wmakepath(wchar_t* _ResultPath,const wchar_t* _Drive,const wchar_t* _Dir,const wchar_t* _Filename,const wchar_t* _Ext);\",\n",
    "    \"_wsearchenv|__cdecl _wsearchenv(const wchar_t* _Filename,const wchar_t* _EnvVar,wchar_t* _ResultPath);\",\n",
    "    \"_wsplitpath|__cdecl _wsplitpath(const wchar_t* _FullPath,wchar_t* _Drive,wchar_t* _Dir,wchar_t* _Filename,wchar_t* _Ext);\",\n",
    "    \"_beep|__cdecl _beep(unsigned _Frequency,unsigned _Duration);\",\n",
    "    \"_seterrormode|__cdecl _seterrormode(int _Mode);\",\n",
    "    \"_sleep|__cdecl _sleep(unsigned long _Duration);\",\n",
    "    \"ecvt|__cdecl ecvt(double _Val,int _NumOfDigits,int* _PtDec,int* _PtSign);\",\n",
    "    \"fcvt|__cdecl fcvt(double _Val,int _NumOfDec,int* _PtDec,int* _PtSign);\",\n",
    "    \"gcvt|__cdecl gcvt(double _Val,int _NumOfDigits,char* _DstBuf);\",\n",
    "    \"itoa|__cdecl itoa(int _Val,char* _DstBuf,int _Radix);\",\n",
    "    \"ltoa|__cdecl ltoa(long _Val,char* _DstBuf,int _Radix);\",\n",
    "    \"putenv|__cdecl putenv(const char* _EnvString);\",\n",
    "    \"swab|__cdecl swab(char* _Buf1,char* _Buf2,int _SizeInBytes);\",\n",
    "    \"ultoa|__cdecl ultoa(unsigned long _Val,char* _Dstbuf,int _Radix);\",\n",
    "    \"onexit|__cdecl onexit(onexit_t _Func);\",\n",
    "    \"lldiv|__cdecl lldiv(long long, long long);\",\n",
    "    \"llabs|__cdecl llabs(long long);\",\n",
    "    \"strtoll|__cdecl strtoll(const char*  __restrict__, char**  __restrict, int);\",\n",
    "    \"strtoull|__cdecl strtoull(const char*  __restrict__, char**  __restrict__, int);\",\n",
    "    \"atoll|__cdecl atoll (const char* );\",\n",
    "    \"wtoll|__cdecl wtoll (const wchar_t* );\",\n",
    "    \"lltoa|__cdecl lltoa (long long, char* , int);\",\n",
    "    \"ulltoa|__cdecl ulltoa (unsigned long long , char* , int);\",\n",
    "    \"lltow|__cdecl lltow (long long, wchar_t* , int);\",\n",
    "    \"ulltow|__cdecl ulltow (unsigned long long, wchar_t* , int);\",\n",
    "    \"__daylight|__cdecl __daylight(void);\",\n",
    "    \"__dstbias|__cdecl __dstbias(void);\",\n",
    "    \"__timezone|__cdecl __timezone(void);\",\n",
    "    \"__tzname|__cdecl __tzname(void);\",\n",
    "    \"_get_daylight|__cdecl _get_daylight(int* _Daylight);\",\n",
    "    \"_get_dstbias|__cdecl _get_dstbias(long* _Daylight_savings_bias);\",\n",
    "    \"_get_timezone|__cdecl _get_timezone(long* _Timezone);\",\n",
    "    \"asctime|__cdecl asctime(const struct tm* _Tm);\",\n",
    "    \"asctime_s|__cdecl asctime_s (char* _Buf,size_t _SizeInWords,const struct tm* _Tm);\",\n",
    "    \"_ctime32|__cdecl _ctime32(const __time32_t* _Time);\",\n",
    "    \"_ctime32_s|__cdecl _ctime32_s (char* _Buf,size_t _SizeInBytes,const __time32_t* _Time);\",\n",
    "    \"clock|__cdecl clock(void);\",\n",
    "    \"_difftime32|__cdecl _difftime32(__time32_t _Time1,__time32_t _Time2);\",\n",
    "    \"_gmtime32|__cdecl _gmtime32(const __time32_t* _Time);\",\n",
    "    \"_gmtime32_s|__cdecl _gmtime32_s (struct tm* _Tm,const __time32_t* _Time);\",\n",
    "    \"_localtime32|__cdecl _localtime32(const __time32_t* _Time);\",\n",
    "    \"_localtime32_s|__cdecl _localtime32_s (struct tm* _Tm,const __time32_t* _Time);\",\n",
    "    \"strftime|__cdecl strftime(char*  __restrict__ _Buf,size_t _SizeInBytes,const char*  __restrict__ _Format,const struct tm*  __restrict__ _Tm);\",\n",
    "    \"_strftime_l|__cdecl _strftime_l(char*  __restrict__ _Buf,size_t _Max_size,const char*  __restrict__ _Format,const struct tm*  __restrict__ _Tm,_locale_t _Locale);\",\n",
    "    \"_strdate|__cdecl _strdate(char* _Buffer);\",\n",
    "    \"_strdate_s|__cdecl _strdate_s (char* _Buf,size_t _SizeInBytes);\",\n",
    "    \"_strtime|__cdecl _strtime(char* _Buffer);\",\n",
    "    \"_strtime_s|__cdecl _strtime_s (char* _Buf ,size_t _SizeInBytes);\",\n",
    "    \"_time32|__cdecl _time32(__time32_t* _Time);\",\n",
    "    \"_mktime32|__cdecl _mktime32(struct tm* _Tm);\",\n",
    "    \"_mkgmtime32|__cdecl _mkgmtime32(struct tm* _Tm);\",\n",
    "    \"tzset|__cdecl tzset(void);\",\n",
    "    \"_tzset|__cdecl _tzset(void);\",\n",
    "    \"_difftime64|__cdecl _difftime64(__time64_t _Time1,__time64_t _Time2);\",\n",
    "    \"_ctime64|__cdecl _ctime64(const __time64_t* _Time);\",\n",
    "    \"_ctime64_s|__cdecl _ctime64_s (char* _Buf,size_t _SizeInBytes,const __time64_t* _Time);\",\n",
    "    \"_gmtime64|__cdecl _gmtime64(const __time64_t* _Time);\",\n",
    "    \"_gmtime64_s|__cdecl _gmtime64_s (struct tm* _Tm,const __time64_t* _Time);\",\n",
    "    \"_localtime64|__cdecl _localtime64(const __time64_t* _Time);\",\n",
    "    \"_localtime64_s|__cdecl _localtime64_s (struct tm* _Tm,const __time64_t* _Time);\",\n",
    "    \"_mktime64|__cdecl _mktime64(struct tm* _Tm);\",\n",
    "    \"_mkgmtime64|__cdecl _mkgmtime64(struct tm* _Tm);\",\n",
    "    \"_time64|__cdecl _time64(__time64_t* _Time);\",\n",
    "    \"_getsystime|__cdecl _getsystime(struct tm* _Tm);\",\n",
    "    \"_setsystime|__cdecl _setsystime(struct tm* _Tm,unsigned _MilliSec);\",\n",
    "    \"_wasctime|__cdecl _wasctime(const struct tm* _Tm);\",\n",
    "    \"_wasctime_s|__cdecl _wasctime_s (wchar_t* _Buf,size_t _SizeInWords,const struct tm* _Tm);\",\n",
    "    \"_wctime32|__cdecl _wctime32(const __time32_t* _Time);\",\n",
    "    \"_wctime32_s|__cdecl _wctime32_s (wchar_t* _Buf,size_t _SizeInWords,const __time32_t* _Time);\",\n",
    "    \"wcsftime|__cdecl wcsftime(wchar_t*  __restrict__ _Buf,size_t _SizeInWords,const wchar_t*  __restrict__ _Format,const struct tm*  __restrict__ _Tm);\",\n",
    "    \"_wcsftime_l|__cdecl _wcsftime_l(wchar_t*  __restrict__ _Buf,size_t _SizeInWords,const wchar_t*  __restrict__ _Format,const struct tm*  __restrict__ _Tm,_locale_t _Locale);\",\n",
    "    \"_wstrdate|__cdecl _wstrdate(wchar_t* _Buffer);\",\n",
    "    \"_wstrdate_s|__cdecl _wstrdate_s (wchar_t* _Buf,size_t _SizeInWords);\",\n",
    "    \"_wstrtime|__cdecl _wstrtime(wchar_t* _Buffer);\",\n",
    "    \"_wstrtime_s|__cdecl _wstrtime_s (wchar_t* _Buf,size_t _SizeInWords);\",\n",
    "    \"_wctime64|__cdecl _wctime64(const __time64_t* _Time);\",\n",
    "    \"_wctime64_s|__cdecl _wctime64_s (wchar_t* _Buf,size_t _SizeInWords,const __time64_t* _Time);\",\n",
    "    \"_wctime|__cdecl _wctime(const time_t* );\",\n",
    "    \"_wctime_s|__cdecl _wctime_s(wchar_t* , size_t, const time_t* );\",\n",
    "    \"mingw_gettimeofday|__cdecl mingw_gettimeofday (struct timeval* p, struct timezone* z);\",\n",
    "    \"_wassert|__cdecl _wassert(const wchar_t* _Message,const wchar_t* _File,unsigned _Line);\",\n",
    "    \"_assert|__cdecl _assert (const char* _Message, const char* _File, unsigned _Line);\",\n",
    "    \"_configthreadlocale|__cdecl _configthreadlocale(int _Flag);\",\n",
    "    \"setlocale|__cdecl setlocale(int _Category,const char* _Locale);\",\n",
    "    \"localeconv|__cdecl localeconv(void);\",\n",
    "    \"_get_current_locale|__cdecl _get_current_locale(void);\",\n",
    "    \"_create_locale|__cdecl _create_locale(int _Category,const char* _Locale);\",\n",
    "    \"_free_locale|__cdecl _free_locale(_locale_t _Locale);\",\n",
    "    \"__get_current_locale|__cdecl __get_current_locale(void);\",\n",
    "    \"__create_locale|__cdecl __create_locale(int _Category,const char* _Locale);\",\n",
    "    \"__free_locale|__cdecl __free_locale(_locale_t _Locale);\",\n",
    "    \"___lc_codepage_func|__cdecl ___lc_codepage_func(void);\",\n",
    "    \"_wsetlocale|__cdecl _wsetlocale(int _Category,const wchar_t* _Locale);\",\n",
    "    \"_controlfp|__MINGW_NOTHROW _controlfp (unsigned int _NewValue, unsigned int _Mask);\",\n",
    "    \"_controlfp_s|__cdecl _controlfp_s(unsigned int* _CurrentState, unsigned int _NewValue, unsigned int _Mask);\",\n",
    "    \"_control87|__MINGW_NOTHROW _control87 (unsigned int _NewValue, unsigned int _Mask);\",\n",
    "    \"_fpreset|__MINGW_NOTHROW _fpreset (void);\",\n",
    "    \"fpreset|__MINGW_NOTHROW fpreset (void);\",\n",
    "    \"__fpecode|__MINGW_NOTHROW __fpecode(void);\",\n",
    "    \"_chgsign|__MINGW_NOTHROW _chgsign (double _X);\",\n",
    "    \"_copysign|__MINGW_NOTHROW _copysign (double _Number,double _Sign);\",\n",
    "    \"_logb|__MINGW_NOTHROW _logb (double);\",\n",
    "    \"_nextafter|__MINGW_NOTHROW _nextafter (double, double);\",\n",
    "    \"_scalb|__MINGW_NOTHROW _scalb (double, long);\",\n",
    "    \"_finite|__MINGW_NOTHROW _finite (double);\",\n",
    "    \"_fpclass|__MINGW_NOTHROW _fpclass (double);\",\n",
    "    \"_isnan|__MINGW_NOTHROW _isnan (double);\",\n",
    "    \"_chgsignl|__cdecl _chgsignl (long double);\",\n",
    "    \"__pctype_func|short*  __pctype_func(void);\",\n",
    "    \"__updatetlocinfo|__cdecl __updatetlocinfo(void);\",\n",
    "    \"__updatetmbcinfo|__cdecl __updatetmbcinfo(void);\",\n",
    "    \"_isctype|__cdecl _isctype(int _C,int _Type);\",\n",
    "    \"_isctype_l|__cdecl _isctype_l(int _C,int _Type,_locale_t _Locale);\",\n",
    "    \"isalpha|__cdecl isalpha(int _C);\",\n",
    "    \"_isalpha_l|__cdecl _isalpha_l(int _C,_locale_t _Locale);\",\n",
    "    \"isupper|__cdecl isupper(int _C);\",\n",
    "    \"_isupper_l|__cdecl _isupper_l(int _C,_locale_t _Locale);\",\n",
    "    \"islower|__cdecl islower(int _C);\",\n",
    "    \"_islower_l|__cdecl _islower_l(int _C,_locale_t _Locale);\",\n",
    "    \"isdigit|__cdecl isdigit(int _C);\",\n",
    "    \"_isdigit_l|__cdecl _isdigit_l(int _C,_locale_t _Locale);\",\n",
    "    \"isxdigit|__cdecl isxdigit(int _C);\",\n",
    "    \"_isxdigit_l|__cdecl _isxdigit_l(int _C,_locale_t _Locale);\",\n",
    "    \"isspace|__cdecl isspace(int _C);\",\n",
    "    \"_isspace_l|__cdecl _isspace_l(int _C,_locale_t _Locale);\",\n",
    "    \"ispunct|__cdecl ispunct(int _C);\",\n",
    "    \"_ispunct_l|__cdecl _ispunct_l(int _C,_locale_t _Locale);\",\n",
    "    \"isalnum|__cdecl isalnum(int _C);\",\n",
    "    \"_isalnum_l|__cdecl _isalnum_l(int _C,_locale_t _Locale);\",\n",
    "    \"isprint|__cdecl isprint(int _C);\",\n",
    "    \"_isprint_l|__cdecl _isprint_l(int _C,_locale_t _Locale);\",\n",
    "    \"isgraph|__cdecl isgraph(int _C);\",\n",
    "    \"_isgraph_l|__cdecl _isgraph_l(int _C,_locale_t _Locale);\",\n",
    "    \"iscntrl|__cdecl iscntrl(int _C);\",\n",
    "    \"_iscntrl_l|__cdecl _iscntrl_l(int _C,_locale_t _Locale);\",\n",
    "    \"toupper|__cdecl toupper(int _C);\",\n",
    "    \"tolower|__cdecl tolower(int _C);\",\n",
    "    \"_tolower|__cdecl _tolower(int _C);\",\n",
    "    \"_tolower_l|__cdecl _tolower_l(int _C,_locale_t _Locale);\",\n",
    "    \"_toupper|__cdecl _toupper(int _C);\",\n",
    "    \"_toupper_l|__cdecl _toupper_l(int _C,_locale_t _Locale);\",\n",
    "    \"__isascii|__cdecl __isascii(int _C);\",\n",
    "    \"__toascii|__cdecl __toascii(int _C);\",\n",
    "    \"__iscsymf|__cdecl __iscsymf(int _C);\",\n",
    "    \"__iscsym|__cdecl __iscsym(int _C);\",\n",
    "    \"isblank|__cdecl isblank(int _C);\",\n",
    "    \"iswalpha|__cdecl iswalpha(wint_t _C);\",\n",
    "    \"_iswalpha_l|__cdecl _iswalpha_l(wint_t _C,_locale_t _Locale);\",\n",
    "    \"iswupper|__cdecl iswupper(wint_t _C);\",\n",
    "    \"_iswupper_l|__cdecl _iswupper_l(wint_t _C,_locale_t _Locale);\",\n",
    "    \"iswlower|__cdecl iswlower(wint_t _C);\",\n",
    "    \"_iswlower_l|__cdecl _iswlower_l(wint_t _C,_locale_t _Locale);\",\n",
    "    \"iswdigit|__cdecl iswdigit(wint_t _C);\",\n",
    "    \"_iswdigit_l|__cdecl _iswdigit_l(wint_t _C,_locale_t _Locale);\",\n",
    "    \"iswxdigit|__cdecl iswxdigit(wint_t _C);\",\n",
    "    \"_iswxdigit_l|__cdecl _iswxdigit_l(wint_t _C,_locale_t _Locale);\",\n",
    "    \"iswspace|__cdecl iswspace(wint_t _C);\",\n",
    "    \"_iswspace_l|__cdecl _iswspace_l(wint_t _C,_locale_t _Locale);\",\n",
    "    \"iswpunct|__cdecl iswpunct(wint_t _C);\",\n",
    "    \"_iswpunct_l|__cdecl _iswpunct_l(wint_t _C,_locale_t _Locale);\",\n",
    "    \"iswalnum|__cdecl iswalnum(wint_t _C);\",\n",
    "    \"_iswalnum_l|__cdecl _iswalnum_l(wint_t _C,_locale_t _Locale);\",\n",
    "    \"iswprint|__cdecl iswprint(wint_t _C);\",\n",
    "    \"_iswprint_l|__cdecl _iswprint_l(wint_t _C,_locale_t _Locale);\",\n",
    "    \"iswgraph|__cdecl iswgraph(wint_t _C);\",\n",
    "    \"_iswgraph_l|__cdecl _iswgraph_l(wint_t _C,_locale_t _Locale);\",\n",
    "    \"iswcntrl|__cdecl iswcntrl(wint_t _C);\",\n",
    "    \"_iswcntrl_l|__cdecl _iswcntrl_l(wint_t _C,_locale_t _Locale);\",\n",
    "    \"iswascii|__cdecl iswascii(wint_t _C);\",\n",
    "    \"isleadbyte|__cdecl isleadbyte(int _C);\",\n",
    "    \"_isleadbyte_l|__cdecl _isleadbyte_l(int _C,_locale_t _Locale);\",\n",
    "    \"towupper|__cdecl towupper(wint_t _C);\",\n",
    "    \"_towupper_l|__cdecl _towupper_l(wint_t _C,_locale_t _Locale);\",\n",
    "    \"towlower|__cdecl towlower(wint_t _C);\",\n",
    "    \"_towlower_l|__cdecl _towlower_l(wint_t _C,_locale_t _Locale);\",\n",
    "    \"iswctype|__cdecl iswctype(wint_t _C,wctype_t _Type);\",\n",
    "    \"_iswctype_l|__cdecl _iswctype_l(wint_t _C,wctype_t _Type,_locale_t _Locale);\",\n",
    "    \"__iswcsymf|__cdecl __iswcsymf(wint_t _C);\",\n",
    "    \"_iswcsymf_l|__cdecl _iswcsymf_l(wint_t _C,_locale_t _Locale);\",\n",
    "    \"__iswcsym|__cdecl __iswcsym(wint_t _C);\",\n",
    "    \"_iswcsym_l|__cdecl _iswcsym_l(wint_t _C,_locale_t _Locale);\",\n",
    "    \"is_wctype|__cdecl is_wctype(wint_t _C,wctype_t _Type);\",\n",
    "    \"iswblank|__cdecl iswblank(wint_t _C);\",\n",
    "    \"isascii|__cdecl isascii(int _C);\",\n",
    "    \"toascii|__cdecl toascii(int _C);\",\n",
    "    \"iscsymf|__cdecl iscsymf(int _C);\",\n",
    "    \"iscsym|__cdecl iscsym(int _C);\",\n",
    "    \"MessageBox|int MessageBox(HWND hWnd, LPCTSTR lpText, LPCTSTR lpCaption, UINT uType);\",\n",
    "    \"SendMessage|LRESULT SendMessage(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam);\"\n",
    "  }\n",
    "  return calltip_add\n",
    "end\n",
    "\n",
    "function user_cpp.get_reqular()\n",
    "  local symbol_reqular_exp = \"\\\\s*(?:[\\\\w+]+[_a-zA-Z0-9 ]*[ \\\\t*]+|^)([_a-zA-Z]+[~_a-zA-Z0-9:]*)\\\\s*\\\\([^\\\\(^;^=^<^>]*\\\\)[a-zA-Z\\\\s ]*\\\\{.*$\"\n",
    "  return symbol_reqular_exp\n",
    "end\n",
    "return user_cpp",
  }
  local shell_code = table.concat(cpp_code)
  eu_core.save_file(path, shell_code)
  shell_code = nil
  cpp_code = nil
end

return cpp